#!/usr/bin/perl

#   Copyright (c) 1998,1999 Adam vonNieda
#
#   You may distribute under the terms of either the GNU General Public
#   License or the Artistic License, as specified in the Perl README file,
#   with the exception that it cannot be placed on a CD-ROM or similar media
#   for commercial distribution without the prior approval of the author.

#   This software is provided without warranty of any kind. If your server
#   melts as a result of using this script, that's a bummer. But it won't.

# Turn on warnings (-w)
#$^W =1;

my ($cgidir,$repository,$bgcolor,$menucolor,$fontcolor,$nullcolor,$font,$fontsize);
my ($linkcolor,$expiration,$oraclenames,$gd);

#=================================================================================
# Begin user editable section. You may need to change some things in this section.
#=================================================================================

# Uncomment and set the (local) ORACLE_HOME environmental variable
# if neccessary. You may get messages in your web servers error log
# if this is not set.
# Win32 users may not need to set this at all.

$ENV{'ORACLE_HOME'} = "/home/oracle/product/8.0.5" 
   if (! defined($ENV{'ORACLE_HOME'}));

# Set the TNS_ADMIN variable if the directory you keep your tnsnames.ora file in
# is not the default.  Default is $ORACLE_HOME/network/admin 
# You may also want to set this if you want only a subset of
# your databases accessible from this tool. To do this,
# you would create a new tnsnames.ora file with only
# the connections you want, and put that in a non-default
# directory. Then, set this variable to point to that
# directory.
# If your installation uses the default, then you can comment this out.
#
# Win32 users: You probably already know this, but your entry should
# look something like this..
#
# $ENV{'TNS_ADMIN'} = 'C:\\ORANT\\NETWORK\\ADMIN';

$ENV{'TNS_ADMIN'} = "/home/oracle/admin/sqlnet" 
   if (! defined($ENV{'TNS_ADMIN'}));

# Set or uncomment the following variable if you are running Oracle
# Names. This will bring up an additional text entry box to enter a
# names-resolved database.

#$oraclenames = "Yep";

# The following variable is set to expire the username/password cookies
# after a certain period of time. The default is one year.
# NOTE: If you are using Internet explorer and are having problems 
# with these cookies, consider upgrading the CGI.pm module to the 
# latest release. It worked for me...

$expiration = "+1y";

# The following are all valid examples for the expiration time, and are 
# taken straight out of Lincoln Stein's CGI::Cookie man page.

# +30s                                30 seconds from now
# +10m                                ten minutes from now
# +1h                                 one hour from now
# -1d                                 yesterday (i.e. "ASAP!")
# now                                 immediately
# +3M                                 in three months
# +10y                                in ten years time
# Thursday, 25-Apr-1999 00:40:33 GMT  at the indicated time & date

# The following is a directory pathname starting from the web servers
# document root directory. For instance, on Redhat Linux the web server's 
# default document root (DocumentRoot) directory is /home/httpd/html.
# This variable will be part of the pathname that oracletoold uses as
# it's repository. This is an optional variable, and if you don't set it, 
# then historical graphs will not be displayed. For more information, see
# the oracletoold documentation. 
# NOTE: This is for future use, please leave this
# commented out for this version.

#$repository = "/oracletool/images";

# These can be changed, or you can leave them as is.

# Background color for the pages.

$bgcolor = "#A8A5BE";

# Background color for menu buttons.

$menucolor = "#B9D3EE";

# Font color.

$fontcolor = "#404040";

# Font color for warning / informational messages

$nullcolor = "#08296B";

# Color for links (LINK,ALINK,VLINK)

$linkcolor="BLUE";

# Font

$font = "";

# Font size

$fontsize = "4";

#========================================================================
# End user editable section. Do not edit below this point unless you know
# what you're doing.
#========================================================================

# Debug
#open (FOO,">>/tmp/foo");

require 5.003;

use strict;
use DBI;
use CGI qw(:standard);
use File::Basename;
use GD;

my ($VERSION,$scriptname,$query,$database,$namesdatabase,$schema);
my ($object_type,$object_name,$statement_id,$user,$whereclause);
my ($expire,$username,$password,$dbh,$sql,$oraversion,$oracle7);
my ($oracle8,$db_block_size,$title,$heading,$cursor,$banner);

$VERSION = "0.93";

Main();

#=============================================================
# Nothing but subroutines from here on.
#=============================================================

sub Main {

# Unbuffer STDOUT
   $| = 1;

# Find out the name this script was invoked as.
   $scriptname = $ENV{'SCRIPT_NAME'};

# Get the data from the elements passed in the URL.
   $query		= new CGI;
   $database		= $query->param('database');
   $namesdatabase	= $query->param('namesdatabase');
   $schema		= $query->param('schema');
   $object_type		= $query->param('object_type');
   $object_name		= $query->param('arg');
   $statement_id	= $query->param('statement_id');
   $user		= $query->param('user');
   $whereclause		= $query->param('whereclause');
   $expire		= $query->param('expire');

# If $namesdatabase is not null, then they have entered
# a names-resolved database. Change the $database value
# to the $namesdatabase value.
   $database = $namesdatabase if $namesdatabase;

# If $database is "About_oracletool" then
# show the "About" page.
   if ( $database && $database  eq "About_oracletool" ) {
      about();
   }

# Go to help if the help button was pressed
   if ( $database && $database eq "behelpful" ) {
      help($schema);
   }

# The $user variable will get passed to get session info
# for an individual user. If no individual user is passed
# then it defaults to % (All users)
   $user 		= "%" unless (defined $user);

# Get rid of the +'s on multi-word object types.
   $object_type =~ s/\+/ / if $object_type;

# If invoked standalone, show main page with database list.
   if ( ! defined $database ) {
      createMainPage();
      exit;
   }

# Add a password if no cookie is found, or if incorrect. 
   if ($object_type eq "ADDPASSWORD")     {
      $username = $query->param('username');
      $password = $query->param('password');
      addPasswd($database,$username,$password);
   }

# Attempt to get username and password cookies for connecting to the specified database. 
   ($username,$password) = split / /, GetPasswd($database);

# Make connection to the database
   $dbh = dbConnect($database,$username,$password);

# Since this sub is just generating an image, let's not
# proceed to the framepage.
   if ($object_type eq "FRAGMAP")	{fragMap();}

# If invoked the first time after selecting the database,
# start creating the frames.

   if ( $object_type eq "FRAMEPAGE" ) {
      framePage();
   }

# Find out if we are dealing with Oracle7 or Oracle8
   $sql = "
SELECT MAX(SUBSTR(RELEASE,1,1))
   FROM SYS.V_\$COMPATIBILITY
";

   $cursor = $dbh->prepare($sql);
   $cursor->execute;
   $oraversion = $cursor->fetchrow_array;
   $cursor->finish;
   if ( $oraversion eq "7" ) {
      $oracle7 = "Yep";
    } else {
      $oracle8 = "Yep";
   }

# Display the menu on the left side of the screen.
# This connects to the database as well, hence the
# $username variable. Connection is for determining 
# version, OPS etc. Certain buttons will or will not
# be display based on some queries.

   if ( $object_type eq "MENU" ) {
      showMenu($username);
   }

# Find out the database block size
   $db_block_size = getDBblocksize();

# Get the Server banner to display the version info.
   $banner = getBanner();

# Create the header for the HTML page.
# This will be used on all pages except the main page.
# $bgcolor, $fontcolor, $font, and $fontsize are set above
# in the user editable section.
 
   $title      = "Oracletool v$VERSION: Connected to $database as $username";
   $heading    = "";

   Header($title,$heading,$font,$fontsize,$fontcolor,$bgcolor);

   Director();

# Disconnect from the database

   $dbh->disconnect;

# Finish the HTML page.

   Footer();
}

sub createMainPage() {

# This sub will be called if this script is invoked without a 'database=....'
# element in the URL.  

# Get the connection strings from the tnsnames.ora file.

my @sids = GetTNS();

# Start creating main page

print << "EOF";
Content-Type: Text/html\n\n
<HTML>
  <HEAD>
    <TITLE>Oracle data dictionary browser v$VERSION</TITLE>
  </HEAD>
  <BODY BGCOLOR="$bgcolor">
    <CENTER>
    <H2> 
    <FONT COLOR="$fontcolor" FACE="$font" SIZE="$fontsize">
      Oracle data dictionary browser v$VERSION
    </FONT>
    </H2>
    </CENTER>
    <TABLE BGCOLOR="BLACK" WIDTH="300" CELLPADDING="1" CELLSPACING="0" BORDER="0">
      <TR>
        <TD VALIGN="TOP">
          <TABLE BGCOLOR="$menucolor" WIDTH="100%" CELLPADDING="2" CELLSPACING="1" BORDER="0">
            <TR ALIGN="CENTER">
              <TD>
                <TABLE>
                  <TR>
                    <TD ALIGN="LEFT">
EOF
print "                      <STRONG>Select an instance.</STRONG>\n" if (! $oraclenames);
print "                      <STRONG>Select or enter an instance name.</STRONG>\n" if ($oraclenames);
print <<"EOF";
                      <FORM METHOD="POST" ACTION="$scriptname">
                      <P>
                      <SELECT NAME="database">
EOF

my $sid;
foreach $sid (@sids) {
   print "                <OPTION VALUE=\"$sid\">$sid</OPTION>\n";
}

print <<"EOF";
                      </SELECT>
                    </TD>
EOF
   if ($oraclenames) {
      print <<"EOF";
                  </TR>
                  <TR>
                    <TD>
                      <INPUT TYPE="TEXT" NAME="namesdatabase" SIZE="20">
                    </TD>
EOF
   }
   print <<"EOF";
                  </TR>
                  <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP">
                      <INPUT TYPE="HIDDEN" NAME="object_type" VALUE="FRAMEPAGE">
                      <INPUT TYPE="SUBMIT" VALUE="Connect">
                      <INPUT TYPE="CHECKBOX" NAME="expire" VALUE="Yep">Expire password cookie
                      </P>
                      </FORM>
                      <P>
                    </TD>
                  </TR>
                </TABLE>
              </TD>
            </TR>
          </TABLE>
        </TD>
      </TR>
    </TABLE>
  </BODY>
</HTML>
EOF
}

sub dbConnect {

   my $database = shift;
   my $username = shift;
   my $password = shift;

# Attempt to make connection to the database..

   my $data_source = "dbi:Oracle:$database";
   my $dbh = DBI->connect($data_source,$username,$password);

# If it fails, act on a couple of different Oracle errors.

# Bring up the password screen for either of these errors.
# ORA-01017 - "Invalid username/password; logon denied." 
# ORA-01004 - "Default username feature not supported; logon denied."
# ORA-01005 - "null password given; logon denied."

# Show an error message for these errors.
# ORA-12224 - "The connection request could not be completed because the listener is not running."
# ORA-01034 - "Oracle was not started up."
# ORA-01090 - "Shutdown in progress - connection is not permitted""
# ORA-12154 - "The service name specified is not defined correctly in the TNSNAMES.ORA file."
# ORA-12505 - "TNS:listener could not resolve SID given in connect descriptor."
# ORA-12545 - "TNS:name lookup failure."

   unless ($dbh) {
      if ( $DBI::errstr =~ /ORA-01017|ORA-01004|ORA-01005/ ) {
         EnterPasswd($database);
         exit;
      }
      if ( $DBI::errstr =~ /ORA-12224/ ) {
         ErrorPage ("You received an ORA-12224, which usually means the listener is down, or your connection definition in your tnsnames.ora file is incorrect. Check both of these things and try again.");
         exit;
      }
      if ( $DBI::errstr =~ /ORA-01034/ ) {
         ErrorPage ("You received an ORA-01034, which usually means the database is down. Check to be sure the database is up and try again.");
         exit;
      }
      if ( $DBI::errstr =~ /ORA-01090/ ) {
         ErrorPage ("You received an ORA-01090, which means the database is in the process of coming down.");
         exit;
      }
      if ( $DBI::errstr =~ /ORA-12154/ ) {
         ErrorPage ("You received an ORA-12154, which probably means you have a mistake in your TNSNAMES.ORA file for the database that you chose.");
         exit;
      }
      if ( $DBI::errstr =~ /ORA-12505/ ) {
         ErrorPage ("You received an ORA-12505, which probably means you have a mistake in your TNSNAMES.ORA file for the database that you chose, or the database you are trying to connect to is not defined to the listener that is running on that node.");
         exit;
      }
      if ( $DBI::errstr =~ /ORA-12545/ ) {
         ErrorPage ("You received an ORA-12545, which probably means you have a mistake in your TNSNAMES.ORA file for the database that you chose. (Possibly the node name).");
         exit;
      }
      ErrorPage ("Unable to connect to Oracle ($DBI::errstr)\n");
   }
   return ($dbh);
}

sub showIndex {

   my ($sql,$text,$link,$foo,$partitioned);   

# Index structure
   $sql = "
SELECT 
   TABLE_NAME					\"Table name\",
   TABLE_OWNER					\"Owner\",
   COLUMN_NAME					\"Column name\", 
   COLUMN_LENGTH				\"Column length\" 
FROM DBA_IND_COLUMNS 
   WHERE INDEX_NAME = '$object_name' 
AND INDEX_OWNER = '$schema' 
   ORDER BY COLUMN_POSITION
";
   $object_type = lc $object_type;
   $text = "Structure of $object_type $object_name";
   $link = "";
   DisplayTable($sql,$text,$link);

# General
   $sql = "
SELECT  
   A.TABLESPACE_NAME					\"Tablespace name\", 
   TO_CHAR(B.CREATED,'Month DD, YYYY - HH24:MI')        \"Date created\",
   TO_CHAR(B.LAST_DDL_TIME,'Month DD, YYYY - HH24:MI')  \"Last DDL time\",
   TO_CHAR(A.EXTENTS,'999,999,999,999')			\"Extents\", 
   TO_CHAR(A.INITIAL_EXTENT,'999,999,999,999')		\"Initial extent\", 
   TO_CHAR(A.NEXT_EXTENT,'999,999,999,999')		\"Next extent\",
   TO_CHAR(A.MAX_EXTENTS,'999,999,999,999')		\"Max extents\",
   TO_CHAR(A.BYTES,'999,999,999,999')			\"Bytes\",
   B.STATUS						\"Status\"
FROM DBA_SEGMENTS A, DBA_OBJECTS B
   WHERE A.SEGMENT_NAME = '$object_name' 
   AND A.SEGMENT_TYPE = 'INDEX' 
   AND A.OWNER = '$schema'
   AND B.OBJECT_NAME = '$object_name'
   AND B.OBJECT_TYPE = 'INDEX'
   AND B.OWNER = '$schema'
";
   $object_type = lc $object_type;
   $text = "General info: $object_type $object_name";
   $link = "";
   DisplayTable($sql,$text,$link);

# Check to see if index is partitioned, if Oracle8

   if ($oracle8) {

      $sql = "
SELECT
   PARTITIONED
FROM DBA_INDEXES
   WHERE INDEX_NAME = '$object_name'
   AND OWNER = '$schema'
";

      $cursor=$dbh->prepare($sql);
      $cursor->execute;
      $foo = $cursor->fetchrow_array;
      $cursor->finish;
      if ($foo eq "YES") {
         $partitioned = "Yep";
      }
   }

# If partitioned, show some additional info.

   if ($partitioned) {
      $sql = "
SELECT
   PARTITION_NAME                               \"Partition name\",
   TABLESPACE_NAME                              \"Tablespace\",
   PARTITION_POSITION                           \"Position\",
   TO_CHAR(INITIAL_EXTENT,'999,999,999,999')    \"Initial\",
   TO_CHAR(NEXT_EXTENT,'999,999,999,999')       \"Next\",
   TO_CHAR(MAX_EXTENT,'999,999,999,999')        \"Max extents\",
   PCT_INCREASE                                 \"Pct increase\",
   HIGH_VALUE                                   \"High value\",
   HIGH_VALUE_LENGTH                            \"High value length\",
   LOGGING                                      \"Logging\"
FROM DBA_IND_PARTITIONS
   WHERE INDEX_NAME = '$object_name'
   AND INDEX_OWNER = '$schema'
ORDER BY PARTITION_POSITION
";

      $text = "Partitions contained in this index";
      $link = "$scriptname?database=$database&schema=$schema&object_type=INDEX+PARTITION";
      DisplayTable($sql,$text,$link);
   }
}

sub showIndexPart {

   my ($sql,$cursor,$isanalyzed,$text,$link,$nulltext);

   $sql = "
SELECT
   PARTITION_NAME                               \"Partition name\",
   INDEX_NAME                                   \"Index name\",
   INDEX_OWNER                                  \"Owner\",
   TABLESPACE_NAME                              \"Tablespace\",
   PARTITION_POSITION                           \"Position\",
   TO_CHAR(INITIAL_EXTENT,'999,999,999,999')    \"Initial\",
   TO_CHAR(NEXT_EXTENT,'999,999,999,999')       \"Next\",
   TO_CHAR(MAX_EXTENT,'999,999,999,999')        \"Max extents\",
   PCT_INCREASE                                 \"Pct increase\",
   HIGH_VALUE                                   \"High value\",
   HIGH_VALUE_LENGTH                            \"High value length\",
   LOGGING                                      \"Logging\"
FROM DBA_IND_PARTITIONS
   WHERE PARTITION_NAME = '$object_name'
   AND INDEX_OWNER = '$schema'
";

   $object_type = lc $object_type;
   $text = "General info: $object_type $object_name";
   $link = "";
   DisplayTable($sql,$text,$link);

}

sub showTablePart {

   my ($sql,$cursor,$isanalyzed,$text,$link,$nulltext);

# General info

   $sql = "
SELECT 
   PARTITION_NAME				\"Partition name\",
   TABLE_NAME					\"Table name\",
   TABLE_OWNER					\"Owner\",
   TABLESPACE_NAME				\"Tablespace\",
   PARTITION_POSITION				\"Position\",
   TO_CHAR(INITIAL_EXTENT,'999,999,999,999')	\"Initial\",
   TO_CHAR(NEXT_EXTENT,'999,999,999,999')	\"Next\",
   TO_CHAR(MAX_EXTENT,'999,999,999,999')	\"Max extents\",
   PCT_INCREASE					\"Pct increase\",
   HIGH_VALUE					\"High value\",
   HIGH_VALUE_LENGTH				\"High value length\",
   LOGGING					\"Logging\"
FROM DBA_TAB_PARTITIONS
   WHERE PARTITION_NAME = '$object_name'
   AND TABLE_OWNER = '$schema'
";

   $object_type = lc $object_type;
   $text = "General info: $object_type $object_name";
   $link = "";
   DisplayTable($sql,$text,$link);

# Check to see if partition has been analyzed.

   $sql = "
SELECT
   DISTINCT LAST_ANALYZED
FROM DBA_TAB_COLUMNS
   WHERE TABLE_NAME = '$object_name'
   AND OWNER = '$schema'
";

   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   $isanalyzed = $cursor->fetchrow_array;
   $cursor->finish;

   if ($isanalyzed) {

      $sql = "
SELECT
   TO_CHAR((BLOCKS / (EMPTY_BLOCKS+BLOCKS)) *100,'999.99')      \"Percent used\",
   TO_CHAR(NUM_ROWS,'999,999,999,999')                          \"Row count\",
   TO_CHAR(BLOCKS,'999,999,999,999')                            \"Blocks\",
   TO_CHAR(EMPTY_BLOCKS,'999,999,999,999')                      \"Empty blocks\",
   TO_CHAR(AVG_SPACE,'999,999,999,999')                         \"Average space\",
   TO_CHAR(AVG_ROW_LEN,'999,999,999,999')                       \"Average row length\",
   TO_CHAR(CHAIN_CNT,'999,999,999,999')                         \"Chain count\",
   TO_CHAR(LAST_ANALYZED,'Month DD, YYYY')			\"Last analyzed\"
FROM DBA_TAB_PARTITIONS
   WHERE PARTITION_NAME = '$object_name'
   AND OWNER = '$schema'
";

      $text = "Analyzation info: $object_type $object_name";
      $link = "";
      DisplayTable($sql,$text,$link);
   } else {
      message("Partition has never been analyzed. Extended info will not be shown.");
   }

}

sub showTable() {

   my ($sql,$text,$link,$nulltext,$cursor,$isanalyzed,$partitioned,$foo);


print <<"EOF";
<TABLE BORDER CELLPADDING=5>
<TR>
<TD>
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
  <TR>
    <TD ALIGN=CENTER>
      <FORM METHOD="GET" ACTION="$scriptname">
        <INPUT TYPE="HIDDEN" NAME="database" VALUE="$database">
        <INPUT TYPE="HIDDEN" NAME="object_type" VALUE="TABLEROWS">
        <INPUT TYPE="HIDDEN" NAME="schema" VALUE="$schema">
        <INPUT TYPE="HIDDEN" NAME="arg" VALUE="$object_name">
        <INPUT TYPE="SUBMIT" NAME="tablerows" VALUE="Display 25 rows of this table">
    </TD>
  </TR>
  <TR>
    <TD ALIGN=CENTER><B><I>where</I></B></TD>
  </TR>
  <TR>
    <TD ALIGN=CENTER>
        <INPUT TYPE="TEXT" SIZE=30 NAME="whereclause">
    </TD> 
      </FORM>
  </TR>
</TABLE>
</TD>
</TR>
</TABLE>
EOF

showGrantButton();

# Table structure

   $sql = "
SELECT 
   COLUMN_NAME					\"Column name\", 
   DATA_TYPE					\"Type\", 
   DATA_LENGTH					\"Length\", 
   DATA_PRECISION				\"Precision\", 
   DATA_DEFAULT					\"Default\", 
   TO_CHAR(LAST_ANALYZED,'Month DD, YYYY')				\"Last analyzed\"
FROM DBA_TAB_COLUMNS 
   WHERE TABLE_NAME = '$object_name' 
AND OWNER = '$schema' 
   ORDER BY COLUMN_ID
";
   $object_type = lc $object_type;
   $text = "Structure of $object_type $object_name";
   $link = "";
   DisplayTable($sql,$text,$link);

# Check to see if table has been analyzed.

   $sql = "
SELECT 
   DISTINCT LAST_ANALYZED
FROM DBA_TAB_COLUMNS
   WHERE TABLE_NAME = '$object_name'
   AND OWNER = '$schema'
";

   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   $isanalyzed = $cursor->fetchrow_array;
   $cursor->finish;

# If the table has been analyzed, show some additional information

   if ($isanalyzed) {

      $sql = "
SELECT 
   TO_CHAR((BLOCKS / (EMPTY_BLOCKS+BLOCKS)) *100,'999.99')	\"Percent used\",
   TO_CHAR(NUM_ROWS,'999,999,999,999')				\"Row count\",
   TO_CHAR(BLOCKS,'999,999,999,999')				\"Blocks\",
   TO_CHAR(EMPTY_BLOCKS,'999,999,999,999')			\"Empty blocks\",
   TO_CHAR(AVG_SPACE,'999,999,999,999')				\"Average space\",
   TO_CHAR(AVG_ROW_LEN,'999,999,999,999')			\"Average row length\",
   TO_CHAR(CHAIN_CNT,'999,999,999,999')				\"Chain count\"
FROM DBA_TABLES 
   WHERE TABLE_NAME = '$object_name'
   AND OWNER = '$schema'
";

      $text = "Analyzation info: $object_type $object_name";
      $link = "";
      DisplayTable($sql,$text,$link);
   } else {
      message("Table has never been analyzed. Extended info will not be shown.");
   }

# General info

   $sql = "
SELECT 
   A.TABLESPACE_NAME					\"Tablespace\", 
   TO_CHAR(B.CREATED,'Month DD, YYYY - HH24:MI')	\"Date created\",
   TO_CHAR(B.LAST_DDL_TIME,'Month DD, YYYY - HH24:MI')	\"Last DDL time\",
   TO_CHAR(A.EXTENTS,'999,999,999,999')			\"Extents\", 
   TO_CHAR(A.INITIAL_EXTENT,'999,999,999,999')		\"Initial extent\", 
   TO_CHAR(A.NEXT_EXTENT,'999,999,999,999')		\"Next extent\", 
   TO_CHAR(A.MAX_EXTENTS,'999,999,999,999')		\"Max extents\",
   TO_CHAR(A.BYTES,'999,999,999,999')			\"Bytes\"
FROM DBA_SEGMENTS A, DBA_OBJECTS B
   WHERE A.SEGMENT_NAME = '$object_name' 
   AND A.SEGMENT_TYPE = 'TABLE' 
   AND A.OWNER = '$schema'
   AND B.OBJECT_NAME = '$object_name'
   AND B.OBJECT_TYPE = 'TABLE'
   AND B.OWNER = '$schema'
";
   $object_type = lc $object_type;
   $text = "General info: $object_type $object_name";
   $link = "$scriptname?database=$database&object_type=TSINFO";
   DisplayTable($sql,$text,$link);

# Check to see if table is partitioned, if Oracle8

   if ($oracle8) {
      
      $sql = "
SELECT
   PARTITIONED
FROM DBA_TABLES
   WHERE TABLE_NAME = '$object_name'
   AND OWNER = '$schema'
";

      $cursor=$dbh->prepare($sql);
      $cursor->execute;
      $foo = $cursor->fetchrow_array;
      $cursor->finish;
      if ($foo eq "YES") {
         $partitioned = "Yep";
      }
   }

# If partitioned, show some additional info.

   if ($partitioned) {
      $sql = "
SELECT
   PARTITION_NAME                               \"Partition name\",
   TABLESPACE_NAME                              \"Tablespace\",
   PARTITION_POSITION                           \"Position\",
   TO_CHAR(INITIAL_EXTENT,'999,999,999,999')    \"Initial\",
   TO_CHAR(NEXT_EXTENT,'999,999,999,999')       \"Next\",
   TO_CHAR(MAX_EXTENT,'999,999,999,999')        \"Max extents\",
   PCT_INCREASE                                 \"Pct increase\",
   HIGH_VALUE                                   \"High value\",
   HIGH_VALUE_LENGTH                            \"High value length\",
   LOGGING                                      \"Logging\"
FROM DBA_TAB_PARTITIONS
   WHERE TABLE_NAME = '$object_name'
   AND TABLE_OWNER = '$schema'
ORDER BY PARTITION_POSITION
";

      $text = "Partitions contained in this table";
      $link = "$scriptname?database=$database&schema=$schema&object_type=TABLE+PARTITION";
      DisplayTable($sql,$text,$link);
   }

# Show primary key (if)

   $sql = "
SELECT 
   CONSTRAINT_NAME				\"Constraint name\",
   STATUS					\"Status\"
FROM DBA_CONSTRAINTS 
   WHERE  CONSTRAINT_TYPE = 'P' 
AND TABLE_NAME = '$object_name' 
AND OWNER = '$schema'
";
   $text = "Primary key: $object_type $object_name";
   $link = "$scriptname?database=$database&schema=$schema&object_type=INDEX";
   $nulltext = "This table has no primary key.";
   DisplayTable($sql,$text,$link,$nulltext);

# Indexes that are not constraints

   $sql = "
SELECT INDEX_NAME
   FROM DBA_INDEXES
WHERE TABLE_NAME = '$object_name'
   AND OWNER = '$schema'
   AND INDEX_NAME NOT IN
   (
SELECT CONSTRAINT_NAME
   FROM DBA_CONSTRAINTS
WHERE TABLE_NAME = '$object_name'
   AND OWNER = '$schema'
   )
";
   $text = "Indexes which are not constraints: $object_type $object_name";
   $link = "$scriptname?database=$database&schema=$schema&object_type=INDEX";
   $nulltext = "This table has no (Non primary key) indexes.";
   DisplayTable($sql,$text,$link,$nulltext);

# Show column constraints (if)

   $sql = "
SELECT 
   CONSTRAINT_NAME				\"Constraint name\", 
DECODE
(
   CONSTRAINT_TYPE,
      'R','FK REFERENCE (R)',
      'C','CHECK (C)',
      'U','UNIQUE (U)',
      'V','CHECK OPTION (V)'
)						\"Constraint type\",
   SEARCH_CONDITION				\"Search condition\", 
   STATUS					\"Status\" 
FROM DBA_CONSTRAINTS 
   WHERE CONSTRAINT_TYPE NOT IN ('P','R')
AND TABLE_NAME = '$object_name' 
AND OWNER = '$schema'
   ORDER BY TABLE_NAME, CONSTRAINT_NAME
";
   $text = "Constraints: $object_type $object_name";
   $link = "";
   $nulltext = "This table has no column constraints.";
   DisplayTable($sql,$text,$link,$nulltext);

# Show foreign key constraints (if)

   $sql = "
SELECT
   CONSTRAINT_NAME                             \"Constraint name\",
   COLUMN_NAME                                 \"Column name\"
FROM DBA_CONS_COLUMNS
   WHERE OWNER = '$schema'
   AND CONSTRAINT_NAME IN
(SELECT
   CONSTRAINT_NAME
FROM DBA_CONSTRAINTS
   WHERE CONSTRAINT_TYPE = 'R'
   AND OWNER = '$schema'
   AND TABLE_NAME = '$object_name')
";
   $text = "Foreign key constraints: $object_type $object_name";
   $link = "$scriptname?database=$database&schema=$schema&object_type=CONSTRAINT";
   $nulltext = "This table has no foreign key constraints.";
   DisplayTable($sql,$text,$link,$nulltext);

# Foreign keys referencing this table (if)

   $sql = "
SELECT
   CONSTRAINT_NAME				\"Child constraint name\",
   TABLE_NAME					\"Child table name\",
   OWNER					\"Owner\",
   R_CONSTRAINT_NAME				\"Local constraint name\"
FROM DBA_CONSTRAINTS
   WHERE R_OWNER = '$schema'
   AND R_CONSTRAINT_NAME IN 
   ( SELECT
        CONSTRAINT_NAME
     FROM DBA_CONSTRAINTS
        WHERE TABLE_NAME = '$object_name'
        AND OWNER = '$schema')
";

   $text = "Foreign key constraints referencing $object_name";
   $link = "";
   $nulltext = "There are no foreign key constraints referencing this table.";
   DisplayTable($sql,$text,$link,$nulltext);

   $sql = "
SELECT 
   TRIGGER_NAME			\"Trigger name\",
   TRIGGERING_EVENT		\"Event\",
   WHEN_CLAUSE			\"When clause\"
FROM DBA_TRIGGERS
   WHERE TABLE_NAME = '$object_name'
   AND OWNER = '$schema'
";
   $text = "Triggers";
   $link = "$scriptname?database=$database&schema=$schema&object_type=TRIGGER";
   $nulltext = "This table has no triggers.";
   DisplayTable($sql,$text,$link,$nulltext);

}

sub Describe {

   my ($sql,$moresql,$text,$link,$nulltext); 

   my $object_name = shift;

# Get owner if one is specified

   $_ = uc($object_name);
   if (/\./) {
      ($schema, $object_name) = split /\./;
      $moresql = "AND OWNER = UPPER('$schema')";
   }
   $object_name = uc($object_name);

#   $sql = "
#SELECT 
#   DTC.COLUMN_NAME			\"Column name\",
#   DECODE(
#      DTC.NULLABLE,
#         'N','Not Null',
#         'Y',''
#   )					\"Null?\",
#   DTC.DATA_TYPE			\"Type\",
#   DTC.DATA_LENGTH			\"Data length\",
#   DTC.DATA_PRECISION			\"Precision\",
#   DCC.COMMENTS				\"Comments\"
#FROM 
#   DBA_TAB_COLUMNS DTC, 
#   DBA_COL_COMMENTS DCC
#WHERE DTC.TABLE_NAME = '$object_name'
#   AND DTC.OWNER = '$schema'
#   AND DCC.TABLE_NAME = '$object_name'
#   AND DCC.OWNER = '$schema'
#GROUP BY 
#  DTC.COLUMN_NAME, 
#  DTC.DATA_TYPE,
#  DTC.NULLABLE,
#  DTC.DATA_LENGTH,
#  DTC.DATA_PRECISION,
#  DCC.COMMENTS, 
#  DTC.COLUMN_ID
#ORDER BY DTC.COLUMN_ID
#";

   $sql = "
SELECT 
   COLUMN_NAME			\"Column name\",
   DECODE(
      NULLABLE,
         'N','Not Null',
         'Y',''
   )				\"Null?\",
   DATA_TYPE			\"Type\",
   DATA_LENGTH			\"Data length\",
   DATA_PRECISION		\"Precision\"
FROM 
   DBA_TAB_COLUMNS
WHERE TABLE_NAME = '$object_name'
   $moresql
ORDER BY COLUMN_ID
";

   $text = "Description of $object_name";
   $link = "";
   $nulltext = "Object to be described does not exist";
   my $err = DisplayTable($sql,$text,$link,$nulltext);

   print "<BR><HR WIDTH=\"10%\"><BR>\n";
}

sub objectSearch {

   my ($sql,$text,$link,$nulltext,$moresql);

# Search for an object in the entire database

# Check for a null value

   if ($object_name eq "") {
      message("You must enter an object name!\n");
      Footer();
      exit;
   }

# Get owner if one is specified

   $_ = $object_name;
   if (/\./) {
      ($schema, $object_name) = split /\./;
      $moresql = "AND OWNER = UPPER('$schema')";
   }

    $sql = "
SELECT
   OBJECT_NAME                  \"Object name\",
   OBJECT_TYPE                  \"Object type\",
   OWNER                        \"Owner\"
FROM DBA_OBJECTS
   WHERE OBJECT_NAME LIKE UPPER('\%$object_name\%')
   $moresql
";

   $text = "The following objects were found";
   $link = "";
   $nulltext = "No objects like that name were found";
   ObjectTable($sql,$text,$nulltext);

# If $object_name is a number, search by object_id as well.

   $_ = $object_name;
   if ( ! /\D/ ) {

      $sql = "
SELECT
   OBJECT_NAME                  \"Object name\",
   OBJECT_TYPE                  \"Object type\",
   OWNER                        \"Owner\"
FROM DBA_OBJECTS
   WHERE OBJECT_ID = '$object_name'
";

      $text = "The following object was found with object_id $object_name";
      $link = "";
      $nulltext = "No objects were found with object_id $object_name";
      ObjectTable($sql,$text,$nulltext);
   }

   $sql = "
SELECT 
   A.USERNAME		\"User accessing\",
   A.OSUSER		\"OS Username\",
   A.PROCESS		\"Process ID\", 
   A.PROGRAM		\"Program\", 
   B.SID		\"SID\",
   A.SERIAL#		\"Serial#\",
   B.OBJECT		\"Object name\",
   B.OWNER		\"Owner\",
   B.TYPE		\"Object type\"
FROM V\$SESSION A, V\$ACCESS B
   WHERE B.OBJECT IN
(SELECT OBJECT_NAME 
   FROM DBA_OBJECTS
WHERE OBJECT_NAME LIKE UPPER('\%$object_name\%') $moresql
  AND A.SID = B.SID AND A.STATUS = 'ACTIVE')
";

   $text = "Objects currently being accessed that match your search";
   $link = "";
   $nulltext = "No objects that match your search are currently being accessed";
   DisplayTable($sql,$text,$link,$nulltext);
}

sub showConstraint {

   my ($sql,$text,$link);

# Constraint info

   $sql = "
SELECT * FROM
   (SELECT
      TABLE_NAME				\"Table_name\",
      CONSTRAINT_NAME				\"Constraint name\"
    FROM DBA_CONSTRAINTS
       WHERE OWNER = '$schema'
       AND CONSTRAINT_NAME = '$object_name'),
   (SELECT 
       TABLE_NAME				\"Parent table\",
       CONSTRAINT_NAME				\"Parent constraint\",
       OWNER					\"Parent owner\"
    FROM DBA_CONSTRAINTS
       WHERE CONSTRAINT_NAME = 
    (SELECT R_CONSTRAINT_NAME 
        FROM DBA_CONSTRAINTS
     WHERE CONSTRAINT_NAME = '$object_name'
        AND OWNER = '$schema'))
";

   $text = "General info: Constraint $object_name";
   $link = "";
   DisplayTable($sql,$text,$link);
}

sub showView() {

   my ($sql,$text,$link);

print <<"EOF";
<TABLE BORDER CELLPADDING=5>
<TR>
<TD>
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
  <TR>
    <TD ALIGN=CENTER>
      <FORM METHOD="GET" ACTION="$scriptname">
        <INPUT TYPE="HIDDEN" NAME="database" VALUE="$database">
        <INPUT TYPE="HIDDEN" NAME="object_type" VALUE="TABLEROWS">
        <INPUT TYPE="HIDDEN" NAME="schema" VALUE="$schema">
        <INPUT TYPE="HIDDEN" NAME="arg" VALUE="$object_name">
        <INPUT TYPE="SUBMIT" NAME="tablerows" VALUE="Display 25 rows of this view">
    </TD>
  </TR>
  <TR>
    <TD ALIGN=CENTER><B><I>where</I></B></TD>
  </TR>
  <TR>
    <TD ALIGN=CENTER>
        <INPUT TYPE="TEXT" SIZE=30 NAME="whereclause">
    </TD>
      </FORM>
  </TR>
</TABLE>
</TD>
</TR>
</TABLE>
EOF

showGrantButton();

# View structure

   $sql = "
SELECT 
   COLUMN_NAME					\"Column name\", 
   DATA_TYPE					\"Type\", 
   DATA_LENGTH					\"Length\" 
FROM DBA_TAB_COLUMNS 
   WHERE TABLE_NAME = '$object_name' 
   AND OWNER = '$schema' 
ORDER BY COLUMN_ID
";
   $object_type = lc $object_type;
   $text = "Structure of $object_type $object_name";
   $link = "";
   DisplayTable($sql,$text,$link);

# View source

   $sql = "
SELECT 
   TEXT						\"Text\"	
FROM DBA_VIEWS 
   WHERE VIEW_NAME = '$object_name' 
   AND OWNER = '$schema'";
   $text = "Text: $object_type $object_name";
   DisplayLongData($sql,$text);
}

sub showTrigger {

   my ($sql,$text,$link);

# General info

$sql = "
SELECT 
   TRIGGER_NAME					\"Trigger name\",
   TRIGGER_TYPE					\"Trigger type\",
   TRIGGERING_EVENT				\"Triggering event\",
   REFERENCING_NAMES				\"Referencing names\",
   WHEN_CLAUSE					\"When clause\",
   STATUS					\"Status\"
FROM DBA_TRIGGERS
   WHERE TRIGGER_NAME = '$object_name'
   AND OWNER = '$schema'
";

   $text = "Trigger: $object_name";
   DisplayTable($sql,$text,$link);

# Source

$sql = "
SELECT
    TRIGGER_BODY				\"Trigger body\"
FROM DBA_TRIGGERS
   WHERE TRIGGER_NAME = '$object_name'
AND OWNER = '$schema'
";

   $text = "Trigger body";
   DisplayLongData($sql,$text);
}

sub showDBlink() {

   my ($sql,$text,$link);

# General info

   $sql = "
SELECT 
   DB_LINK					\"Link name\", 
   USERNAME					\"Username\", 
   HOST						\"Host\", 
   CREATED					\"Created\" 
FROM DBA_DB_LINKS 
   WHERE DB_LINK = '$object_name' 
   AND OWNER = '$schema'"
;
   $text = "Database link: $object_name";
   $link = "";
   DisplayTable($sql,$text,$link);
}

sub showSource() {

   my ($sql,$text,$link);

   showGrantButton();

# General info

   $sql = "
SELECT
   TO_CHAR(CREATED,'Month DD, YYYY - HH24:MI')          \"Date created\",
   TO_CHAR(LAST_DDL_TIME,'Month DD, YYYY - HH24:MI')    \"Last compiled\",
   STATUS                                             \"Status\"
FROM DBA_OBJECTS
   WHERE OBJECT_NAME = '$object_name'
   AND OBJECT_TYPE = '$object_type'
   AND OWNER = '$schema'
";

   $text = "General info: $object_type $object_name";
   DisplayTable($sql,$text);


# Source of object (package, procedure, etc.)

   $sql = "
SELECT 
   TEXT						\"Text\"	
FROM 
   DBA_SOURCE 
WHERE TYPE = '$object_type' 
   AND OWNER = '$schema' 
   AND NAME = '$object_name' 
ORDER BY LINE
";
   $text = "Text: $object_type $object_name";
   $link = "";
   DisplayPiecedData($sql,$text,$link);
}

sub showSequence() {

   my ($sql,$text,$link);

   showGrantButton();

# General info

   $sql = "
SELECT 
   MIN_VALUE					\"Min value\", 
   MAX_VALUE					\"Max value\", 
   INCREMENT_BY					\"Increment by\", 
   CYCLE_FLAG					\"Cycle flag\", 
   ORDER_FLAG					\"Order flag\", 
   CACHE_SIZE					\"Cache size\", 
   LAST_NUMBER					\"Last number\" 
FROM DBA_SEQUENCES 
   WHERE SEQUENCE_NAME = '$object_name' 
   AND SEQUENCE_OWNER = '$schema'
";
   $text = "$object_type $object_name";
   $link = "";
   DisplayTable($sql,$text,$link);
}

sub showGrantsto() {

   my ($sql,$text,$link,$nulltext);

# System privileges

   $sql = "
SELECT 
   PRIVILEGE					\"Privilege\", 
   ADMIN_OPTION					\"Admin option\"
FROM DBA_SYS_PRIVS 
   WHERE GRANTEE = '$schema'
";
   $text = "System privileges granted to $schema";
   $link = "";
   $nulltext = "There are no system privileges granted to $schema.";
   DisplayTable($sql,$text,$link,$nulltext);

# Granted roles

   $sql = "
SELECT 
   GRANTED_ROLE					\"Granted role\", 
   ADMIN_OPTION					\"Admin option\", 
   DEFAULT_ROLE					\"Default role\" 
FROM DBA_ROLE_PRIVS 
   WHERE GRANTEE = '$schema'
";
   $text = "Roles granted to $schema";
   $link = "$scriptname?database=$database&schema=$schema&object_type=ROLES";
   $nulltext = "There are no roles granted to $schema.";
   DisplayTable($sql,$text,$link,$nulltext);

# Granted object privileges (explicit)

   $sql = "
SELECT 
   PRIVILEGE					\"Privilege\", 
   TABLE_NAME					\"Table name\", 
   GRANTOR					\"Grantor\", 
   GRANTABLE					\"Grantable\" 
FROM DBA_TAB_PRIVS 
   WHERE GRANTEE = '$schema' 
ORDER BY GRANTOR, TABLE_NAME
";
   $text = "Explicit grants to $schema";
   $link = "";
   $nulltext = "There are no explicit grants to $schema.";
   DisplayTable($sql,$text,$link,$nulltext);
}

sub showRoles {

   my ($sql,$text,$link,$nulltext);

# Roles granted to this role

   $sql = "
SELECT 
   GRANTED_ROLE					\"Granted role\", 
   ADMIN_OPTION					\"Admin option\", 
   DEFAULT_ROLE					\"Default role\" 
FROM DBA_ROLE_PRIVS 
   WHERE GRANTEE = '$object_name'
";
   $text = "Roles granted to role $object_name"; 
   $link = "$scriptname?database=$database&schema=$schema&object_type=ROLES"; 
   $nulltext = "There are no roles granted to this role.";
   DisplayTable($sql,$text,$link,$nulltext);

# System privileges granted to this role

   $sql = "
SELECT 
   PRIVILEGE					\"Privilege\", 
   ADMIN_OPTION					\"Admin option\" 
FROM DBA_SYS_PRIVS 
   WHERE GRANTEE = '$object_name' 
ORDER BY PRIVILEGE
";
   $text = "System privileges granted to role $object_name";
   $link = "";
   $nulltext = "There are no system privileges granted to this role.";
   DisplayTable($sql,$text,$link,$nulltext);

# Object privileges granted to this role

   $sql = "
SELECT 
   PRIVILEGE, 
   TABLE_NAME, 
   GRANTOR, 
   GRANTABLE 
FROM DBA_TAB_PRIVS 
   WHERE GRANTEE = '$object_name' 
ORDER BY GRANTOR, TABLE_NAME
";
   $text = "Object privileges granted to role $object_name";
   $link = "";
   $nulltext = "There are no object privileges granted to this role.";
   DisplayTable($sql,$text,$link,$nulltext);
}

sub showGrantsfrom {

   my ($sql,$text,$link,$nulltext);
 
# Object privileges granted from this user

   $sql = "
SELECT 
   GRANTEE, 
   PRIVILEGE, 
   TABLE_NAME, 
   GRANTABLE 
FROM DBA_TAB_PRIVS 
   WHERE GRANTOR = '$schema' 
ORDER BY GRANTEE, TABLE_NAME
";
   $text = "Object privileges granted from user $schema";
   $link = "";
   $nulltext = "$schema has not granted any privileges to other users. $schema is a stingy user.";
   DisplayTable($sql,$text,$link,$nulltext);
}

sub OPSpage {

   my ($sql,$text,$link,$nulltext);

# Local instance info

   $sql = "
SELECT 
   INSTANCE_NAME						\"Instance name\",
   INSTANCE_NUMBER						\"Instance #\",
   THREAD#							\"Thread\",
   HOST_NAME							\"Hostname\",
   TO_CHAR(STARTUP_TIME,'Day, Month DD YYYY - HH24:MI:SS')	\"Startup time\"
FROM V\$INSTANCE
";

   $text = "Info about this instance.";
   $link = "";
   $nulltext = "";
   DisplayTable($sql,$text,$link,$nulltext);

# All instance info

   $sql = "
SELECT INSTANCE_NAME						\"Instance name\",
   INSTANCE_NUMBER						\"Instance #\",
   THREAD#							\"Thread\",
   HOST_NAME							\"Hostname\",
   TO_CHAR(STARTUP_TIME,'Day, Month DD YYYY - HH24:MI:SS')	\"Startup time\"
FROM GV\$INSTANCE
   ORDER BY INSTANCE_NAME
";

   $text = "Info about all instances.";
   $link = "";
   $nulltext = "";
   DisplayTable($sql,$text,$link,$nulltext);

# Lock (IDLM) information

   $sql = "
SELECT
   A.INSTANCE_NAME			\"Instance Name\",
   B.FROM_VAL				\"From\",
   B.TO_VAL				\"To\",
   B.ACTION_VAL				\"Action\",
   TO_CHAR(B.COUNTER,'999,999,999,999')	\"Counter\"
FROM GV\$INSTANCE A, GV\$LOCK_ACTIVITY B
   WHERE B.INST_ID = A.INST_ID
   ORDER BY A.INSTANCE_NAME, B.COUNTER DESC
";

   $text = "Lock conversions by instance.";
   $link = "";
   $nulltext = "No lock conversions";
   DisplayTable($sql,$text,$link,$nulltext);
}
   
sub showUsers {

   my ($sql,$user,@dbausers,@connectedusers,$dba,$connected,$text,$cursor,$counter,$row,$usercount);

   my $highlight = "#FFFFC6";

# Display buttons for general database information

print <<"EOF";
Connected to database : $database<BR>
$banner
<P>
EOF

# Get all users who have the DBA role granted to them

   $sql = "
SELECT GRANTEE 
   FROM DBA_ROLE_PRIVS
WHERE GRANTED_ROLE='DBA'
";


   $cursor = $dbh->prepare($sql) or ErrorPage ("$DBI::errstr");
   $cursor->execute or ErrorPage ("$DBI::errstr");

   while ($user = $cursor->fetchrow_array) { 
      push (@dbausers,$user);
   }

   $cursor->finish;

# Get all users that are currently connected.

   $sql = "
SELECT DISTINCT USERNAME
   FROM V\$SESSION
";

   $cursor = $dbh->prepare($sql) or ErrorPage ("$DBI::errstr");
   $cursor->execute or ErrorPage ("$DBI::errstr");

   while ($user = $cursor->fetchrow_array) {
      push (@connectedusers,$user);
   }

   $cursor->finish;

# Displsy a count of all users.

   $sql = "
SELECT COUNT(*)
   FROM DBA_USERS
";

   $cursor = $dbh->prepare($sql) or ErrorPage ("$DBI::errstr");
   $cursor->execute or ErrorPage ("$DBI::errstr");
   $usercount = $cursor->fetchrow_array;
   $cursor->finish;

# Get all usernames

   $sql = "
SELECT 
   USERNAME 
FROM DBA_USERS 
   ORDER BY USERNAME
";
   $text = "Select a schema by clicking on it.<BR>Highlighted background indicates user is connected.<BR>Bold text in parenthesis indicates DBA authority.";
   $cursor = $dbh->prepare($sql) or ErrorPage ("$DBI::errstr");
   $cursor->execute or ErrorPage ("$DBI::errstr");
   $counter=0;
   print "<B>$text</B><P>\n";
   print "<B>Total # users: $usercount</B>\n";
   print "<TABLE BORDER=1>\n";

   while ($row = $cursor->fetchrow_array) {
      undef $dba;
      foreach $user (@dbausers) {
         if ( $row eq $user ) {
            $dba = "yes";
            last;
         }
      }
      undef $connected;
      foreach $user (@connectedusers) {
         if ( $row eq $user ) {
            $connected = "yes";
            last;
         }
      }
      print "<TR ALIGN=CENTER>" if $counter == 0;
      if (($connected) && ($dba)) {
         print "<TD BGCOLOR=\"$highlight\"><STRONG><A href=$scriptname?database=$database&schema=$row&object_type=USERINFO>(${row})</A></STRONG></TD>\n";
      } elsif ($connected) {
         print "<TD BGCOLOR=\"$highlight\"><A href=$scriptname?database=$database&schema=$row&object_type=USERINFO>$row</A></TD>\n";
      } elsif ($dba) {
         print "<TD><STRONG><A href=$scriptname?database=$database&schema=$row&object_type=USERINFO>(${row})</A></STRONG></TD>\n";
      } else {
         print "<TD><A href=$scriptname?database=$database&schema=$row&object_type=USERINFO>$row</A></TD>\n";
      }
         
      $counter++;
      print "</TR>" if $counter == 0;
      if ($counter == 5) { $counter = 0 };
   }
   print "</TABLE>\n\n";

   $cursor->finish or ErrorPage ("$DBI::errstr");
} 

sub showAuditing {

   my ($sql,$text,$link,$nulltext);

   $sql = "
SELECT 
   USER_NAME		\"Username\",
   PRIVILEGE		\"Privilege\",
   SUCCESS		\"Success\",
   FAILURE		\"Failure\"
FROM DBA_PRIV_AUDIT_OPTS
   ORDER BY USER_NAME
";

   $text        = "System privileges which are being audited.";
   $link        = "$scriptname?database=$database&object_type=ROLES";
   $nulltext    = "No system privileges are being audited.";

   DisplayTable($sql,$text,$link,$nulltext); 

   $sql = "
SELECT 
   USER_NAME		\"Username\",
   AUDIT_OPTION		\"Audit option\",
   SUCCESS		\"Success\",
   FAILURE		\"Failure\"
FROM DBA_STMT_AUDIT_OPTS
   ORDER BY USER_NAME
";

   $text        = "System auditing options.";
   $link        = "$scriptname?database=$database&object_type=ROLES";
   $nulltext    = "No system auditing options are set.";

   DisplayTable($sql,$text,$link,$nulltext); 

#   $sql = "
#SELECT 
#   OWNER		\"Owner\",
#   OBJECT_NAME		\"Object name\",
#   OBJECT_TYPE		\"Object type\",
#   ALT			\"Alter\",
#   AUD			\"Audit\",
#   COM			\"Comment\",
#   DEL			\"Delete\",
#   GRA			\"Grant\",
#   IND			\"Index\",
#   INS			\"Insert\",
#   LOC			\"Lock\",
#   REN			\"Rename\",
#   SEL			\"Select\",
#   UPD			\"Update\",
#   EXE			\"Execute\",
#   CRE			\"Create\",
#   REA			\"Read\",
#   WRI			\"Write\"
#FROM DBA_OBJ_AUDIT_OPTS
#   ORDER BY OWNER
#";
#
#   $text        = "Auditing options pertaining to individual objects.";
#   $link        = "$scriptname?database=$database&object_type=ROLES";
#   $nulltext    = "No object level auditing is taking place.";
#
#   DisplayTable($sql,$text,$link,$nulltext); 

}


sub showSecurity {

   my ($sql,$cursor,$value,$text,$link,$nulltext,$cols);

   $sql = "
SELECT 
   VALUE FROM V\$PARAMETER
WHERE NAME = 'audit_trail'
";

   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   $value = $cursor->fetchrow_array;

   if ( $value eq "TRUE" ) { 

      print <<"EOF";
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
  <TR>
    <TD ALIGMN=CENTER>
      <FORM METHOD="GET" ACTION="$scriptname">
        <INPUT TYPE="HIDDEN" NAME="database" VALUE="$database">
        <INPUT TYPE="HIDDEN" NAME="object_type" VALUE="AUDITING">
        <INPUT TYPE="SUBMIT" NAME="auditing" VALUE="Auditing information">
      </FORM>
    </TD>
  </TR>
</TABLE>
EOF
    } else {
      message("Database auditing is not enabled.");
   } 

   $sql = "
SELECT 
   ROLE
FROM DBA_ROLES
   ORDER BY ROLE
";

   $text        = "All roles for this database";
   $link	= "$scriptname?database=$database&object_type=ROLES";
   $nulltext    = "There are no roles in this database";
   $cols	= "3";

   DisplayColTable($sql,$text,$link,$nulltext,$cols); 

   $sql = "
SELECT DISTINCT
   PROFILE
FROM DBA_PROFILES
   ORDER BY PROFILE
";

   $text        = "All profiles for this database";
   $link	= "$scriptname?database=$database&object_type=PROFILE";
   $nulltext    = "There are no profiles in this database";
   $cols	= "5";

   DisplayColTable($sql,$text,$link,$nulltext,$cols); 

   $sql = "
SELECT GRANTEE
   FROM DBA_ROLE_PRIVS
WHERE GRANTED_ROLE='DBA'
   AND GRANTEE IN
(SELECT USERNAME 
   FROM DBA_USERS)
"; 

   $text        = "All users with the \"DBA\" role granted to them";
   $link	= "$scriptname?database=$database&object_type=USERINFO";
   $nulltext    = "There are no users with the \"DBA\" role in this database";
   $cols	= "5";

   DisplayColTable($sql,$text,$link,$nulltext,$cols); 

}

sub showProfile {

   my ($sql,$text,$link,$nulltext);

   $sql = "
SELECT
   RESOURCE_NAME        \"Resource name\",
   LIMIT                \"Limit\"
FROM DBA_PROFILES
   WHERE PROFILE = '$object_name'
ORDER BY RESOURCE_NAME
" if ($oracle7);

   $sql = "
SELECT 
   RESOURCE_NAME	\"Resource name\",
   RESOURCE_TYPE	\"Resource type\",
   LIMIT		\"Limit\"
FROM DBA_PROFILES
   WHERE PROFILE = '$object_name'
ORDER BY RESOURCE_NAME
" if ($oracle8);

   $text	= "Profile $object_name";
   $link	= "";
   $nulltext	= "";

   DisplayTable($sql,$text,$link,$nulltext); 
}

sub userInfo {

   # User info
   # Get the data from the database

   my ($sql,$cursor,$count,$text,$link,$nulltext);
   my ($uname,$defts,$tmpts,$created,$profile);

# General user info

   $sql = "
SELECT 
   USERNAME,
   DEFAULT_TABLESPACE,
   TEMPORARY_TABLESPACE,
   TO_CHAR(CREATED,'Month DD, YYYY - HH24:MI'),
   PROFILE
FROM DBA_USERS 
   WHERE USERNAME = '$schema'
";

   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   ($uname,$defts,$tmpts,$created,$profile) = $cursor->fetchrow;
   $cursor->finish;

print <<"EOF";
<TABLE BORDER>
  <TR>
    <TH>User name</TH>
    <TH>Default tablespace</TH>
    <TH>Temp tablespace</TH>
    <TH>Created</TH>
    <TH>Profile</TH>
  </TR>
  <TR>
    <TD>$uname</TD>
    <TD>$defts</TD>
    <TD>$tmpts</TD>
    <TD>$created</TD>
    <TD><A HREF=$scriptname?database=$database&object_type=PROFILE&arg=$profile>$profile</A></TD>
  </TR>
</TABLE>
EOF
    
# Tablespace quotas

   $sql = "
SELECT 
   TABLESPACE_NAME                       \"Tablespace\", 
   TO_CHAR(BYTES,'999,999,999,999')      \"Bytes used\", 
DECODE 
(
   MAX_BYTES,
      '-1','Unlimited', TO_CHAR(MAX_BYTES,'999,999,999,999')
)                                        \"Quota\"  
FROM DBA_TS_QUOTAS 
   WHERE USERNAME = '$schema'
";
   $text = "Tablespace quotas";
   $link = "";
   $nulltext = "$schema has no individual tablespace quotas.";

   DisplayTable($sql,$text,$link,$nulltext);

# Buttons for displaying grants / session info

print <<"EOF";
<P>
<TABLE BORDER=0>
  <TR ALIGN=CENTER>
    <TD>
      <FORM METHOD="GET" ACTION="$scriptname">
        <INPUT TYPE="HIDDEN" NAME="database" VALUE="$database">
        <INPUT TYPE="HIDDEN" NAME="schema" VALUE="$schema">
        <INPUT TYPE="HIDDEN" NAME="object_type" VALUE="GRANTSTO">
        <INPUT TYPE="SUBMIT" NAME="togrants" VALUE="Display grants to $schema">
      </FORM>
    </TD>
    <TD>
      <FORM METHOD="GET" ACTION="$scriptname">
        <INPUT TYPE="HIDDEN" NAME="database" VALUE="$database">
        <INPUT TYPE="HIDDEN" NAME="schema" VALUE="$schema">
        <INPUT TYPE="HIDDEN" NAME="object_type" VALUE="GRANTSFROM">
        <INPUT TYPE="SUBMIT" NAME="fromgrants" VALUE="Display grants from $schema">
      </FORM>
    </TD>
  </TR>
EOF

# Display a button if the user currently has sessions in this instance.

   $sql = "
SELECT COUNT(*) 
   FROM V\$SESSION 
WHERE USERNAME = '$schema'
";
   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   $count = $cursor->fetchrow_array;
   $cursor->finish;

   if ($count > 0) {
print <<"EOF";
  <TR>
    <TD COLSPAN=2 ALIGN=CENTER>
      <FORM METHOD="GET" ACTION="$scriptname">
        <INPUT TYPE="HIDDEN" NAME="database" VALUE="$database">
        <INPUT TYPE="HIDDEN" NAME="user" VALUE="$schema">
        <INPUT TYPE="HIDDEN" NAME="object_type" VALUE="SESSIONS">
        <INPUT TYPE="SUBMIT" NAME="sessions" VALUE="Display $schema session info">
      </FORM>
    </TD>
  </TR>
</TABLE>
EOF
   } else {
print <<"EOF";
</TABLE>
EOF
   message("$schema has no sessions in this instance.");
   }

   $sql = "
SELECT
   COUNT(DECODE(TYPE, 2, OBJ#, '')) \"Table\",
   COUNT(DECODE(TYPE, 1, OBJ#, '')) \"Index\",
   COUNT(DECODE(TYPE, 5, OBJ#, '')) \"Synonym\",
   COUNT(DECODE(TYPE, 4, OBJ#, '')) \"View`\",
   COUNT(DECODE(TYPE, 6, OBJ#, '')) \"Sequence\",
   COUNT(DECODE(TYPE, 7, OBJ#, '')) \"Procedure\",
   COUNT(DECODE(TYPE, 8, OBJ#, '')) \"Function\",
   COUNT(DECODE(TYPE, 9, OBJ#, '')) \"Package\",
   COUNT(DECODE(TYPE,12, OBJ#, '')) \"Trigger\",
   COUNT(DECODE(TYPE,10, OBJ#, '')) \"Dependency\"
FROM SYS.OBJ\$
   WHERE OWNER# = 
(
SELECT USER_ID 
   FROM DBA_USERS 
WHERE USERNAME = '$schema'
)
" if $oracle7;

   $sql = "
SELECT
   COUNT(DECODE(TYPE#, 2, OBJ#, '')) \"Table\",
   COUNT(DECODE(TYPE#, 1, OBJ#, '')) \"Index\",
   COUNT(DECODE(TYPE#, 5, OBJ#, '')) \"Synonym\",
   COUNT(DECODE(TYPE#, 4, OBJ#, '')) \"View\",
   COUNT(DECODE(TYPE#, 6, OBJ#, '')) \"Sequence\",
   COUNT(DECODE(TYPE#, 7, OBJ#, '')) \"Procedure\",
   COUNT(DECODE(TYPE#, 8, OBJ#, '')) \"Function\",
   COUNT(DECODE(TYPE#, 9, OBJ#, '')) \"Package\",
   COUNT(DECODE(TYPE#,12, OBJ#, '')) \"Trigger\",
   COUNT(DECODE(TYPE#,10, OBJ#, '')) \"Dependency\"
FROM SYS.OBJ\$
   WHERE OWNER# = 
(
SELECT USER_ID 
   FROM DBA_USERS 
WHERE USERNAME = '$schema'
)
" if $oracle8;

   $text = "Object count";
   $link = "";
   $nulltext = "No objects to count for $schema.";

   DisplayTable($sql,$text,$link,$nulltext);

# Get object types owned by user

   $sql = "
SELECT DISTINCT 
   OBJECT_TYPE				\"Object type\" 
FROM DBA_OBJECTS 
   WHERE OWNER = '$schema'
";

   $text = "The following object types are owned by $schema.<BR>Click an object type for a list.";
   $link = "$scriptname?database=$database&schema=$schema&object_type=LISTOBJECTS";
   $nulltext = "There are no objects owned by $schema in this database.";
   DisplayTable($sql,$text,$link,$nulltext);

   $sql = "
SELECT 
   COUNT(*)
FROM DBA_OBJECTS
   WHERE OWNER = '$schema'
AND OBJECT_TYPE IN ('TABLE','INDEX','CLUSTER')
";

   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   $count = $cursor->fetchrow_array;

   if ($count > 0) {

      print <<"EOF";
</FONT>
<FORM METHOD="GET" ACTION="$scriptname">
  <INPUT TYPE="HIDDEN" NAME="database" VALUE="$database">
  <INPUT TYPE="HIDDEN" NAME="schema" VALUE="$schema">
  <INPUT TYPE="HIDDEN" NAME="object_type" VALUE="OBJECTREPORT">
  <INPUT TYPE="SUBMIT" NAME="objectreport" VALUE="Object report by tablespace.">
</FORM>
EOF
   }
}

sub objectReport {

   my ($sql1,$sql2,$count,$counter,$cursor1,$cursor2);
   my ($tablespace_name,$object_type,@tablespaces,$text,$link);

# Show all objects for a particular user ordered by tablespace.
# This can be helpful for examining which tablespaces are expected
# to exist should you need to import this user's schema into a
# different database.

print "Object report for schema $schema ordered by tablespace.\n";

  $sql1 = "
SELECT DISTINCT 
   TABLESPACE_NAME 
FROM DBA_SEGMENTS
   WHERE OWNER = '$schema'
   AND SEGMENT_TYPE NOT IN ('CACHE',
			    'ROLLBACK',
			    'TEMPORARY')
ORDER BY TABLESPACE_NAME
";

   $count=0;
   $cursor1 = $dbh->prepare($sql1); 
   $cursor1->execute;
   while ( $tablespace_name = $cursor1->fetchrow_array ) { 
      push @tablespaces, $tablespace_name;
      $count++;
   }
   $cursor1->finish;

# Exit if user has no objects anywhere.
   
   if ($count == 0) {
      print "<BR>$schema has no objects in this database.<BR>\n";
      Footer();
      exit;
   } else {
      print "<BR>Objects of type CACHE or TEMPORARY not shown.<BR>\n";
      print "$schema has objects in $count tablespace(s).<P></CENTER>\n";
      print "<B>Summary report:</B><P><CENTER>\n";
   }

# Print a summary report with object types and counts for each tablespace.

print "<TABLE><TR>\n";

   foreach $tablespace_name (@tablespaces) {
      print "<TR VALIGN=TOP>" if $counter == 0;
      print <<"EOF";
<TD>
<TABLE BORDER=1>
  <TR>
    <TD COLSPAN=2 ALIGN=CENTER>
    $tablespace_name
    </TD>
  </TR>
  <TH>Object type</TH>
  <TH>Count</TH>
EOF

      $sql1 = "
SELECT DISTINCT SEGMENT_TYPE 
   FROM DBA_SEGMENTS
WHERE OWNER = '$schema'
AND TABLESPACE_NAME = '$tablespace_name'
AND SEGMENT_TYPE NOT IN ('CACHE',
			 'ROLLBACK',
			 'TEMPORARY')
";

      $cursor1=$dbh->prepare($sql1);
      $cursor1->execute;
      while ($object_type = $cursor1->fetchrow_array) {
         print "<TR><TD>$object_type</TD>\n";
         $sql2 = "
SELECT COUNT(*) 
   FROM DBA_SEGMENTS 
WHERE OWNER = '$schema'
AND SEGMENT_TYPE = '$object_type'
AND TABLESPACE_NAME = '$tablespace_name'
";
         $cursor2=$dbh->prepare($sql2);
         $cursor2->execute;
         $count = $cursor2->fetchrow_array;
         $cursor2->finish;
         print "<TD>$count</TD></TR>\n";
      }
      $cursor1->finish;
      print "</TABLE><TD>\n";
      $counter++;
      print "</TR>\n" if $counter == 0;
      if ( $counter == 6 ) { $counter = 0 };
   }
   print "</TR></TABLE>\n";

      print "</CENTER><P><HR WIDTH=100%><P><B>Detailed report:</B><P>\n";
      foreach $tablespace_name (@tablespaces) {
   
      $sql2 = "
SELECT
   A.SEGMENT_NAME                                       \"Object name\",
   A.SEGMENT_TYPE                                       \"Object type\",
   TO_CHAR(B.CREATED,'Month DD, YYYY - HH24:MI')          \"Created\",
   TO_CHAR(B.LAST_DDL_TIME,'Month DD, YYYY - HH24:MI')    \"Last DDL time\",
   TO_CHAR(A.BYTES,'999,999,999,999')                   \"Bytes\",
   TO_CHAR(A.EXTENTS,'999,999,999,999')                 \"Extents\"
FROM DBA_SEGMENTS A, DBA_OBJECTS B
   WHERE A.TABLESPACE_NAME = '$tablespace_name'
   AND A.OWNER = '$schema'
   AND B.OWNER = '$schema'
   AND A.SEGMENT_NAME = B.OBJECT_NAME
ORDER BY A.SEGMENT_TYPE, A.SEGMENT_NAME
";

      $text = "Tablespace $tablespace_name";
      $link = "";
      DisplayTable($sql2,$text,$link);
   }
}

sub showObjects {

   my ($sql,$text,$link,$object_type);

# Show list of object type selected

# Default sql

      $sql = "
SELECT 
   OBJECT_NAME       			\"Object name\" 
FROM DBA_OBJECTS 
   WHERE OWNER = '$schema' 
   AND OBJECT_TYPE = '$object_name'
";

# If object is of type partitioned, then
# show the subobject as well.

   if ($object_name =~ /PARTITION/) {
      $sql = "
SELECT 
   SUBOBJECT_NAME			\"SubObject name\",
   OBJECT_NAME				\"Object name\"
FROM DBA_OBJECTS
   WHERE OWNER = '$schema'
   AND OBJECT_TYPE = '$object_name'
";
   }

# If object is a table or index, show the space used

   if ($object_name eq "TABLE" || $object_name eq "INDEX") {
      $sql = "
SELECT 
   SEGMENT_NAME				\"Object name\",
   TABLESPACE_NAME			\"Tablespace name\",
   TO_CHAR(BYTES,'999,999,999,999')	\"Bytes\"
FROM DBA_SEGMENTS
   WHERE OWNER = '$schema'
   AND SEGMENT_TYPE = '$object_name'
ORDER BY SEGMENT_NAME
";
   }

   $_ = $object_name;
   s/ /+/;
   $object_type = $_;
   $text = "Select an object by clicking on it..";
   $link = "$scriptname?database=$database&schema=$schema&object_type=$object_type";
   DisplayTable($sql,$text,$link);
}

sub showSynonym {

   my ($sql,$text,$link);

# General synonym info

   $sql = "
SELECT 
   SYNONYM_NAME				\"Synonym name\", 
   TABLE_NAME				\"Object name\", 
   TABLE_OWNER				\"Table owner\", 
   DB_LINK				\"Database link\"
FROM DBA_SYNONYMS 
   WHERE SYNONYM_NAME = '$object_name' 
   AND OWNER = '$schema'
";
   $text = "";
   $link = "";
   DisplayTable($sql,$text,$link);
}

sub showTablespaces {

   my ($sql,$text,$link);

# Tablespace graph button

print <<"EOF";
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
  <TR>
    <TD ALIGN=CENTER>
      <FORM METHOD="GET" ACTION="$scriptname">
        <INPUT TYPE="HIDDEN" NAME="database" VALUE="$database">
        <INPUT TYPE="HIDDEN" NAME="object_type" VALUE="TSGRAPH">
        <INPUT TYPE="SUBMIT" NAME="tsgraph" VALUE="Tablespace allocation graph">
      </FORM>
    </TD>
  </TR>
</TABLE>
EOF

# General tablespace information

   $sql = "
SELECT
   TABLESPACE_NAME				\"Tablespace name\",
   TO_CHAR(INITIAL_EXTENT,'999,999,999,999')	\"Initial extent\",
   TO_CHAR(NEXT_EXTENT,'999,999,999,999')	\"Next extent\",
   TO_CHAR(MAX_EXTENTS,'999,999,999,999')	\"Max extents\",
   PCT_INCREASE					\"% increase\",
   STATUS					\"Status\"
   FROM DBA_TABLESPACES
ORDER BY TABLESPACE_NAME
";
   $text = "Tablespace information: Database $database";
   $link = "$scriptname?database=$database&object_type=TSINFO";
   DisplayTable($sql,$text,$link);
}

sub showTSinfo {

   my ($sql,$cursor,$foo,$text,$link,$nulltext);

# Show a tablespace fragmentation image.

#   print "<IMG SRC=$scriptname?database=$database&object_type=FRAGMAP&arg=$object_name&schema=tablespace>\n";

# Tablespace information

   $sql = "
SELECT
   TO_CHAR(INITIAL_EXTENT,'999,999,999,999')	\"Initial extent\",
   TO_CHAR(NEXT_EXTENT,'999,999,999,999')	\"Next extent\",
   TO_CHAR(MAX_EXTENTS,'999,999,999,999')	\"Max extents\",
   PCT_INCREASE				\"% increase\",
   STATUS				\"Status\"
   FROM DBA_TABLESPACES
WHERE TABLESPACE_NAME = '$object_name'
";
   $text = "General information: Tablespace $object_name";
   $link = "";
   DisplayTable($sql,$text,$link);

# Space allocation

   $sql = "
SELECT
   DF.TABLESPACE_NAME                                   \"Tablespace name\",
   TO_CHAR(DF.BYTES,'999,999,999,999')                  \"Bytes allocated\",
   TO_CHAR(DF.BYTES-SUM(FS.BYTES),'999,999,999,999')    \"Bytes used\",
   TO_CHAR(SUM(FS.BYTES),'999,999,999,999')             \"Bytes free\",
   ROUND((DF.BYTES-SUM(FS.BYTES))*100/DF.BYTES)         \"%Used\",
   ROUND(SUM(FS.BYTES)*100/DF.BYTES)                    \"%Free\"
FROM DBA_FREE_SPACE FS,
   (SELECT TABLESPACE_NAME, SUM(BYTES) BYTES FROM DBA_DATA_FILES GROUP BY TABLESPACE_NAME ) DF
WHERE FS.TABLESPACE_NAME = DF.TABLESPACE_NAME
AND DF.TABLESPACE_NAME = '$object_name'
GROUP BY DF.TABLESPACE_NAME, DF.BYTES
";

   $text = "Space allocation";
   $link = "";
   DisplayTable($sql,$text,$link);

# Fragmentation

$sql = "
SELECT 
   A.FILE_NAME					\"File name\",
   B.FILE_ID					\"File #\", 
   TO_CHAR(A.BYTES,'999,999,999,999')		\"Bytes\",
   TO_CHAR(MAX(B.BYTES),'999,999,999,999')	\"Largest free chunk\", 
   TO_CHAR(MIN(B.BYTES),'999,999,999,999')	\"Smallest free chunk\",
   COUNT(*)					\"Pieces\"
FROM DBA_DATA_FILES A, DBA_FREE_SPACE B
WHERE A.FILE_ID = B.FILE_ID
AND B.TABLESPACE_NAME = '$object_name'
GROUP BY A.FILE_NAME, B.FILE_ID, A.BYTES
";

   $text = "Tablespace (datafile) fragmentation";
   $link = "$scriptname?database=$database&object_type=DATAFILE";
   DisplayTable($sql,$text,$link);

# Tablespace graph button

print <<"EOF";
<BR>
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
  <TR>
    <TD ALIGN=CENTER>
      <FORM METHOD="GET" ACTION="$scriptname">
        <INPUT TYPE="HIDDEN" NAME="database" VALUE="$database">
        <INPUT TYPE="HIDDEN" NAME="object_type" VALUE="TSFILEGRAPH">
        <INPUT TYPE="HIDDEN" NAME="schema" VALUE="$object_name">
        <INPUT TYPE="SUBMIT" NAME="tsfilegraph" VALUE="Datafile information graphs">
      </FORM>
    </TD>
  </TR>
</TABLE
EOF

# Added this to check for DBA_FREE_SPACE
# returning a null value if there is no
# free space

   $sql = "
SELECT MAX(BYTES)
   FROM DBA_FREE_SPACE
WHERE TABLESPACE_NAME = '$object_name'
";
   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   $foo = $cursor->fetchrow_array;
   if ($foo) {
   

# Objects in the tablespace with next extent sizes larger than the largest
# free extent in the tablespace. Allocating a next extent for these objects
# will fail.

      $sql = "
SELECT 
   SEGMENT_NAME					\"Object name\", 
   OWNER					\"Owner\",
   TO_CHAR(NEXT_EXTENT,'999,999,999,999')	\"Next extent\"
FROM DBA_SEGMENTS
   WHERE TABLESPACE_NAME = '$object_name'
   AND NEXT_EXTENT > (SELECT MAX(BYTES) FROM DBA_FREE_SPACE
WHERE TABLESPACE_NAME = '$object_name')
";
      $text = "Objects that will fail to allocate a next extent";
      $link = "";
      $nulltext = "No objects in $object_name will fail to allocate a next extent.";
      DisplayTable($sql,$text,$link,$nulltext);
    } else {
      message("Warning: No objects can allocate an extent. Add a datafile.");
   }
   undef $foo;

# Objects in the tablespace that are approaching their max_extents limit.

   $sql = "
SELECT 
   SEGMENT_NAME					\"Object name\",
   OWNER					\"Owner\",
   SEGMENT_TYPE					\"Object type\",
   TO_CHAR(EXTENTS,'999,999,999,999')		\"Extents\",
   TO_CHAR(MAX_EXTENTS,'999,999,999,999')	\"Max extents\"
FROM DBA_SEGMENTS
   WHERE TABLESPACE_NAME = '$object_name'
   AND EXTENTS > (MAX_EXTENTS-25)
   AND SEGMENT_TYPE != 'CACHE'
";

   $text = "Objects that are approaching their max_extents limit";
   $link = "";
   $nulltext = "No objects in $object_name have extents > ( max_extents - 25 )";
   DisplayTable($sql,$text,$link,$nulltext);

   $sql = "
SELECT 
   A.SEGMENT_NAME					\"Object name\",
   A.SEGMENT_TYPE					\"Object type\",
   A.OWNER						\"Owner\",
   TO_CHAR(B.CREATED,'Month DD, YYYY - HH24:MI')		\"Created\",
   TO_CHAR(B.LAST_DDL_TIME,'Month DD, YYYY - HH24:MI')    \"Last DDL time\",
   TO_CHAR(A.BYTES,'999,999,999,999')			\"Bytes\",
   TO_CHAR(A.INITIAL_EXTENT,'999,999,999,999')		\"Initial extent\",
   TO_CHAR(A.NEXT_EXTENT,'999,999,999,999')		\"Next extent\",
   TO_CHAR(A.EXTENTS,'999,999,999,999')			\"Extents\"
FROM DBA_SEGMENTS A, DBA_OBJECTS B
   WHERE A.TABLESPACE_NAME = '$object_name'
   AND A.SEGMENT_NAME = B.OBJECT_NAME
   AND A.OWNER = B.OWNER
ORDER BY A.OWNER, A.SEGMENT_TYPE, A.SEGMENT_NAME
";
   $text = "Object list";
   $link = "";
   $nulltext = "Tablespace $object_name has no objects.";
   ObjectTable($sql,$text,$nulltext);

}

sub showFile {

   my ($sql,$text,$link,$nulltext);

# Show a datafile fragmentation image.

   print "<IMG SRC=$scriptname?database=$database&object_type=FRAGMAP&arg=$object_name&schema=datafile>\n";

# Specific datafile information

   $sql = "
SELECT 
   B.FILE_NAME					\"File name\",
   TO_CHAR(A.CREATE_BYTES,'999,999,999,999')	\"Creation size\",
   TO_CHAR(A.BYTES,'999,999,999,999')		\"Current size\",
   TO_CHAR(B.BLOCKS,'999,999,999,999')		\"Blocks\",
   B.TABLESPACE_NAME				\"Tablespace_name\",
   B.STATUS					\"Status\"
FROM V\$DATAFILE A, DBA_DATA_FILES B
   WHERE B.FILE_NAME = '$object_name'
   AND A.FILE# = B.FILE_ID
";
   $text = "General information";
   $link = "";
   DisplayTable($sql,$text,$link);

   $sql = "
SELECT 
   TO_CHAR(A.PHYRDS,'999,999,999,999')				\"Physical reads#\",
   TO_CHAR(A.PHYWRTS,'999,999,999,999')				\"Physical writes#\",
   TO_CHAR(A.PHYBLKRD*$db_block_size,'999,999,999,999')		\"Bytes read\",
   TO_CHAR(A.PHYBLKWRT*$db_block_size,'999,999,999,999')	\"Bytes written\"
FROM V\$FILESTAT A, DBA_DATA_FILES B
   WHERE B.FILE_NAME = '$object_name'
   AND A.FILE# = B.FILE_ID
";
   $text = "I/O stats since database startup";
   $link = "";
   DisplayTable($sql,$text,$link);

   $text = "Historical I/O stats.";
   DisplayGraph("dbfile",$object_name,$text);

   $sql = "
SELECT 
   TO_CHAR(NEXT_EXTENT,'999,999,999,999')	\"Next extent\"
FROM DBA_TABLESPACES
    WHERE TABLESPACE_NAME =  
(SELECT 
   TABLESPACE_NAME FROM DBA_DATA_FILES
WHERE FILE_NAME = '$object_name')
";

   $text = "Next extent size of tablespace";
   $link = "";
   DisplayTable($sql,$text,$link);
   
   $sql = "
SELECT 
   TO_CHAR(BYTES,'999,999,999,999')		\"Chunk size (bytes)\",
   TO_CHAR(BLOCKS,'999,999,999,999')		\"Blocks\"
FROM DBA_FREE_SPACE
   WHERE FILE_ID  = 
(SELECT 
   FILE_ID FROM DBA_DATA_FILES 
      WHERE FILE_NAME = '$object_name')
      AND ROWNUM <= 10
   ORDER BY BYTES DESC
";
   $text = "Free space (Top ten)";
   $link = "";
   $nulltext = "There are no free chunks of data in this datafile.";
   DisplayTable($sql,$text,$link,$nulltext);

   $sql = "
SELECT DISTINCT
   SEGMENT_NAME					\"Segment name\",
   SEGMENT_TYPE					\"Segment type\",
   OWNER					\"Owner\",
   TABLESPACE_NAME				\"Tablespace name\"
FROM DBA_EXTENTS
   WHERE FILE_ID = (
SELECT FILE_ID FROM DBA_DATA_FILES
   WHERE FILE_NAME = '$object_name')
";

   $text = "Objects which have extents in this datafile.";
   $nulltext = "There are no objects with extents in this datafile.";
   ObjectTable($sql,$text,$nulltext);

}

sub runWorksheet {

   my ($sql,$cursor,$rows,$text,$link,$nulltext,@statements,$statement,$error);

   $_ = $object_name;
# Get rid of trailing whitespace
   s/\s+$//;
   @statements = split /;/;
   foreach $_ (@statements) {
# Get rid of leading whitespace and newlines
      s/^\s+//;

# If the command is "DESCRIBE"
   if (/^desc/i) {
      @_ = split;
      Describe("$_[1]");
      next;
   }
      
print <<"EOF";
<TABLE BGCOLOR="BLACK" WIDTH="100" CELLPADDING="1" CELLSPACING="0" BORDER="0" ALIGN="CENTER">
  <TR>
    <TD VALIGN="TOP">
      <TABLE BGCOLOR="$menucolor" WIDTH="100%" CELLPADDING="2" CELLSPACING="1" BORDER="0">
        <TR ALIGN="LEFT">
          <TD><B><FONT SIZE="2">
          <PRE>
$_</PRE>
          </TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
</TABLE>
EOF
# Check to see if it is a select statement.
      if (/^SELECT/i) {
         $text = "";
         $link="";
         $nulltext = "No rows to display.";
         $error = DisplayTable($_,$text,$link,$nulltext);
         if ($error) {
            message("Select statement failed: $error\n");
         }
         print "<BR>\n";
      } else {
         $cursor=$dbh->do($_);
         if ( ! $cursor) {
            $_ = $DBI::errstr;
            s/DBD: //;
            message("SQL error:<BR>$_\n");
         } else {
            $dbh->commit;
#            $rows = $cursor->rows;
            message("SQL statement executed successfully.\n");
            if ($rows > 0) {
               message("$rows rows affected.\n");
            }
            Footer();
         }
      }
   print "<HR WIDTH=\"10%\">\n";
   }
}

sub runExplainPlan {

   my ($sql,$cursor,$text,$link,$nulltext,@row,$explainsql);

   $explainsql	= $object_name;
   $explainsql = "Explain plan set statement_id = '$statement_id' into $schema.plan_table for $explainsql";
   $cursor=$dbh->do($explainsql);
   if ( ! $cursor) { 
      ErrorPage("Could not execute explain plan. $DBI::errstr\n");
   } else {
      text("Explain plan executed successfully.\n");
#      $sql = "
#SELECT
#   STATEMENT_ID		\"Statement id\",
#   TIMESTAMP		\"Timestamp\",
#   REMARKS		\"Remarks\",
#   OPERATION		\"Operation\",
#   OPTIONS		\"Options\",
#   OBJECT_NODE		\"Object node\",
#   OBJECT_OWNER		\"Object owner\",
#   OBJECT_NAME		\"Object name\",
#   OBJECT_INSTANCE	\"Object instance\",
#   OBJECT_TYPE		\"Object type\",
#   OPTIMIZER		\"Optimizer\",
#   SEARCH_COLUMNS	\"Search columns\",
#   ID			\"ID\",
#  PARENT_ID		\"Parent ID\",
#   POSITION		\"Position\",
#   COST			\"Cost\",
#   CARDINALITY		\"Cardinality\",
#   BYTES		\"Bytes\",
#   OTHER_TAG		\"Other tag\",
#   PARTITION_START	\"Partition start\",
#   PARTITION_STOP	\"Partition stop\",
#   PARTITION_ID		\"Partition ID\"
#FROM $schema.PLAN_TABLE
#   WHERE STATEMENT_ID = '$statement_id'
#";
#   $text = "Output of explain plan";
#   $link = "";
#   $nulltext = "";
#   DisplayTable($sql,$text,$link,$nulltext);

   text("Output of explain plan.");
print <<"EOF";
<TABLE BGCOLOR="BLACK" WIDTH="100" CELLPADDING="1" CELLSPACING="0" BORDER="0" ALIGN="CENTER">
  <TR>
    <TD VALIGN="TOP">
      <TABLE BGCOLOR="$menucolor" WIDTH="100%" CELLPADDING="2" CELLSPACING="1" BORDER="0">
        <TR ALIGN="LEFT">
          <TD><B><FONT SIZE="2">
          <PRE>
EOF
   
   $sql = "
SELECT LPAD(' ',2*LEVEL-1)||OPERATION Operation, OPTIONS, OBJECT_NAME
FROM $schema.PLAN_TABLE
START WITH ID=0 AND STATEMENT_ID = '$statement_id'
CONNECT BY PRIOR ID = PARENT_ID AND STATEMENT_ID = '$statement_id'
";
   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   while (@row = $cursor->fetchrow_array) {
      print "@row\n";
   }
   $cursor->finish;
   
print <<"EOF";
          </TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
</TABLE>
EOF
   }
}

sub enterWorksheet {

   my ($sql);

   message("Connected to $database as $schema.");
   text("Enter or paste the SQL you wish to execute.<BR>Terminate statements with a <B>';'</B> if entering multiple statements.");
   print <<"EOF";
<FORM>
<INPUT TYPE=HIDDEN NAME=object_type VALUE=RUNWORKSHEET>
<INPUT TYPE=HIDDEN NAME=database VALUE=$database>
<INPUT TYPE=HIDDEN NAME=schema VALUE=$schema>
<TEXTAREA NAME=arg ROWS=15 COLS=60></TEXTAREA>
<P>
</B>
<INPUT TYPE=SUBMIT VALUE="Execute">
</FORM>
EOF
}

sub enterExplainPlan {

   my ($sql,$cursor,$count,$text,$link,$nulltext);
   my ($owner,$table_name);

# Check for available plan_table's

# First, get a count

   $sql = "
SELECT COUNT(*) 
   FROM DBA_TABLES
   WHERE TABLE_NAME = 'PLAN_TABLE'
";

   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   $count=$cursor->fetchrow_array;
   if ($count == 0) {
      message("No plan tables were found.<BR>You can create a PLAN_TABLE with the following SQL..\n");
      print <<"EOF" if $oracle7;
</CENTER>
<B>
<PRE>
create table PLAN_TABLE (
        statement_id    varchar2(30),
        timestamp       date,
        remarks         varchar2(80),
        operation       varchar2(30),
        options         varchar2(30),
        object_node     varchar2(128),
        object_owner    varchar2(30),
        object_name     varchar2(30),
        object_instance numeric,
        object_type     varchar2(30),
        optimizer       varchar2(255),
        search_columns  numeric,
        id              numeric,
        parent_id       numeric,
        position        numeric,
        cost            numeric,
        cardinality     numeric,
        bytes           numeric,
        other_tag       varchar2(255),
        other           long);
EOF

      print <<"EOF" if $oracle8;
</CENTER>
<B>
<PRE>
create table PLAN_TABLE (
   statement_id    varchar2(30),
   timestamp       date,
   remarks         varchar2(80),
   operation       varchar2(30),
   options         varchar2(30),
   object_node     varchar2(128),
   object_owner    varchar2(30),
   object_name     varchar2(30),
   object_instance numeric,
   object_type     varchar2(30),
   optimizer       varchar2(255),
   search_columns  number,
   id              numeric,
   parent_id       numeric,
   position        numeric,
   cost            numeric,
   cardinality     numeric,
   bytes           numeric,
   other_tag       varchar2(255),
   partition_start varchar2(255),
   partition_stop  varchar2(255),
   partition_id    numeric,
   other           long);
EOF
  } else {
      message("Connected to $database as $schema.");
      text("Choose a plan table from below to store your execution plan.\n");
      print "<FORM METHOD=POST ACTION=$scriptname>\n";
      print "<TABLE BORDER>\n";
      $sql = "
SELECT
   OWNER	\"Owner\",
   TABLE_NAME	\"Table name\"
FROM DBA_TABLES
   WHERE TABLE_NAME = 'PLAN_TABLE'
";

      $cursor=$dbh->prepare($sql);
      $cursor->execute;
      while (($owner,$table_name) = $cursor->fetchrow_array) {
         print "<TR><TD><INPUT TYPE=radio NAME=schema VALUE=$owner>$owner</TD><TD>$table_name</TD></TR>\n";
      }
      print "</TABLE>\n";
      text("Enter a statement ID for your plan.\n");
      print "<INPUT TYPE=TEXT NAME=statement_id SIZE=20>\n";
      print "</B><P><INPUT TYPE=SUBMIT VALUE=\"Run explain plan\"><B>\n";
      text("Paste in the SQL to explain.\n");
      print <<"EOF";
<INPUT TYPE=HIDDEN NAME=object_type VALUE=RUNEXPLAINPLAN>
<INPUT TYPE=HIDDEN NAME=database VALUE=$database>
<INPUT TYPE=HIDDEN NAME=schema VALUE=$schema>
<TEXTAREA NAME=arg ROWS=20 COLS=60></TEXTAREA>
</FORM>
EOF
   }
}

sub showDBfiles {

   my ($sql,$text,$link,$nulltext);

print <<"EOF";
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
  <TR>
    <TD ALIGMN=CENTER>
      <FORM METHOD="GET" ACTION="$scriptname">
        <INPUT TYPE="HIDDEN" NAME="database" VALUE="$database">
        <INPUT TYPE="HIDDEN" NAME="object_type" VALUE="FILEGRAPH">
        <INPUT TYPE="SUBMIT" NAME="filegraph" VALUE="Datafile graph by file I/O">
      </FORM>
    </TD>
  </TR>
</TABLE>
EOF

# Show any files that need media recovery.

   $sql = "
SELECT 
   A.FILE_NAME					\"File name\",
   A.TABLESPACE_NAME				\"Tablespace name\",
   A.FILE_ID					\"File#\",
   A.STATUS					\"Status\",
   B.ERROR					\"Error\",
   B.CHANGE#					\"Start SCN\",
   TO_CHAR(B.TIME,'Month DD, YYYY - HH24:MI:SS')	\"Recover from..\"
FROM DBA_DATA_FILES A,
     V\$RECOVER_FILE B
WHERE A.FILE_ID = B.FILE#
";

   $text = "Datafiles need recovery!!";
   $link = "$scriptname?database=$database&object_type=DATAFILE";
   $nulltext = "No datafiles are needing media recovery :-)";
   DisplayTable($sql,$text,$link,$nulltext);

# General datafile information, all datafiles

   $sql = "
SELECT
   A.FILE_NAME					\"File name\",
   TO_CHAR(A.BYTES,'999,999,999,999')		\"Bytes\",
   A.TABLESPACE_NAME				\"Tablespace_name\",
   TO_CHAR(B.PHYBLKRD,'999,999,999,999')	\"Physical block reads\",
   TO_CHAR(B.PHYBLKWRT,'999,999,999,999')	\"Physical block writes\",
   A.STATUS					\"Status\"
FROM DBA_DATA_FILES A, V\$FILESTAT B
   WHERE A.FILE_ID = B.FILE#
ORDER BY A.FILE_NAME, A.TABLESPACE_NAME
";
   $text = "Datafile information: Database $database";
   $link = "$scriptname?database=$database&object_type=DATAFILE";
   DisplayTable($sql,$text,$link);
}

sub EnterPasswd {

# Usage: EnterPasswd($database);

   if ($object_type ne "MENU") {

   my $database      = shift;

   my ($title,$heading);

   $title	= "Add database $database";
   $heading	= "Please enter a username and password for database $database.<BR>This user needs to have CREATE SESSION and SELECT ANY TABLE privileges.";

   Header($title,$heading,$font,$fontsize,$fontcolor,$bgcolor);

   print <<"EOF";
</CENTER>
  <P>
    <TABLE BGCOLOR="BLACK" WIDTH="200" CELLPADDING="1" CELLSPACING="0" BORDER="0">
      <TR>
        <TD VALIGN="TOP">
          <TABLE BGCOLOR="$menucolor" WIDTH="100%" CELLPADDING="2" CELLSPACING="1" BORDER="0">
            <TR ALIGN="CENTER">
              <TD>
                <FORM METHOD="POST" ACTION="$scriptname">
                <STRONG>Enter the username</STRONG>
                <P>
                <INPUT TYPE="TEXT" SIZE="20" NAME="username" MAXLENGTH="20">
                <P>
                <STRONG>Enter the password</STRONG>
                <P>
                <INPUT TYPE="PASSWORD" SIZE="20" NAME="password" MAXLENGTH="20">
                <P>
                <INPUT TYPE="HIDDEN" NAME="object_type" VALUE="ADDPASSWORD">
                <INPUT TYPE="HIDDEN" NAME="database" VALUE="$database">
                <INPUT TYPE="SUBMIT" VALUE="Submit">
              </TD>
            </TR>
          </TABLE>
        </TD>
      </TR>
    </TABLE>
EOF
exit;
    } else {
      Header($title,$heading,$font,$fontsize,$fontcolor,$bgcolor);
   }
}

sub GetPasswd {

# Usage: $info = GetPasswd($database);

   my $database      = shift;
   my ($username,$password,$usercookie,$passcookie,$info,$message,$duration,$url);

   if ( defined $expire ) {
      $username = "undefined";
      $password = "undefined";
      $usercookie = cookie(-name=>"$database.username",-value=>"$username",-expires=>'-1y');
      $passcookie = cookie(-name=>"$database.password",-value=>"$password",-expires=>'-1y');
      print header(-cookie=>[$usercookie,$passcookie]);
      $message     = "Password cookie for database $database has been expired.";
      $duration    = "1";
      $url         = "$scriptname";

      print <<"EOF";
<HTML>
  <HEAD>
    <TITLE>Notice!</TITLE>
    <META HTTP-EQUIV="Refresh" Content="$duration;URL=$url">
  </HEAD>
  <BODY BGCOLOR="$bgcolor">
    <FONT FACE="$font" SIZE="$fontsize" COLOR="$fontcolor">
    <CENTER>
      $message
    </CENTER
  </BODY
</HTML>
EOF

      exit;
    } else {

      $username = cookie("$database.username") or return(1);
      $password = cookie("$database.password") or return(1);
   }

   $info = "$username $password";
   return($info);
}

sub addPasswd {

   my $database		= shift;
   my $username		= shift;
   my $password		= shift;

   my ($sql,$cursor,$count,$message,$duration,$url,$usercookie,$passcookie);
   my ($role,@allroles,$foo);

# First, check to be sure this user has "SELECT ANY TABLE" privilege.
# If not, send them packing.

   $dbh = dbConnect($database,$username,$password);

# Check to see if the user has "SELECT ANY TABLE" explicitly granted.
   $sql = "
SELECT COUNT(*) 
   FROM USER_SYS_PRIVS
WHERE PRIVILEGE = 'SELECT ANY TABLE'
";
   $cursor = $dbh->prepare($sql);
   $cursor->execute;
   $count = $cursor->fetchrow_array;
   $cursor->finish;
   if ($count < 1) {
# Find names of roles explicitly granted to user
      $sql = "
SELECT *
   FROM SESSION_ROLES
";
      $cursor = $dbh->prepare($sql);
      $cursor->execute;
      while ($role = $cursor->fetchrow_array) {
         push @allroles, $role;
      }
      $cursor->finish;
      foreach $role (@allroles) {
         $sql = "
SELECT COUNT(*)
   FROM ROLE_SYS_PRIVS
WHERE ROLE = '$role'
AND PRIVILEGE = 'SELECT ANY TABLE'
";

         $cursor=$dbh->prepare($sql);
         $cursor->execute;
         $count = $cursor->fetchrow_array;
         $cursor->finish;
         last if ($count > 0);
      }
   }
   if ($count < 1) {
      $dbh->disconnect;
      $foo = join(" , ",@allroles);
      ErrorPage("The username you have specified does not have the appropriate permissions to use this tool. Please specify a username with SELECT ANY TABLE privileges.<P> The following roles were found and checked.<BR> ($foo)");
   }
   $dbh->disconnect;

   $usercookie = cookie(-name=>"$database.username",-value=>"$username",-expires=>"$expiration");
   $passcookie = cookie(-name=>"$database.password",-value=>"$password",-expires=>"$expiration");
   print header(-cookie=>[$usercookie,$passcookie]);

   $message     = "Password for database $database has been updated.";
   $duration    = "1";
   $url         = "$scriptname?database=$database&object_type=FRAMEPAGE";
   
   print <<"EOF";
<HTML>
  <HEAD>
    <TITLE>Notice!</TITLE>
    <META HTTP-EQUIV="Refresh" Content="$duration;URL=$url">
  </HEAD>
  <BODY BGCOLOR="$bgcolor">
    <FONT FACE="$font" SIZE="$fontsize" COLOR="$fontcolor">
    <CENTER>
      $message
    </CENTER
  </BODY
</HTML>
EOF

exit;
}

sub healthCheck {

   my ($sql,$text,$link,$nulltext);

   $sql = "
SELECT 
   TO_CHAR(TO_DATE(D.VALUE,'J'),'Day, Month DD, YYYY')||' -  '||
   TO_CHAR(TO_DATE(S.VALUE,'sssss'),'HH24:MI:SS')		\"Startup Time\"
FROM V\$INSTANCE D, V\$INSTANCE S
   WHERE D.KEY = 'STARTUP TIME - JULIAN'
   AND S.key = 'STARTUP TIME - SECONDS'
" if ($oracle7);

   $sql = "
SELECT
   TO_CHAR(STARTUP_TIME,'Day, Month DD, YYYY -  HH24:MI:SS')	\"Startup Time\"
FROM V\$INSTANCE
" if ($oracle8);

   $text = "";
   $link = "";
   DisplayTable($sql,$text,$link);

}

sub showPerformance {

   my ($sql,$text,$link,$nulltext);

# Instance SGA information

   $sql = "
SELECT
   NAME                                 \"Name\",
   TO_CHAR(VALUE,'999,999,999,999')     \"Value\"
FROM V\$SGA
";

   $text = "Instance SGA info";
   $link = "";
   DisplayTable($sql,$text,$link);

   $sql = "
SELECT
   NAME                                 \"Name\",
   TO_CHAR(BYTES,'999,999,999,999')     \"Bytes\"
FROM V\$SGASTAT
   WHERE NAME IN ('free memory','db_block_buffers','log_buffer','dictionary cache','sql area','library cache')
";

   $text = "Memory usage";
   $link = "";
   DisplayTable($sql,$text,$link);

# Information from v$librarycache

   $sql = "
SELECT
   NAMESPACE                                            \"Namespace\",
   TO_CHAR(GETS,'999,999,999,999')                      \"Gets\",
   TO_CHAR(GETHITS,'999,999,999,999')                   \"Gethits\",
   TO_CHAR(GETHITRATIO,'99.99')                         \"GetHitRatio\",
   TO_CHAR(PINS,'999,999,999,999')                      \"Pins\",
   TO_CHAR(PINHITS,'999,999,999,999')                   \"PinHits\",
   TO_CHAR(PINHITRATIO,'99.99')                         \"PinHitRatio\",
   TO_CHAR(RELOADS,'999,999,999,999')                   \"Reloads\",
   TO_CHAR(INVALIDATIONS,'999,999,999,999')             \"Invalidations\"
FROM V\$LIBRARYCACHE
";

   $sql = "
SELECT
   NAMESPACE                                            \"Namespace\",
   TO_CHAR(GETS,'999,999,999,999')                      \"Gets\",
   TO_CHAR(GETHITS,'999,999,999,999')                   \"Get hits\",
   TO_CHAR(GETHITRATIO,'99.99')                         \"Get hit ratio\",
   TO_CHAR(PINS,'999,999,999,999')                      \"Pins\",
   TO_CHAR(PINHITS,'999,999,999,999')                   \"Pin hits\",
   TO_CHAR(PINHITRATIO,'99.99')                         \"Pin hit ratio\",
   TO_CHAR(RELOADS,'999,999,999,999')                   \"Reloads\",
   TO_CHAR(INVALIDATIONS,'999,999,999,999')             \"Invalidations\",
   TO_CHAR(DLM_LOCK_REQUESTS,'999,999,999,999')         \"DLM lock requests\",
   TO_CHAR(DLM_PIN_REQUESTS,'999,999,999,999')          \"DLM pin requests\",
   TO_CHAR(DLM_PIN_RELEASES,'999,999,999,999')          \"DLM pin releases\",
   TO_CHAR(DLM_INVALIDATION_REQUESTS,'999,999,999,999') \"DLM invalidation requests\",
   TO_CHAR(DLM_INVALIDATIONS,'999,999,999,999')         \"DLM invalidations\"
FROM V\$LIBRARYCACHE
" if ($oracle8 && parallel());

   $text = "Library cache information";
   $link = "";
   DisplayTable($sql,$text,$link);

# Data dictionary cache miss ratio

   $sql = "
SELECT
   TO_CHAR(SUM(gets),'999,999,999,999')                         \"Gets\",
   TO_CHAR(SUM(getmisses),'999,999,999,999')                    \"Misses\",
   TO_CHAR(SUM(getmisses) / SUM(gets) * 100,'999')||'%'         \"Percentage\"
FROM V\$ROWCACHE
";

   $text = "Data dictionary cache miss ratio";
   $link = "";
   DisplayTable($sql,$text,$link);

# Percentage of sorts that are taking place in memory,
# as opposed to in temporary segments on disk.

$sql = "
SELECT 
   ROUND((SUM(DECODE(NAME, 'sorts (memory)', VALUE, 0))
        / (SUM(DECODE(NAME, 'sorts (memory)', VALUE, 0))
        + SUM(DECODE(NAME, 'sorts (disk)', VALUE, 0))))
        * 100,2) \"Percentage\"
FROM V\$SYSSTAT
";

   $text = "Percentage of sorts that are taking place in memory";
   $link = "";
   DisplayTable($sql,$text,$link);

# Resource limit info for Oracle8 databases.

   if ( $oracle8 ) {
      $sql = "
SELECT
   RESOURCE_NAME                \"Resource name\",
   INITIAL_ALLOCATION           \"Initial value\",
   CURRENT_UTILIZATION          \"Current utilization\",
   MAX_UTILIZATION              \"Max utilization\",
   LIMIT_VALUE                  \"Upper limit\"
FROM V\$RESOURCE_LIMIT
";

      $text = "Resource limits";
      $link = "";
      DisplayTable($sql,$text,$link);
   }

# Parallel query slave stats

   $sql = "
SELECT 
   SLAVE_NAME						\"Slave name\",
   STATUS						\"Status\",
   TO_CHAR(SESSIONS,'999,999,999,999')			\"Sessions\",
   TO_CHAR(IDLE_TIME_CUR,'999,999,999,999')		\"Idle time (cur)\",
   TO_CHAR(IDLE_TIME_TOTAL,'999,999,999,999')		\"Idle time (tot)\",
   TO_CHAR(BUSY_TIME_CUR,'999,999,999,999')		\"Busy time (cur)\",
   TO_CHAR(BUSY_TIME_TOTAL,'999,999,999,999')		\"Busy time (tot)\",
   TO_CHAR(CPU_SECS_CUR	,'999,999,999,999')		\"CPU seconds (cur)\",
   TO_CHAR(CPU_SECS_TOTAL,'999,999,999,999')		\"CPU seconds (tot)\",
   TO_CHAR(MSGS_SENT_CUR,'999,999,999,999')		\"Msgs sent (cur)\",
   TO_CHAR(MSGS_SENT_TOTAL,'999,999,999,999')		\"Msgs sent (tot)\",
   TO_CHAR(MSGS_RCVD_CUR,'999,999,999,999')		\"Msgs rcvd (cur)\",
   TO_CHAR(MSGS_RCVD_TOTAL,'999,999,999,999')		\"Msgs rcvd (tot)\"
FROM V\$PQ_SLAVE
";

      $text = "Parallel query slave statistics";
      $nulltext = "No parallel query slaves are active";
      $link = "";
      DisplayTable($sql,$text,$link,$nulltext);

# Parallel query server stats

   $sql = "
SELECT
   STATISTIC				\"Statistic\",
   TO_CHAR(VALUE,'999,999,999,999')	\"Value\" 
FROM V\$PQ_SYSSTAT
";

      $text = "Parallel query server status";
      $link = "";
      DisplayTable($sql,$text,$link);

}

sub showParameters {

   my ($sql,$text,$link);

# Instance parameters

   $sql = "
SELECT 
   NAME			\"Name\",
   DESCRIPTION		\"Description\",
   VALUE		\"Value\",
   ISDEFAULT		\"Default\",
   ISSES_MODIFIABLE	\"Session mod\",
   ISSYS_MODIFIABLE	\"System mod\",
   ISADJUSTED		\"Changed\"
FROM V\$PARAMETER
   ORDER BY NAME
";

   $text = "Instance parameter information";
   $link = "";
   DisplayTable($sql,$text,$link);
}

sub showRows {

#================================================================================
# DISABLED!! Security risk!

#ErrorPage ("This action is disabled at this time.");
#exit;
#================================================================================

   my $numrows = shift;

   my ($sql,$text,$link,$nulltext,$error);

# If they entered a "where" clause, use it.

if ($whereclause) {
# Get rid of trailing semicolon, if present.
   $whereclause =~ s/;$//;
   $whereclause = " AND $whereclause";
}

# Show the first $numrows rows of a table

   $sql = "
SELECT * FROM $schema.$object_name 
WHERE ROWNUM <= $numrows
$whereclause
";

   $text = "$numrows rows of $object_name";
   $link = "";
   $nulltext = "There are no rows to display.";
   $error = DisplayTable($sql,$text,$link,$nulltext);
   if ($error) {
      message("Error in your \"where\" clause.<BR>Check the SQL and try again.<BR><BR>$error");
   }
}

sub showRollback {

   my ($sql,$text,$link,$nulltext);

# Rollback segment information

   $sql = "
SELECT 
   A.NAME					\"Rollback name\",
   TO_CHAR(C.INITIAL_EXTENT,'999,999,999,999')	\"Initial extent\",
   TO_CHAR(C.NEXT_EXTENT,'999,999,999,999')	\"Next extent\",
   TO_CHAR(C.MIN_EXTENTS,'999,999,999,999')	\"Min extents\",
   B.EXTENTS					\"Extents\",
   TO_CHAR(C.MAX_EXTENTS,'999,999,999,999')	\"Max extents\",
   TO_CHAR(D.BYTES,'999,999,999,999')		\"Size\",
   TO_CHAR(B.OPTSIZE,'999,999,999,999')		\"Optimal\",
   TO_CHAR(B.EXTENDS,'999,999,999')		\"Extends\",
   TO_CHAR(B.SHRINKS,'999,999,999')		\"Shrinks\",
   TO_CHAR(B.WRAPS,'999,999,999')		\"Wraps\",
   B.STATUS					\"Status\"
FROM V\$ROLLNAME A, V\$ROLLSTAT B, DBA_ROLLBACK_SEGS C, DBA_SEGMENTS D
   WHERE A.NAME = '$object_name'
   AND C.SEGMENT_NAME = '$object_name'
   AND A.USN = B.USN
   AND D.SEGMENT_NAME = '$object_name'
   AND D.SEGMENT_TYPE = 'ROLLBACK'
";

   $text = "Rollback segment info";
   $link = "";
   DisplayTable($sql,$text,$link);

# Active transactions occupying this rollback

   $sql = "
SELECT 
   OSUSER				\"OS user\",
   USERNAME				\"Ora user\",
   SEGMENT_NAME				\"RBS\",
   SA.SQL_TEXT				\"SQL Text\"
FROM   V\$SESSION S,
       V\$TRANSACTION T,
       DBA_ROLLBACK_SEGS R,
       V\$SQLAREA SA
WHERE  R.SEGMENT_NAME = '$object_name'
AND    S.TADDR = T.ADDR
AND    T.XIDUSN = R.SEGMENT_ID(+)
AND    S.SQL_ADDRESS = SA.ADDRESS(+)
";

   $text = "Transaction info";
   $link = "";
   $nulltext = "No current transactions on this segment";
   DisplayTable($sql,$text,$link,$nulltext);

# Tablespace information for the tablespace this rollback belongs to.
# Good for monitoring the growth of a rollback with a long running
# transaction.

   $sql = "
SELECT TABLESPACE_NAME 
   FROM DBA_SEGMENTS
WHERE SEGMENT_NAME = '$object_name'
AND SEGMENT_TYPE = 'ROLLBACK'
";

   my $cursor=$dbh->prepare($sql);
   $cursor->execute;
   $object_name = $cursor->fetchrow_array;
   $cursor->finish;

   $sql = "
SELECT * FROM
   (SELECT TO_CHAR(SUM(BYTES),'999,999,999,999')        \"Bytes allocated\"
FROM DBA_DATA_FILES WHERE TABLESPACE_NAME = '$object_name'),
   (SELECT TO_CHAR(SUM(BYTES),'999,999,999,999')        \"Bytes used\"
FROM DBA_EXTENTS WHERE TABLESPACE_NAME = '$object_name'),
   (SELECT TO_CHAR(SUM(BYTES),'999,999,999,999')        \"Bytes free\"
FROM DBA_FREE_SPACE WHERE TABLESPACE_NAME = '$object_name'),
   (SELECT TO_CHAR(MAX(BYTES),'999,999,999,999')        \"Largest free extent\"
FROM DBA_FREE_SPACE WHERE TABLESPACE_NAME = '$object_name')
";
   $text = "$object_name tablespace allocation";
   $link = "";
   DisplayTable($sql,$text,$link);

}

sub showRollbacks {

   my ($sql,$cursor,$foo,$text,$link);

# Rollback segment information

   $sql = "
SELECT
   A.SEGMENT_NAME				\"Name\",
   A.OWNER					\"Owner\",
   A.TABLESPACE_NAME				\"Tablespace\",
   TO_CHAR(A.BYTES,'999,999,999,999')		\"Bytes\",
   TO_CHAR(A.INITIAL_EXTENT,'999,999,999,999')	\"Initial Extent\",
   TO_CHAR(A.NEXT_EXTENT,'999,999,999,999')	\"Next extent\",
   TO_CHAR(A.EXTENTS,'999,999,999,999')		\"Extents\",
   TO_CHAR(A.MAX_EXTENTS,'999,999,999,999')	\"Max Extents\",
   B.STATUS					\"Status\",
   TO_CHAR(C.WRITES,'999,999,999,999')		\"Writes\",
   C.WAITS					\"Waits\",
   C.XACTS					\"Active Xacts\"
FROM DBA_SEGMENTS A, DBA_ROLLBACK_SEGS B, V\$ROLLSTAT C
   WHERE A.SEGMENT_TYPE = 'ROLLBACK'
   AND A.SEGMENT_NAME = B.SEGMENT_NAME
   AND B.SEGMENT_ID = C.USN
   AND ( B.INSTANCE_NUM = 
      ( SELECT VALUE FROM V\$PARAMETER
           WHERE NAME = 'instance_number' )
         OR B.INSTANCE_NUM IS NULL )
ORDER BY A.SEGMENT_NAME, A.TABLESPACE_NAME
";

   $text = "Rollback segments";
   $link = "$scriptname?database=$database&object_type=ROLLBACK";
   DisplayTable($sql,$text,$link);

# Show gets and waits percentages for performance 

   $sql = "
SELECT 
   SUM(VALUE)
FROM V\$SYSSTAT
   WHERE NAME IN
('db block gets','consistent gets')
";
   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   $foo = $cursor->fetchrow_array;
   $cursor->finish;

   $sql = "
SELECT 
   TO_CHAR(SUM(VALUE),'999,999,999,999') \"Total gets\"
FROM V\$SYSSTAT
   WHERE NAME IN
('db block gets','consistent gets')
";
   $text = "Total gets";
   $link = "";
   DisplayTable($sql,$text,$link);
   
   $sql = "
SELECT 
   CLASS				\"Class\",
   TO_CHAR(COUNT,'999,999,999,999')	\"Count\", 
   TO_CHAR(COUNT/$foo,'99.99')		\"Wait %\"
   FROM V\$WAITSTAT
WHERE CLASS IN
('system undo header','system undo block','undo header','undo block')
";

   $text = "Wait statistics.<BR>If any wait% is greater than 1, you need to add rollbacks.";
   $link = "";
   DisplayTable($sql,$text,$link);
}

sub showContention {

   my ($sql,$text,$link,$nulltext);

# Locking contention information

   $sql = "
SELECT DISTINCT 
   O.OBJECT_NAME			\"Object_name\",
   SH.USERNAME				\"Holding username\",
   SH.SID				\"Holder SID\",
   SW.USERNAME				\"Waiting username\",
   SW.SID				\"Waiter SID\",
   DECODE(LH.LMODE,
	1, 'null', 
	2, 'row share', 
	3, 'row exclusive', 
	4,  'share', 
	5, 'share row exclusive', 
	6, 'exclusive')			\"Mode held\"
  FROM DBA_OBJECTS O,
       V\$SESSION SW, 
       V\$LOCK LW, 
       V\$SESSION SH, 
       V\$LOCK LH
WHERE LH.ID1  = O.OBJECT_ID
AND  LH.ID1  = LW.ID1
AND  SH.SID  = LH.SID
AND  SW.SID  = LW.SID
AND  SH.LOCKWAIT IS NULL
AND  SW.LOCKWAIT IS NOT NULL
AND  LH.TYPE = 'TM'
AND  LW.TYPE = 'TM'
";

   $text = "Object lock contention info";
   $link = "";
   $nulltext = "No object lock contention found.";
   DisplayTable($sql,$text,$link,$nulltext);

# Locked objects (Not neccessarily contending).

   $sql = "
SELECT 
   A.OBJECT_NAME				\"Object_name\",
   A.OWNER					\"Owner\",
   B.OBJECT_ID					\"Object ID\",
   B.SESSION_ID					\"SID\",
   B.ORACLE_USERNAME				\"Oracle user\",
   B.PROCESS					\"OS process ID\",
   DECODE(B.LOCKED_MODE,
			0,'None',
			1,'Null',
			2,'Row-S (SS)',
			3,'Row-X (SX)',
			4,'Share',
			5,'S/Row-X (SSX)',
			6,'Exclusive')		\"Locked mode\"
FROM DBA_OBJECTS A, V\$LOCKED_OBJECT B
   WHERE A.OBJECT_ID = B.OBJECT_ID
ORDER BY A.OBJECT_NAME, A.OWNER
";

   $text = "Object lock info";
   $link = "";
   $nulltext = "No object locks found.";
   DisplayTable($sql,$text,$link,$nulltext);

# Session wait information

$sql = "
SELECT 
   SES.USERNAME				\"Username\",
   SW.SID				\"SID\",
   SW.EVENT				\"Event\"
FROM V\$SESSION SES,
     V\$SESSION_WAIT SW
WHERE SES.SID = SW.SID
AND SES.USERNAME IS NOT NULL
";

   $text = "Session wait info";
   $link = "";
   $nulltext = "No waits found.";
   DisplayTable($sql,$text,$link,$nulltext);
}

sub showRefreshgroups {

   my ($sql,$cursor,$text,$link,$nulltext);

#   $sql = "
#SELECT
#   OWNER		\"Refresh owner\",
#   NAME			\"Refresh Name\",
#   TABLE_NAME		\"Table name\",
#   MASTER_VIEW		\"Master view\",
#   MASTER_OWNER		\"Master owner\",
#   MASTER		\"Master table\",
#   MASTER_LINK		\"DB link\",
#   CAN_USE_LOG		\"Log?\",
#   UPDATABLE		\"Updatable?\",
#   TO_CHAR(LAST_REFRESH,'Month DD, YYYY - HH24:MI') \"Last refresh\"
#FROM DBA_SNAPSHOTS
#";

#   $text = "Parent snapshots";
#   $link = "$scriptname?database=$database&object_type=SNAPINFO";
#   $nulltext = "";
#   DisplayTable($sql,$text,$link,$nulltext);

   $sql = "
SELECT 
   REFGROUP						\"Group ID\",
   ROWNER						\"Group owner\",
   RNAME						\"Group name\",
   ROLLBACK_SEG						\"Rollback\",
   PUSH_DEFERRED_RPC					\"Push changes?\",
   JOB							\"Job ID\",
   TO_CHAR(NEXT_DATE,'Month DD, YYYY - HH24:MI')		\"Next date\",
   BROKEN						\"Broken?\",
   PURGE_OPTION						\"Purge option\",
   PARALLELISM						\"Parallelism\"
FROM DBA_REFRESH
";

   $text = "Refresh groups";
   $link = "$scriptname?database=$database&object_type=REFRESHINFO";
   $nulltext = "No refresh groups";
   DisplayTable($sql,$text,$link,$nulltext);

}

sub showRefreshinfo {

   my ($sql,$cursor,$text,$link,$nulltext);

   $sql = "
SELECT
   OWNER						\"Owner\",
   NAME							\"Name\",
   TYPE							\"Type\",
   ROLLBACK_SEG						\"Rollback\",
   PUSH_DEFERRED_RPC					\"Push changes?\",
   JOB							\"Job ID\",
   TO_CHAR(NEXT_DATE,'Month DD, YYYY - HH24:MI')		\"Next date\",
   BROKEN						\"Broken?\",
   PURGE_OPTION						\"Purge option\",
   PARALLELISM						\"Parallelism\"
FROM DBA_REFRESH_CHILDREN
   WHERE REFGROUP = $object_name
";

   $text = "Refresh group children";
   $link = "";
   $nulltext = "No refresh group children";
   DisplayTable($sql,$text,$link,$nulltext);
}

sub showRepmaster {

   my ($sql,$cursor,$text,$link,$nulltext);

   $sql = "
SELECT
   SNAPSHOT_ID		\"Snap ID\",
   NAME			\"Name\",
   OWNER		\"Owner\",
   SNAPSHOT_SITE	\"Snap site\",
   CAN_USE_LOG		\"Use log?\",
   UPDATABLE		\"Updatable?\",
   REFRESH_METHOD	\"Refresh method\",
   VERSION		\"Version\"
FROM DBA_REGISTERED_SNAPSHOTS
";

   $text = "Registered snapshots";
   $link = "$scriptname?database=$database&object_type=SNAPINFO";
   $nulltext = "";
   DisplayTable($sql,$text,$link,$nulltext);

}   

sub showSnapinfo {

   my ($sql,$cursor,$text,$link,$nulltext);

   $sql = "
SELECT
   NAME			\"Name\",
   OWNER		\"Owner\",
   SNAPSHOT_SITE	\"Snap site\"
FROM DBA_REGISTERED_SNAPSHOTS
   WHERE SNAPSHOT_ID = $object_name
";

   $text = "Detailed snapshot info";
   $link = "";
   $nulltext = "";
   DisplayTable($sql,$text,$link,$nulltext);

   $sql = "
SELECT 
   QUERY_TXT		\"Query text\"
FROM DBA_REGISTERED_SNAPSHOTS
   WHERE SNAPSHOT_ID = $object_name
";

   $text = "";
   DisplayLongData($sql,$text);

   $sql = "
SELECT 
   LOG_TABLE		\"Log table\",
   MASTER		\"Master\",
   LOG_OWNER		\"Log owner\",
   ROWIDS		\"Rowids?\",
   PRIMARY_KEY		\"Primary key?\",
   FILTER_COLUMNS	\"Filter columns?\",
   TO_CHAR(CURRENT_SNAPSHOTS,'Month DD, YYYY - HH24:MI') \"Current snapshot\"
FROM DBA_SNAPSHOT_LOGS
   WHERE SNAPSHOT_ID = $object_name
";
   

   $text = "Snapshot log table";
   $link = "";
   $nulltext = "No snapshot log table for this snapshot.";
   DisplayTable($sql,$text,$link,$nulltext);

}

sub showControlfiles {

   my ($sql,$cursor,$text,$link,$nulltext);
   my ($alloc,$used,$alloc_total,$used_total);

   $sql = "
SELECT
   NAME				\"Name\",
   DECODE (STATUS,'','OK')	\"Status\"
FROM V\$CONTROLFILE
";

   $text = "Controlfile info";
   $link = "";
   $nulltext = "There is something terribly wrong...";
   DisplayTable($sql,$text,$link,$nulltext);

   if ($oracle8) {

      $sql = "
SELECT 
   RECORDS_TOTAL*RECORD_SIZE,
   RECORDS_USED*RECORD_SIZE
FROM V\$CONTROLFILE_RECORD_SECTION
";

   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   while (($alloc,$used) = $cursor->fetchrow_array) {
      $alloc_total += $alloc;
      $used_total  += $used;
   }
   $cursor->finish;

   $sql = "
SELECT 
   TO_CHAR($alloc_total,'999,999,999,999')	\"Total allocated\",
   TO_CHAR($used_total,'999,999,999,999')	\"Total used\"
FROM DUAL
";

   $text = "Controlfile record space usage";
   $link = "";
   $nulltext = "There is something terribly wrong...";
   DisplayTable($sql,$text,$link,$nulltext);

      $sql = "
SELECT
   DECODE(TYPE,
      'DATABASE','Database',
      'CKPT PROGRESS','Checkpoint progress',
      'REDO THREAD','Redo thread',
      'REDO LOG','Redo log',
      'DATAFILE','Datafile',
      'FILENAME','Filename',
      'TABLESPACE','Tablespace',
      'LOG HISTORY','Log history',
      'OFFLINE RANGE','Offline range',
      'ARCHIVED LOG','Archived log',
      'BACKUP SET','Backup set',
      'BACKUP PIECE','Backup piece',
      'BACKUP DATAFILE','Backup datafile',
      'BACKUP REDOLOG','Backup redolog',
      'DATAFILE COPY','Datafile copy',
      'BACKUP CORRUPTION','Backup corruption',
      'COPY CORRUPTION','Copy corruption',
      'DELETED OBJECT','Deleted object','Reserved')			\"Record type\",
   TO_CHAR(RECORD_SIZE,'999,999,999,999')				\"Record size\",
   TO_CHAR(RECORDS_TOTAL,'999,999,999,999')				\"Records total\",
   TO_CHAR(RECORDS_USED,'999,999,999,999')				\"Records used\",
   TO_CHAR(RECORDS_TOTAL*RECORD_SIZE,'999,999,999,999')			\"Space allocated\",
   TO_CHAR(RECORDS_USED*RECORD_SIZE,'999,999,999,999')			\"Space used\"
FROM V\$CONTROLFILE_RECORD_SECTION
";

   $text = "Controlfile record info";
   $link = "";
   $nulltext = "There is something terribly wrong...";
   DisplayTable($sql,$text,$link,$nulltext);

   }

}


sub showArchiving {

   my ($sql,$cursor,$value,$log_archive_dest,$text,$link,$nulltext);

   $sql = "
SELECT 
   VALUE FROM V\$PARAMETER
WHERE NAME = 'log_archive_dest'
";

   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   $value = $cursor->fetchrow_array;

   $log_archive_dest .= $value;

   $sql = "
SELECT 
   VALUE FROM V\$PARAMETER
WHERE NAME = 'log_archive_format'
";

   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   $value = $cursor->fetchrow_array;

   $log_archive_dest .= $value;

   print <<"EOF";
<TABLE BORDER=1>
  <TH>Archive log destination / format</TH>
  <TR>
    <TD>$log_archive_dest</TD>
  </TR>
</TABLE>
EOF

   $sql = "
SELECT 
   THREAD#							\"Thread#\",
   SEQUENCE#							\"Sequence#\",
   TIME								\"Time of first entry\",
   LOW_CHANGE#							\"Lowest  SCN\",
   (HIGH_CHANGE#-1)						\"Highest SCN\",
   ARCHIVE_NAME							\"Archived log name\"
FROM V\$LOG_HISTORY
ORDER BY SEQUENCE# DESC
" if ($oracle7);

   $sql = "
SELECT 
   THREAD#							\"Thread#\",
   SEQUENCE#							\"Sequence#\",
   TO_CHAR(FIRST_TIME,'Day, Month DD YYYY - HH24:MI:SS')	\"Time of first entry\",
   FIRST_CHANGE#						\"Lowest  SCN\",
   NEXT_CHANGE#							\"Highest SCN\",
   RECID							\"Controlfile RecID\",
   STAMP							\"Controlfile stamp\"
FROM V\$LOG_HISTORY
ORDER BY SEQUENCE# DESC
" if ($oracle8);

   $sql = "
SELECT 
   THREAD#							\"Thread#\",
   SEQUENCE#							\"Sequence#\",
   TO_CHAR(FIRST_TIME,'Day, Month DD YYYY - HH24:MI:SS')	\"Time of first entry\",
   FIRST_CHANGE#						\"Lowest  SCN\",
   NEXT_CHANGE#							\"Highest SCN\",
   RECID							\"Controlfile RecID\",
   STAMP							\"Controlfile stamp\"
FROM V\$LOG_HISTORY
   WHERE THREAD# = (
SELECT VALUE FROM V\$PARAMETER
   WHERE NAME = 'thread')
ORDER BY SEQUENCE# DESC
" if ( ($oracle8) && (parallel()) );


   $text = "Archived redo log info";
   $link = "";
   $nulltext = "There are no archived redologs to report on.";
   DisplayTable($sql,$text,$link,$nulltext);



}

sub showRedo {

   my ($sql,$cursor,$value,$text,$link);

   $sql = "
SELECT
   VALUE FROM V\$PARAMETER
WHERE NAME = 'log_archive_start'
";

   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   $value = $cursor->fetchrow_array;

   if ( $value eq "TRUE" ) {

      print <<"EOF";
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
  <TR>
    <TD ALIGMN=CENTER>
      <FORM METHOD="GET" ACTION="$scriptname">
        <INPUT TYPE="HIDDEN" NAME="database" VALUE="$database">
        <INPUT TYPE="HIDDEN" NAME="object_type" VALUE="ARCHIVING">
        <INPUT TYPE="SUBMIT" NAME="archiving" VALUE="Archiving information">
      </FORM>
    </TD>
  </TR>
</TABLE>
EOF
    } else {
      message("Database archiving is not enabled.");
   }


# Online redo log information

   $sql = "
SELECT
   A.MEMBER				\"Member\",
   B.GROUP#				\"Group#\",
   B.THREAD#				\"Thread#\",
   B.SEQUENCE#				\"Sequence#\",
   TO_CHAR(B.BYTES,'999,999,999,999')	\"Bytes\",
   B.MEMBERS				\"Members\",
   B.ARCHIVED				\"Archived\",
   B.STATUS				\"Status\"
FROM V\$LOGFILE A, V\$LOG B
   WHERE A.GROUP# = B.GROUP#
ORDER BY A.MEMBER
";

   $text = "Online redo log info";
   $link = "";
   DisplayTable($sql,$text,$link);

   $sql = "
SELECT
   TO_CHAR(FIRST_TIME,'Mon DD')			\"Date\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'00',1,0)),'99')	\"00\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'01',1,0)),'99')	\"01\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'02',1,0)),'99')	\"02\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'03',1,0)),'99')	\"03\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'04',1,0)),'99')	\"04\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'05',1,0)),'99')	\"05\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'06',1,0)),'99')	\"06\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'07',1,0)),'99')	\"07\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'08',1,0)),'99')	\"08\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'09',1,0)),'99')	\"09\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'10',1,0)),'99')	\"10\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'11',1,0)),'99')	\"11\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'12',1,0)),'99')	\"12\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'13',1,0)),'99')	\"13\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'14',1,0)),'99')	\"14\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'15',1,0)),'99')	\"15\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'16',1,0)),'99')	\"16\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'17',1,0)),'99')	\"17\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'18',1,0)),'99')	\"18\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'19',1,0)),'99')	\"19\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'20',1,0)),'99')	\"20\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'21',1,0)),'99')	\"21\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'22',1,0)),'99')	\"22\",
   TO_CHAR(SUM(DECODE(TO_CHAR(FIRST_TIME,'HH24'),'23',1,0)),'99')	\"23\"
FROM V\$LOG_HISTORY
   GROUP BY TO_CHAR(FIRST_TIME,'Mon DD')
" if $oracle8;

   $sql = "
SELECT
   SUBSTR(TIME,1,5)			\"Day\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'00',1,0)),'99')	\"00\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'01',1,0)),'99')	\"01\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'02',1,0)),'99')	\"02\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'03',1,0)),'99')	\"03\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'04',1,0)),'99')	\"04\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'05',1,0)),'99')	\"05\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'06',1,0)),'99')	\"06\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'07',1,0)),'99')	\"07\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'08',1,0)),'99')	\"08\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'09',1,0)),'99')	\"09\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'10',1,0)),'99')	\"10\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'11',1,0)),'99')	\"11\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'12',1,0)),'99')	\"12\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'13',1,0)),'99')	\"13\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'14',1,0)),'99')	\"14\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'15',1,0)),'99')	\"15\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'16',1,0)),'99')	\"16\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'17',1,0)),'99')	\"17\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'18',1,0)),'99')	\"18\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'19',1,0)),'99')	\"19\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'20',1,0)),'99')	\"20\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'21',1,0)),'99')	\"21\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'22',1,0)),'99')	\"22\",
   TO_CHAR(SUM(DECODE(SUBSTR(TIME,10,2),'23',1,0)),'99')	\"23\"
FROM V\$LOG_HISTORY
   GROUP BY SUBSTR(TIME,1,5)
" if $oracle7;

   $text = "Graph of log switch history by day and hour";
   $link = "";
   DisplayTable($sql,$text,$link);

}

sub showSessions {

# Instance session information

   my ($sql,$text,$cursor,$numfields,@row,$counter1,$counter2,$count,$paddr);
   my (@username,@osuser,@sid,@serial,@status,@process,@program,@command,@address,@hash_value,@rows_processed,@logon_time,@sqltext);

   my $user = shift;

# If user is not "%", then count the number of sessions
# and show a message if there is none.

   if ( $user ne "%" ) {
      $sql = "
SELECT COUNT(*) FROM V\$SESSION
   WHERE USERNAME = '$user'
";
      $cursor = $dbh->prepare($sql);
      $cursor->execute;
      $count = $cursor->fetchrow_array;
      $cursor->finish;
      if ( $count == 0 ) {
         message("$user has no sessions in this instance.");
         Footer();
         exit;
      }
    } else {
      DisplayGraph("sessions","","Active and inactive session history");
   }

   print "</CENTER>\n";

   $sql = "
SELECT DISTINCT
   S.USERNAME,
   S.OSUSER,
   S.SID,
   S.SERIAL#,
   S.STATUS,
   S.PROCESS,
   S.PROGRAM,
   DECODE(S.COMMAND,
	'0','No command in progress',
	'1','Create table',
	'2','Insert',
	'3','Select',
	'4','Create cluster',
	'5','Alter cluster',
	'6','Update',
	'7','Delete',
	'8','Drop cluster',
	'9','Create index',
	'10','Drop index',
	'11','Alter index',
	'12','Drop table',
	'13','Create sequence',
	'14','Alter sequence',
	'15','Alter table',
	'16','Drop sequence',
	'17','Grant',
	'18','Revoke',
	'19','Create synonym',
	'20','Drop synonym',
	'21','Create view',
	'22','Drop view',
	'23','Validate index',
	'24','Create procedure',
	'25','Alter procedure',
	'26','Lock table',
	'27','No operation in progress',
	'28','Rename',
	'29','Comment',
	'30','Audit',
	'31','Noaudit',
	'32','Create database link',
	'33','Drop database link',
	'34','Create database',
	'35','Alter database',
	'36','Create rollback segment',
	'37','Alter rollback segment',
	'38','Drop rollback segment',
	'39','Create tablespace',
	'40','Alter tablespace',
	'41','Drop tablespace',
	'42','Alter session',
	'43','Alter user',
	'44','Commit',
	'45','Rollback',
	'46','Savepoint',
	'47','PL/SQL Execute',
	'48','Set transaction',
	'49','Alter system switch log',
	'50','Explain',
	'51','Create user',
	'52','Create role',
	'53','Drop user',
	'54','Drop role',
	'55','Set role',
	'56','Create schema',
	'57','Create control file',
	'58','Alter tracing',
	'59','Create trigger',
	'60','Alter trigger',
	'61','Drop trigger',
	'62','Analyze table',
	'63','Analyze index',
	'64','Analyze cluster',
	'65','Create profile',
	'66','Drop profile',
	'67','Alter profile',
	'68','Drop procedure',
	'69','Drop procedure',
	'70','Alter resource cost',
	'71','Create snapshot log',
	'72','Alter snapshot log',
	'73','Drop snapshot log',
	'74','Create snapshot',
	'75','Alter snapshot',
	'76','Drop snapshot',
	'79','Alter role',
	'85','Truncate table',
	'86','Truncate cluster',
	'88','Alter view',
	'91','Create function',
	'92','Alter function',
	'93','Drop function',
	'94','Create package',
	'95','Alter package',
	'96','Drop package',
	'97','Create package body',
	'98','Alter package body',
	'99','Drop package body'),
   TO_CHAR(S.LOGON_TIME,'Day, Month DD HH24:MI'),
   T.ADDRESS,
   T.HASH_VALUE,
   MAX(Q.ROWS_PROCESSED)
FROM V\$SESSION S, V\$SQLTEXT T, V\$SQL Q
   WHERE S.USERNAME IS NOT NULL 
   AND S.USERNAME LIKE '$user'
   AND S.SQL_ADDRESS = T.ADDRESS(+) 
   AND S.SQL_ADDRESS = Q.ADDRESS(+)
   AND S.SQL_HASH_VALUE = T.HASH_VALUE(+)
   AND S.SQL_HASH_VALUE = Q.HASH_VALUE(+)
GROUP BY S.USERNAME, S.OSUSER, S.SID, S.SERIAL#, S.STATUS, S.PROCESS, S.PROGRAM, S.COMMAND, S.LOGON_TIME, T.ADDRESS, T.HASH_VALUE
";

   $cursor = $dbh->prepare($sql);
   print $DBI::errstr unless ($cursor);
   $cursor->execute;
   $numfields = $cursor->{NUM_OF_FIELDS};
   $counter1=0;
   while (@row = $cursor->fetchrow_array) {
      $username[$counter1]		= $row[0];
      $osuser[$counter1]		= $row[1];
      $sid[$counter1]			= $row[2];
      $serial[$counter1]		= $row[3];
      $status[$counter1]		= $row[4];
      $process[$counter1]		= $row[5];
      $program[$counter1]		= $row[6];
      $command[$counter1]		= $row[7];
      $logon_time[$counter1]		= $row[8];
      $address[$counter1]		= $row[9];
      $hash_value[$counter1]		= $row[10];
      $rows_processed[$counter1]	= $row[11];
      $counter1++;
   }
   $cursor->finish;

   $counter2 = 0;

   foreach (@address) {
      $sql = "
SELECT 
   SQL_TEXT, 
   PIECE 
FROM V\$SQLTEXT 
   WHERE ADDRESS = '$address[$counter2]' 
   ORDER BY PIECE
";
   $cursor = $dbh->prepare($sql);
   $cursor->execute;
   while (@row = $cursor->fetchrow_array) {
      $sqltext[$counter2] = "$sqltext[$counter2]$row[0]";
    }
   $cursor->finish;
# Check for processes with a ':' in them. These would be remote connections.
# Resolve the bad process ID's 
   if ($process[$counter2] =~ /:/) {
      $sql = "
SELECT PADDR FROM V\$SESSION 
   WHERE SID = $sid[$counter2]
   AND SERIAL# = $serial[$counter2]
";
      $cursor=$dbh->prepare($sql);
      $cursor->execute;
      $paddr = $cursor->fetchrow_array;
      $cursor->finish;
            $sql = "
SELECT SPID FROM V\$PROCESS
   WHERE ADDR = '$paddr'
";
      $cursor=$dbh->prepare($sql);
      $cursor->execute;
      $process[$counter2] = $cursor->fetchrow_array;
      $cursor->finish;
   }
   print << "EOF";
<TABLE BORDER>
  <TR><TH ALIGN=LEFT>Oracle username</TH><TD>$username[$counter2]&nbsp&nbsp&nbsp&nbsp&nbsp<A HREF="$scriptname?database=$database&object_type=SESSIONSTATS&schema=$sid[$counter2]">Display session statistics</A></TD></TR>
  <TR><TH ALIGN=LEFT>OS username</TH><TD>$osuser[$counter2]</TD></TR>
  <TR><TH ALIGN=LEFT>SID</TH><TD>$sid[$counter2]</TD></TR>
  <TR><TH ALIGN=LEFT>Serial#</TH><TD>$serial[$counter2]</TD></TR>
  <TR><TH ALIGN=LEFT>Status</TH><TD>$status[$counter2]</TD></TR>
  <TR><TH ALIGN=LEFT>Process</TH><TD>$process[$counter2]</TD></TR>
  <TR><TH ALIGN=LEFT>Program</TH><TD>$program[$counter2]</TD></TR>
  <TR><TH ALIGN=LEFT>Command</TH><TD>$command[$counter2]</TD></TR>
  <TR><TH ALIGN=LEFT>Rows processed</TH><TD>$rows_processed[$counter2]</TD></TR>
  <TR><TH ALIGN=LEFT>Logon time</TH><TD>$logon_time[$counter2]</TD></TR>
  <TR><TH ALIGN=LEFT>SQL text</TH><TD>$sqltext[$counter2]</TD></TR>
</TABLE>   
<HR WIDTH="5%" ALIGN=LEFT>
EOF
   $counter2++;
   }
}

sub GetTNS {

# Usage: @tns_entries = GetTNS();
# If you have ever wondered why Russia was first in space, check out the hacks below!
# Many thanks to Dima Dorofeev.

# Returns the database connection strings defined in the tnsnames.ora.
# Also removes duplicates and sorts alphabetically. Duplicates can show
# up because the DBI->data_sources checks both the tnsnames.ora file
# and the oratab file. There are several possibilities here, I'm waiting
# to see if there are any complaints before I remove the others.

# 1  my %hash =  map { (split(':'))[-1] , undef } DBI->data_sources('Oracle');
# 2  my %hash = map { /\:(\w[\w-]*)(?:\.world){0,1}$/i , undef } DBI->data_sources('Oracle');
#   delete($hash{""});
# 3  my %hash = map { /\:([\.\w]+)(?:\.world){0,1}$/i , undef } DBI->data_sources('Oracle');
   my %hash = map { (split(/\.world/i,(split(':'))[-1]))[0] , undef } DBI->data_sources('Oracle');
   return sort keys %hash;
}

sub ObjectTable {

# Usage: ObjectTable ($dbh,$sql,$text,$nulltext);

# This sub is specifically for displaying a table with
# database object name, type, and owner.
# It will make each entry a hyperlink to obtain additional
# information about the object.

   my $sql	= shift;
   my $text	= shift;
   my $nulltext	= shift;

   my ($cursor,@row,$object_name,$object_type,$schema,$count,$numfields,$field,$name);

   $nulltext = "<FONT COLOR=\"$nullcolor\">$nulltext</FONT>";

   $cursor = $dbh->prepare($sql) or ErrorPage ("$DBI::errstr");
   $cursor->execute or ErrorPage ("$DBI::errstr");

   while (@row = $cursor->fetchrow_array) {
      $count++;
   }
   $cursor->finish or ErrorPage ("$DBI::errstr");
   if ($count != 0) {

      $cursor = $dbh->prepare($sql) or ErrorPage ("$DBI::errstr");
      $cursor->execute or ErrorPage ("$DBI::errstr");

      print "<P><B>$text</B></P>\n" if defined $text;
      print "<TABLE BORDER=1>\n";
      $cursor = $dbh->prepare($sql) or ErrorPage ("$DBI::errstr");
      $cursor->execute or ErrorPage ("$DBI::errstr");
      $numfields = $cursor->{NUM_OF_FIELDS};

      for ($field=0; $field < $numfields; $field++) {
         $name = $cursor->{NAME}->[$field];
         print "<TH>$name</TH>";
      }
      while (@row = $cursor->fetchrow_array) {
         $object_name	=$row[0];
         $object_type	=$row[1];
         $schema	=$row[2];
         print "<TR ALIGN=LEFT>";
         $_ = $row[1];
         s/ /+/;
         $object_type = $_;
         for ($field=0; $field < $numfields; $field++) {
            print "<TD";
            print " ALIGN=RIGHT" if ($row[$field] =~ /^\s*\.?\d/);
            print "><A href=$scriptname?database=$database&arg=$object_name&object_type=$object_type&schema=$schema>$row[$field]</A></TD>\n";
#            print "<TD><A href=$scriptname?database=$database&arg=$object_name&object_type=$object_type&schema=$schema>$row[$field]</A></TD>\n";
         }
      print "</TR>\n";
      }
      print "</TABLE>\n";
      $cursor->finish or ErrorPage ("$DBI::errstr");
   } else {
      print "<P><B>$nulltext</B></P>\n" if ( defined $nulltext );
   }
}

sub DisplayColTable {

# Usage: DisplayColTable ($sql,$text,$link,$nulltext,$cols);

# This sub is for displaying a table of 'n' columns
# wide from a query that returns a single column of
# data. 
# The first arg is the SQL you want to execute.
# The second arg (text) is for optionally putting a text description
# of the outputted data above the table.
# The third argument is to optionally make the table output
# a hyperlink. the hyperlink will use the data in the first column
# as an argument to whatever the link is pointing to.
# The fourth argument is the text that you want to display if
# no rows are returned from the query.
# The fifth argument is the number of columns wide you want the table
# to be.

   my $sql      = shift;
   my $text     = shift;
   my $link     = shift;
   my $nulltext = shift;
   my $cols	= shift;
   my $counter	= 0;

   my ($cursor,$row);

   $dbh->{LongReadLen} = 2048;

   $nulltext = "<FONT COLOR=\"$nullcolor\">$nulltext</FONT>";

   $cursor = $dbh->prepare($sql);
   $cursor->execute;
   print "<P><B>$text</B></P>\n" if defined $text;
   print "<TABLE BORDER=1>\n";
   while ($row = $cursor->fetchrow_array) {
      print "  <TR ALIGN=CENTER>" if $counter == 0;
      if ($link) {
         print "    <TD><A href=$link&schema=$row&arg=$row>$row</A></TD>\n";
      } else {
         print "    <TD>$row</TD>\n";
      }
      $counter++;
      print "  </TR>" if $counter == 0;
      if ($counter == $cols) { $counter = 0 };
   }
   print "</TABLE>\n\n";

   $cursor->finish;
}

   
sub DisplayTable {

# Usage:  DisplayTable ($sql,$text,$link,$nulltext);

# This sub is for formatting the output of a SQL query. The
# output will have the column headings in bold with the data
# in a HTML table.
# The first arg is the SQL you want to execute.
# The second arg (text) is for optionally putting a text description
# of the outputted data above the table.
# The third argument is to optionally make the table output
# a hyperlink. the hyperlink will use the data in the first column
# as an argument to whatever the link is pointing to.
# The fourth argument is the text that you want to display if
# no rows are returned from the query.

   my $sql	= shift;
   my $text	= shift;
   my $link	= shift;
   my $nulltext	= shift;
   my $count = 0;

   $dbh->{LongReadLen} = 2048;

   $nulltext = "<FONT COLOR=\"$nullcolor\">$nulltext</FONT>";

   my ($cursor,@row,$numfields,$field,$name,$arg);

   if ( $link eq "" ) {
      undef $link;
   }

   $cursor = $dbh->prepare($sql) or return($DBI::errstr);
   $cursor->execute or return($DBI::errstr);

   while (@row = $cursor->fetchrow_array) {
      $count++;
   }
   $cursor->finish or return("$DBI::errstr");
   if ($count != 0) {
      print "<P><B>$text</B></P>\n" if defined $text;
      print "<TABLE BORDER=1>\n";
      $cursor = $dbh->prepare($sql) or return($DBI::errstr);
      $cursor->execute or return($DBI::errstr);
      $numfields = $cursor->{NUM_OF_FIELDS};

      for ($field=0; $field < $numfields; $field++) {
         $name = $cursor->{NAME}->[$field];
         print "<TH>$name</TH>";
      }

      while (@row = $cursor->fetchrow_array) {
#         foreach (@$row) { $_ = '' unless defined }
         print "<TR ALIGN=LEFT>";
         for (my $field=0; $field < $numfields; $field++) {
            if ($field == 0) {
               $_ = $row[$field];
               s/ /+/;
               $arg = $_;
            }
            print "<TD VALIGN=TOP";
            print " ALIGN=RIGHT" if ($row[$field] =~ /^\s*\.?\d/);
            print ">$row[$field]</TD>\n" if ! defined $link;
            print "><A href=$link&arg=$arg>$row[$field]</A></TD>\n" if defined $link;
         }
      print "</TR>\n";
      }
      print "</TABLE>\n";
      $cursor->finish or return("$DBI::errstr");
   } else {
      print "<P><B>$nulltext</B></P>\n" if ( defined $nulltext );
   }
   return($DBI::errstr);
}

sub DisplayPiecedData {

# Usage:   DisplayPiecedData ($sql,$text,$link)

# This is for formatting the output of a SQL query. The
# output will have the column headings in bold with the data
# in a HTML table. This sub should be used for data retrieved
# from tables which have the data in pieces such as dba_source,
# and v$sql.
# The first arg is the SQL you want to execute.
# The second arg (text) is for optionally putting a text description
# of the outputted data above the table.
# The third argument is to optionally make the table output
# a hyperlink. the hyperlink will use the data in the first column
# as an argument to whatever the link is pointing to.

   my $sql   = shift;
   my $text  = shift;
   my $link  = shift;
   my $count = 0;

   my ($cursor,@row,$numfields,$field,$name,$arg,$row,$data);

   if ( $link eq "" ) {
      undef $link;
   }

   $cursor = $dbh->prepare($sql) or ErrorPage ("$DBI::errstr");
   $cursor->execute or ErrorPage ("$DBI::errstr");
   while (@row = $cursor->fetchrow_array) {
      $count++;
   }
   $cursor->finish or ErrorPage ("$DBI::errstr");
   if ($count != 0) {
      print "<P><B>$text</B></P>\n" if defined $text;
      print "<TABLE BORDER=1>\n";
      $cursor = $dbh->prepare($sql) or ErrorPage ("$DBI::errstr");
      $cursor->execute or ErrorPage ("$DBI::errstr");
      $numfields = $cursor->{NUM_OF_FIELDS};

      for ($field=0; $field < $numfields; $field++) {
         $name = $cursor->{NAME}->[$field];
         print "<TH>$name</TH>";
      }

      while ($_ = $cursor->fetchrow_array) {
            s/</&lt;/g;
            s/>/&gt;/g;
            $row = $_;
            $data = "$data$row";
      }
      print "<TR>";
      print "<TD><PRE>$data</PRE></TD>" if ! defined $link;
      print "<TD><PRE><A href=$link&arg=$arg>$data</A></PRE></TD>" if defined $link;
      print "</TR>";
      print "</TABLE>\n\n";

      $cursor->finish or ErrorPage ("$DBI::errstr");
   }
}

sub DisplayLongData {

# Usage: DisplayLongData ($sql,$text)

# This is for formatting the output of a SQL query that fetches
# LONG datatypes, which is a real pain in the ass with DBD. The
# output will have the column headings in bold with the data
# in a HTML table.
# The first arg is the SQL you want to execute.
# The second arg (text) is for optionally putting a text description
# of the outputted data above the table.

   my $sql   = shift;
   my $text  = shift;
   my $count = 0;

   my ($cursor,@row,$lump,$offset,$frag,$ll);
   my ($numfields,$field,$name,$arg,$row,$data);

   $cursor = $dbh->prepare($sql) or ErrorPage ("$DBI::errstr");
   $cursor->execute or ErrorPage ("$DBI::errstr");
   print "<P><B>$text</B></P>\n" if defined $text;
   print "<TABLE BORDER=1>\n";
   $cursor = $dbh->prepare($sql) or ErrorPage ("$DBI::errstr");
   $cursor->execute or ErrorPage ("$DBI::errstr");
   $numfields = $cursor->{NUM_OF_FIELDS};

   for ($field=0; $field < $numfields; $field++) {
      $name = $cursor->{NAME}->[$field];
      print "<TH>$name</TH>";
   }

   @row = $cursor->fetchrow_array;
#   foreach (@$row) { $_ = '' unless defined }
   $row = '';
   $lump = 4096;
   $offset = 0;
   while (1)
   {
      $frag = $cursor->blob_read(0, $offset, $lump);
      last unless defined $frag;
      $ll = length $frag;
      last unless $ll;
      $row .= $frag;
      $offset += $ll;
   }
   print "<TR>";
   print "<TD><PRE>$row</PRE></TD>";
   print "</TABLE>\n\n";

   $cursor->finish or ErrorPage ("$DBI::errstr");
}

sub Header {

# Usage: Header ($title,$heading,$font,$fontsize,$fontcolor,$bgcolor);

# Creates a HTML header with title

   my $title      = shift;
   my $heading    = shift;
   my $font       = shift;
   my $fontsize   = shift;
   my $fontcolor  = shift;
   my $bgcolor    = shift;

print "Content-type: multipart/x-mixed-replace; boundary=thisistheboundary\r\n";
print header(-type => 'text/html');
print << "EOF";
<HTML>
<HEAD>
<META HTTP-EQUIV="pragma" CONTENT="nocache">
<TITLE>$title</TITLE>
</HEAD>
<BODY BGCOLOR="$bgcolor" LINK="$linkcolor" ALINK="$linkcolor" VLINK="$linkcolor">
<FONT FACE="$font" SIZE="$fontsize" COLOR="$fontcolor">
EOF
Button("$scriptname?database=behelpful&schema=$object_type","Help!","$menucolor","RIGHT");
print << "EOF";
<BR><BR>
<CENTER>
EOF
   if ( $heading ne "" ) {
      print "$heading";
   }

}

sub framePage {

# Usage: framePage ($title,$heading,$font,$fontsize,$fontcolor,$bgcolor);

# Creates a HTML header with title

   my $title      = shift;
   my $heading    = shift;
   my $font       = shift;
   my $fontsize   = shift;
   my $fontcolor  = shift;
   my $bgcolor    = shift;

   my $schema	  = uc($username);

print << "EOF";
Content-type: Text/html\n\n
<HTML>
<HEAD>
  <TITLE>Oracletool v$VERSION: Connected to $database as $schema</TITLE>
</HEAD>
<FRAMESET COLS="150,*" BORDER="0">
<FRAME NAME="menu" SRC="$scriptname?database=$database&object_type=MENU">
<FRAME NAME="body" SRC="$scriptname?database=$database&schema=$schema&object_type=LISTUSERS">
</FRAMESET>
</HTML>
EOF
exit;
}

sub showMenu {

   my $schema = shift;

   print <<"EOF";
Content-type: Text/html\n\n
<HTML>
<BODY BGCOLOR="$bgcolor" LINK="$linkcolor" ALINK="$linkcolor" VLINK="$linkcolor">
<FONT FACE="" SIZE="2" COLOR="$fontcolor">
<CENTER>
<P>
<TABLE "WIDTH=100%">
  <TR WIDTH="100%">
    <TD VALIGN="TOP">
EOF
Button("$scriptname?database=$database&object_type=PARAMETERS TARGET=body","Init parameters","$menucolor");
Button("$scriptname?database=$database&object_type=TABLESPACES TARGET=body","Tablespaces","$menucolor");
Button("$scriptname?database=$database&object_type=DATAFILES TARGET=body","Datafiles","$menucolor");
Button("$scriptname?database=$database&object_type=REDOLOGS TARGET=body","Redo / Archives","$menucolor");
Button("$scriptname?database=$database&object_type=CONTROLFILES TARGET=body","Controlfiles","$menucolor");
Button("$scriptname?database=$database&object_type=SESSIONS TARGET=body","Session info","$menucolor");
Button("$scriptname?database=$database&object_type=CONTENTION TARGET=body","Locks / contends","$menucolor");
Button("$scriptname?database=$database&object_type=PERFORMANCE TARGET=body","Perf / memory","$menucolor");
Button("$scriptname?database=$database&object_type=ROLLBACKSEGS TARGET=body","Rollback segs","$menucolor");
#Button("$scriptname?database=$database&object_type=EXPLAINPLAN&schema=$schema TARGET=body","Explain plan (beta)","$menucolor");
Button("$scriptname?database=$database&object_type=WORKSHEET&schema=$schema TARGET=body","SQL Worksheet","$menucolor");
Button("$scriptname?database=$database&object_type=LISTUSERS TARGET=body","Schema list","$menucolor");
Button("$scriptname?database=$database&object_type=SECURITY TARGET=body","Security","$menucolor");
#Button("$scriptname?database=$database&object_type=HEALTHCHECK TARGET=body","Health check","$menucolor");
if ($oracle8) {
   if (repmaster()) {
      Button("$scriptname?database=$database&object_type=REPMASTER TARGET=body","Replication (M)","$menucolor");
   }
   if (repsnapshot()) {
      Button("$scriptname?database=$database&object_type=REFRESHGROUPS TARGET=body","Replication (S)","$menucolor");
   }
}
if (parallel()) {
   Button("$scriptname?database=$database&object_type=OPSPAGE TARGET=body","OPS specific","$menucolor");
}
Button("$scriptname TARGET=_top","Change connection","$menucolor");
#Button("","Db  : $database<BR>User: $schema","$menucolor");
   print <<"EOF";
      <FORM METHOD=POST ACTION=$scriptname TARGET=body>
        <INPUT TYPE="TEXT" NAME="arg" SIZE="10">
        <INPUT TYPE="HIDDEN" NAME="database" VALUE="$database">
        <INPUT TYPE="HIDDEN" NAME="object_type" VALUE="OBJECTSEARCH">
        <INPUT TYPE="SUBMIT" VALUE="Search">
      </FORM>
EOF
Button("$scriptname?database=About_oracletool TARGET=body","About","$menucolor");
print <<"EOF";
    </TD>
  </TR>
</TABLE>
EOF
exit;

}

sub Footer {

# Usage: Footer();

# Creates a HTML footer that refers back

print <<"EOF";
</BODY>
</HTML>
EOF
}

sub ErrorPage {

# Usage: ErrorPage ($message);

   my $message          = shift;
   my ($font,$fontsize,$fontcolor,$bgcolor);

   $font        = "";
   $fontsize    = "4";
   $fontcolor   = "#404040";
   $bgcolor     = "#A8A5BE";

print <<EOF;
Content-type: Text/html\n\n
<HTML>
  <HEAD>
    <TITLE>Error!</TITLE>
  </HEAD>
    <BODY BGCOLOR="$bgcolor">
      <FONT FACE="$font" SIZE="$fontsize" COLOR="$fontcolor">
      <CENTER>
      $message
      </CENTER>
  </BODY
</HTML>
EOF
exit(1);
}

sub TempPage {

# Usage: TempPage ($message,$duration,$url);

   my $message  = shift;
   my $duration = shift;
   my $url      = shift;

   my ($font,$fontsize,$fontcolor,$bgcolor);

   $font        = "";
   $fontsize    = "4";
   $fontcolor   = "#404040";
   $bgcolor     = "#A8A5BE";

print <<EOF;
Content-type: Text/html\n\n
<HTML>
  <HEAD>
    <TITLE>Notice!</TITLE>
    <META HTTP-EQUIV="Refresh" Content="$duration;URL=$url">
  </HEAD>
  <BODY BGCOLOR="$bgcolor">
    <FONT FACE="$font" SIZE="$fontsize" COLOR="$fontcolor">
    <CENTER>
      $message
    </CENTER
  </BODY
</HTML>
EOF
}

sub getDBblocksize {

# Find out the database block size

   my $sql = "
SELECT VALUE
   FROM V\$PARAMETER
WHERE NAME = 'db_block_size'
";

   my $cursor = $dbh->prepare($sql);
   $cursor->execute;
   my $db_block_size = $cursor->fetchrow_array;
   $cursor->finish;
   return ($db_block_size);
}

sub getBanner {

   my ($banner,$foo);

# Get the oracle version info

   my $sql = "
SELECT BANNER 
   FROM V\$VERSION
WHERE BANNER LIKE 'Oracle%'
";

   my $cursor = $dbh->prepare($sql);
   $cursor->execute;
   $banner = $cursor->fetchrow_array;
   $cursor->finish;

   $sql = "
SELECT
   TO_CHAR(TO_DATE(D.VALUE,'J'),'Day, Month DD, YYYY')||' -  '||
   TO_CHAR(TO_DATE(S.VALUE,'sssss'),'HH24:MI:SS')
FROM V\$INSTANCE D, V\$INSTANCE S
   WHERE D.KEY = 'STARTUP TIME - JULIAN'
   AND S.key = 'STARTUP TIME - SECONDS'
" if ($oracle7);

   $sql = "
SELECT
   TO_CHAR(STARTUP_TIME,'Day, Month DD, YYYY -  HH24:MI:SS')
FROM V\$INSTANCE
" if ($oracle8);

   $cursor = $dbh->prepare($sql);
   $cursor->execute;
   $foo = $cursor->fetchrow_array;
   $cursor->finish;

   $banner = "$banner<BR>Instance started on $foo<BR>";

   return($banner);
}

sub showTSgraph {

   my ($sql,$text,$link,$cursor,$tablespace,$bytesalloc,$bytesused,$bytesfree,$pctused,$pctfree);

# Show a graph of tablespace usage based on free space.

# Print the page header

   print <<"EOF";
Tablespaces are ordered by percentage used, descending.<P>
</CENTER>
<TABLE BORDER ALIGN=CENTER>
  <TR>
    <TH>Tablespace name</TH><TH>Bytes allocated</TH><TH>Bytes used</TH><TH>Bytes free</TH><TH>%Used graph</TH><TH>Percent used</TH><TH>Percent free</TH>
  </TR>
EOF

   $sql = "
SELECT
   DF.TABLESPACE_NAME                                   \"Tablespace name\",
   TO_CHAR(DF.BYTES,'999,999,999,999')                  \"Bytes allocated\",
   TO_CHAR(DF.BYTES-SUM(FS.BYTES),'999,999,999,999')    \"Bytes used\",
   TO_CHAR(SUM(FS.BYTES),'999,999,999,999')             \"Bytes free\",
   ROUND((DF.BYTES-SUM(FS.BYTES))*100/DF.BYTES)         \"Percent used\",
   ROUND(SUM(FS.BYTES)*100/DF.BYTES)                    \"Percent free\"
FROM DBA_FREE_SPACE FS,
   (SELECT TABLESPACE_NAME, SUM(BYTES) BYTES FROM DBA_DATA_FILES GROUP BY TABLESPACE_NAME ) DF
WHERE FS.TABLESPACE_NAME = DF.TABLESPACE_NAME
GROUP BY DF.TABLESPACE_NAME, DF.BYTES
ORDER BY \"Percent free\"
";

# Get the space allocation info

   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   while (($tablespace,$bytesalloc,$bytesused,$bytesfree,$pctused,$pctfree) = $cursor->fetchrow_array ) {
      $bytesalloc=commify($bytesalloc);
      $bytesused=commify($bytesused);
      $bytesfree=commify($bytesfree);
      print <<"EOF";
  <TR>
    <TD>
      <TABLE>
        <TR ALIGN=LEFT>
          <TD><A HREF=$scriptname?database=$database&object_type=TSINFO&arg=$tablespace>$tablespace</A></TD>
        </TR>
      </TABLE>
    </TD>
    <TD ALIGN=RIGHT>
      <TABLE>
        <TR>
          <TD>$bytesalloc</TD>
        </TR>
      </TABLE>
    </TD>
    <TD ALIGN=RIGHT>
      <TABLE>
        <TR>
          <TD>$bytesused</TD>
        </TR>
      </TABLE>
    </TD>
    <TD ALIGN=RIGHT>
      <TABLE>
        <TR>
          <TD>$bytesfree</TD>
        </TR>
      </TABLE>
    </TD>
    <TD WIDTH=100>
      <TABLE>
        <TR>
          <TD WIDTH=$pctused BGCOLOR=BLUE><BR></TD>
        </TR>
      </TABLE>
    </TD>
    <TD ALIGN=RIGHT>
      <TABLE>
        <TR>
          <TD>$pctused%</TD>
        </TR>
      </TABLE>
    </TD>
    <TD ALIGN=RIGHT>
      <TABLE>
        <TR>
          <TD>$pctfree%</TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
EOF
   }
   $cursor->finish;
   print "</TABLE>\n";
}

sub showSessionstats {

   my ($sql,$text,$link,$nulltext);

   $sql = "
SELECT 
   OBJECT		\"Object name\",
   TYPE			\"Object type\",
   OWNER		\"Owner\"
FROM V\$ACCESS
   WHERE SID= $schema
";

   $text = "Objects being accessed by SID $schema.";
   $nulltext = "This SID is not accessing any objects.";
   ObjectTable($sql,$text,$nulltext); 

# Display output from V$SESSION_LONGOPS if Oracle8

   if ($oracle8) {
      $sql = "
SELECT
   SID			\"SID\",
   UPDATE_COUNT		\"Update count\",
   COMPNAM		\"Component\",
   OBJID		\"Object ID\",
   MSG			\"Message\",
   STEPSOFAR		\"Step sofar\",
   STEPTOTAL		\"Step total\",
   SOFAR		\"Work sofar\",
   TOTALWORK		\"Work total\",
   APPLICATION_DATA_1	\"Data 1\",
   APPLICATION_DATA_2	\"Data 2\",
   APPLICATION_DATA_3	\"Data 3\",
   TO_CHAR(START_TIME,'Month DD, YYYY - HH24:MI')	\"Start time\",
   TO_CHAR(CURRENT_TIME,'Month DD, YYYY - HH24:MI')	\"Current time\"
FROM V\$SESSION_LONGOPS
   WHERE SID = $schema
";

      $text = "Long operation information.";
      $link = "";
      $nulltext = "No info in V\$SESSION_LONGOPS.";
      DisplayTable($sql,$text,$link,$nulltext);
   }

   $sql = "
SELECT 
   SEQ#							\"Seq#\",
   EVENT						\"Event\",
   SECONDS_IN_WAIT					\"Seconds waiting\"
FROM V\$SESSION_WAIT
   WHERE SID = $schema
";

      $text = "Session wait information.";
      $link = "";
      $nulltext = "No info in V\$SESSION_WAIT.";
      DisplayTable($sql,$text,$link,$nulltext);

# Show session statistics for a particular SID

   $sql = "
SELECT 
   A.NAME					\"Parameter name\",
   TO_CHAR(B.VALUE,'999,999,999,999,999')	\"Value\",
   DECODE(A.CLASS,
		1,'User',
		2,'Redo',
		4,'Enqueue',
		8,'Cache',
		16,'OS',
		32,'Parallel server',
		64,'SQL',
		128,'Debug')			\"Class\"
FROM V\$STATNAME A, V\$SESSTAT B
   WHERE A.STATISTIC# = B.STATISTIC#
   AND B.SID = $schema
   AND B.VALUE > 0
ORDER BY A.CLASS, A.NAME
";

   $text = "Session statistics for SID '$schema'. Only non-zero values displayed.";
   $link = "";
   $nulltext = "No current session statistics for SID $schema.";
   DisplayTable($sql,$text,$link,$nulltext);
}

sub showFilegraph {

   my ($sql,$text,$link,$cursor,$totalreads);
   my ($totalwrites,$file_name,$phyrds,$rdpct,$phywrts,$wrtpct);

# Show a graph of datafile activity based on physical writes.

   $sql = "
SELECT 
   SUM(PHYRDS), SUM(PHYWRTS) 
FROM V\$FILESTAT
";

   $cursor = $dbh->prepare($sql);
   $cursor->execute;
   ($totalreads,$totalwrites) = $cursor->fetchrow_array;
   $cursor->finish;

   $sql = "
SELECT 
   NAME							\"File name\",
   TO_CHAR(PHYRDS,'999,999,999,999')			\"Physical reads\",
   TO_CHAR(PHYRDS * 100 / $totalreads,'999')		\"Physical reads %\",
   TO_CHAR(PHYWRTS,'999,999,999,999')			\"Physical writes\",
   TO_CHAR(PHYWRTS * 100 / $totalwrites,'999')		\"Physical writes %\"
FROM V\$DATAFILE DF, V\$FILESTAT FS
   WHERE DF.FILE# = FS.FILE#
ORDER BY PHYWRTS DESC
";

   print <<"EOF";
Datafiles are ordered by physical writes, descending.<P>
</CENTER>
<TABLE BORDER ALIGN=CENTER>
  <TR>
    <TH>File name</TH><TH>Reads</TH><TH>Percentage</TH><TH>Writes</TH><TH>Percentage</TH>
  </TR>
EOF
    
   $cursor = $dbh->prepare($sql);
   $cursor->execute;
   while ( ($file_name,$phyrds,$rdpct,$phywrts,$wrtpct) = $cursor->fetchrow_array ) {
      print <<"EOF";
  <TR>
    <TD>
      <TABLE>
        <TR ALIGN=LEFT>
          <TD><A HREF=$scriptname?database=$database&object_type=DATAFILE&arg=$file_name>$file_name</A></TD>
        </TR>
      </TABLE>
    </TD>
    <TD WIDTH=100>
      <TABLE>
        <TR>
          <TD WIDTH=$rdpct BGCOLOR=BLUE><BR></TD>
        </TR>
      </TABLE>
    </TD>
    <TD ALIGN=RIGHT>
      <TABLE>
        <TR>
          <TD>$rdpct%</TD>
        </TR>
      </TABLE>
    </TD>
    <TD WIDTH=100>
      <TABLE>
        <TR>
          <TD WIDTH=$wrtpct BGCOLOR=BLUE><BR></TD>
        </TR>
      </TABLE>
    </TD>
    <TD ALIGN=RIGHT>
      <TABLE>
        <TR>
          <TD>$wrtpct%</TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
EOF
   }
   $cursor->finish;
   print "</TABLE>\n";
}

sub showTSfilegraph {

   my ($sql,$text,$link,$cursor,$totalreads);
   my ($totalwrites,$file_name,$phyrds,$rdpct,$phywrts,$wrtpct);
   my ($file_id,$bytes,$bytesused,$percent);

# Show a graph of datafile activity based on physical writes.

   $sql = "
SELECT
   SUM(PHYRDS), SUM(PHYWRTS)
FROM V\$FILESTAT
";

   $cursor = $dbh->prepare($sql);
   $cursor->execute;
   ($totalreads,$totalwrites) = $cursor->fetchrow_array;
   $cursor->finish;

   $sql = "
SELECT
   NAME                                                 \"File name\",
   TO_CHAR(PHYRDS,'999,999,999,999')                    \"Physical reads\",
   TO_CHAR(PHYRDS * 100 / $totalreads,'999')            \"Physical reads %\",
   TO_CHAR(PHYWRTS,'999,999,999,999')                   \"Physical writes\",
   TO_CHAR(PHYWRTS * 100 / $totalwrites,'999')          \"Physical writes %\"
FROM V\$DATAFILE DF, V\$FILESTAT FS
   WHERE DF.FILE# = FS.FILE#
   AND DF.FILE# IN
   (SELECT FILE_ID
FROM DBA_DATA_FILES
WHERE TABLESPACE_NAME = '$schema')
ORDER BY PHYWRTS DESC
";

   print <<"EOF";
Datafile I/O statistics.<BR>
Entries are ordered by physical writes, descending.<BR>
Percentage shown is in comparison to all other datafiles in database.<P>
</CENTER>
<TABLE BORDER ALIGN=CENTER>
  <TR>
    <TH>File name</TH><TH>Reads</TH><TH>Percentage</TH><TH>Writes</TH><TH>Percentage</TH>
  </TR>
EOF
   
   $cursor = $dbh->prepare($sql);
   $cursor->execute;
   while ( ($file_name,$phyrds,$rdpct,$phywrts,$wrtpct) = $cursor->fetchrow_array ) {
      print <<"EOF";
  <TR>
    <TD>
      <TABLE>
        <TR ALIGN=LEFT>
          <TD><A HREF=$scriptname?database=$database&object_type=DATAFILE&arg=$file_name>$file_name</A></TD>
        </TR>
      </TABLE>
    </TD>
    <TD WIDTH=100>
      <TABLE>
        <TR>
          <TD WIDTH=$rdpct BGCOLOR=BLUE><BR></TD>
        </TR>
      </TABLE>
    </TD>
    <TD ALIGN=RIGHT>
      <TABLE>
        <TR>
          <TD>$rdpct%</TD>
        </TR>
      </TABLE>
    </TD>
    <TD WIDTH=100>
      <TABLE>
        <TR>
          <TD WIDTH=$wrtpct BGCOLOR=BLUE><BR></TD>
        </TR>
      </TABLE>
    </TD>
    <TD ALIGN=RIGHT>
      <TABLE>
        <TR>
          <TD>$wrtpct%</TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
EOF
   }
   $cursor->finish;
   print "</TABLE><BR><CENTER>\n";

# Free space

   $sql = "
SELECT D.FILE_NAME                                                      \"Filename\",
       D.FILE_ID                                                        \"File ID\",
       TO_CHAR(D.BYTES,'999,999,999,999')                               \"Bytes\",
       TO_CHAR(SUM(E.BYTES),'999,999,999,999')                           \"Bytes used\",
       TO_CHAR(SUM(E.BYTES) / D.BYTES * 100,'999.99')                   \"% used\"
FROM   SYS.DBA_EXTENTS      E,
       SYS.DBA_DATA_FILES   D
WHERE  D.FILE_ID  = E.FILE_ID (+)
AND D.TABLESPACE_NAME = '$schema'
GROUP BY D.FILE_NAME, D.FILE_ID, D.BYTES
";
   print <<"EOF";
Datafile free space.<P>
</CENTER>
<TABLE BORDER ALIGN=CENTER>
  <TR>
    <TH>File name</TH><TH>File ID</TH><TH>Bytes</TH><TH>Bytes used</TH><TH>Graph</TH><TH>Percentage full</TH>
  </TR>
EOF

   $cursor = $dbh->prepare($sql);
   $cursor->execute;
   while ( ($file_name,$file_id,$bytes,$bytesused,$percent) = $cursor->fetchrow_array ) {
      print <<"EOF";
  <TR>
    <TD>
      <TABLE>
        <TR ALIGN=LEFT>
          <TD><A HREF=$scriptname?database=$database&object_type=DATAFILE&arg=$file_name>$file_name</A></TD>
        </TR>
      </TABLE>
    </TD>
    <TD ALIGN=RIGHT>
      <TABLE>
        <TR>
          <TD>$file_id</TD>
        </TR>
      </TABLE>
    </TD>
    <TD ALIGN=RIGHT>
      <TABLE>
        <TR>
          <TD>$bytes</TD>
        </TR>
      </TABLE>
    </TD>
    <TD ALIGN=RIGHT>
      <TABLE>
        <TR>
          <TD>$bytesused</TD>
        </TR>
      </TABLE>
    </TD>
    <TD WIDTH=100>
      <TABLE>
        <TR>
          <TD WIDTH=$percent BGCOLOR=BLUE><BR></TD>
        </TR>
      </TABLE>
    </TD>
    <TD ALIGN=RIGHT>
      <TABLE>
        <TR>
          <TD>$percent</TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
EOF
   }
   $cursor->finish;
   print "</TABLE>\n";
}


sub message {

# Print a message to the user

   my $message = shift;

   $message = "<FONT COLOR=\"$nullcolor\">$message</FONT>";
   print "<P><B>$message</B></P>\n";
}

sub text {

# Print a message to the user

   my $message = shift;

   $message = "<FONT COLOR=\"$fontcolor\">$message</FONT>";
   print "<P><B>$message</B></P>\n";
}

sub commify {

# Puts commas in a numeral

   my $text = reverse $_[0];
   $text =~ s/(\d\d\d)(?=\d)(?!\d*\.)/$1,/g;
   return scalar reverse $text;
}

sub fragMap {

# Creates a GIF image of a datafile fragmentation
# map, showing used and unused blocks. Writes to
# STDOUT.

   my ($sql,$sql1,$cursor,$cursor1,$file_id,$blocks);
   my ($collength,$width,$height,$hstart,$vstart);
   my ($blockused,$blockfree,$x,$y,$numblocks);
   my ($colcounter,$image,$id,$i,$pointer,$length);
   my ($block_id,$counter,$center,$black,$white);

   if ($schema eq "datafile") {
      $sql = "
SELECT FILE_ID, BLOCKS
   FROM DBA_DATA_FILES
WHERE FILE_NAME = '$object_name'
";

   $cursor=$dbh->prepare($sql);
   $cursor->execute;

   ($file_id,$blocks) = $cursor->fetchrow_array;
   $cursor->finish;

   $sql = "
SELECT BLOCK_ID, BLOCKS
   FROM DBA_EXTENTS
WHERE FILE_ID = '$file_id'
   ORDER BY BLOCK_ID
";
   }

   if ($schema eq "tablespace") {

      $sql = "
SELECT SUM(BLOCKS)
   FROM DBA_DATA_FILES
WHERE TABLESPACE_NAME = '$object_name'
";

   $cursor=$dbh->prepare($sql);
   $cursor->execute;

   $blocks = $cursor->fetchrow_array;
   $cursor->finish;

      $sql = "
SELECT BLOCK_ID, BLOCKS
   FROM DBA_EXTENTS
WHERE TABLESPACE_NAME = '$object_name'
   ORDER BY BLOCK_ID
";
   }

   $cursor=$dbh->prepare($sql);
   $cursor->execute;
      
# Create the image

   $collength = 500;
   $width = $collength+100;
   $height = int(10*($blocks/$collength)+110+int($blocks/$collength));
   $image = new GD::Image($width,$height);
   $hstart = 50;
   $vstart = 50;
   $x = $hstart;
   $y = $vstart;
   $white	= $image->colorAllocate(0,0,0);
   $blockused	= $image->colorAllocate(165,0,99);
   $blockfree	= $image->colorAllocate(198,231,222);
   $black	= $image->colorAllocate(0,0,0);
   $image->interlaced('true');
   $image->transparent($white);

   $colcounter = 1;
   $counter = 1;
   $pointer = 1;

   while (($block_id,$numblocks) = $cursor->fetchrow) {
      for ($i = $pointer; $i < $block_id; $i++) {
         $image->line($x,$y,$x,$y+10,$blockfree);
         $x = $x+1;
         if ($x == $collength+$hstart) {
           $x = $hstart;
           $y = $y +10;
           $image->line(0,$y,$width,$y,$white);
           $y = $y + 1;
           $colcounter=0;
         }
         $pointer++;
      }
      for ($i = 1; $i <= $numblocks; $i++ ) {
         $image->line($x,$y,$x,$y+10,$blockused);
         $x = $x+1;
         if ($x == $collength+$hstart) {
           $x = $hstart;
           $y = $y +10;
           $image->line(0,$y,$width,$y,$white);
           $y = $y + 1;
           $colcounter=0;
         }
         $counter = $block_id + $numblocks + 1;
         $pointer++;
      }
   }
   $cursor->finish;
   for ($i = $pointer; $i <= $blocks; $i++) {
      $image->line($x,$y,$x,$y+10,$blockfree);
      $x = $x+1;
      if ($x == $collength+$hstart) {
         $x = $hstart;
         $y = $y +10;
         $image->line(0,$y,$width,$y,$white);
         $y = $y + 1;
         $colcounter=0;
      }
      $pointer++;
   }

   # Create the title and legend

   $center = int(($collength+100)/2);
   my $file_name = basename($object_name);
   my $text = "Fragmentation map for $schema $file_name";
   my $textlength = length($text);
   my $fontwidth = gdMediumBoldFont->width;
   my $offset = int((($collength + 100) - ($textlength * $fontwidth)) / 2);
   eval('$image->string(gdMediumBoldFont,$offset,20,$text,$black)'); 

   eval('$image->rectangle(50,$y+20,60,$y+30,$black)'); 
   eval('$image->fill(55,$y+25,$blockused)');
   eval('$image->string(gdMediumBoldFont,65,$y+19,"Blocks used",$black)');

   eval('$image->rectangle(50,$y+40,60,$y+50,$black)'); 
   eval('$image->fill(55,$y+45,$blockfree)');
   eval('$image->string(gdMediumBoldFont,65,$y+39,"Blocks free",$black)');

   $length = length($image->gif);
   print "Content-Type: image/gif Content-length: $length\n\n";
#   print "Content-Type: image/gif\n\n";
   print $image->gif;
}

sub about {

# Give me a pat on the back. :)

   my ($title,$heading,$fontsize);

   $title	= "Oracle data dictionary browser v$VERSION";
   $heading	= "About oracletool";
   $fontsize	= 5;

   Header($title,$heading,$font,$fontsize,$fontcolor,$bgcolor);
print <<"EOF";
</CENTER>
<FONT SIZE="4">
<BR>
<TABLE BORDER>
  <TR>
    <TD>
    <B>
oracletool.pl version $VERSION
    </B>
    </TD>
  </TR>
</TABLE>
<BR>
Written and maintained by Adam vonNieda in Kansas, USA.<P>
Copyright 1998, 1999 Adam vonNieda<BR>
You may distribute under the terms of either the GNU General Public<BR>
License or the Artistic License, as specified in the Perl README file,<BR>
with the exception that it cannot be placed on a CD-ROM or similar media<BR>
for commercial distribution without the prior approval of the author.<P>
Home site: <A HREF="http://www.oracletool.com">http://www.oracletool.com</A><BR><BR>
Questions, comments, bug reports, and suggestions are encouraged!<BR>
Drop me a note at <A HREF="mailto:adam\@oracletool.comegg">adam\@oracletool.com</A>.<BR><BR>
I'd like to thank Tim Bunce and everyone on the DBI mailing list <BR>
for all of the helpful information they have provided.<BR><BR>
EOF
   exit;
}

sub repmaster {

# Find out if this server is the master for
# replication.

   my ($sql,$cursor,$count);

   $sql = "
SELECT 
   COUNT(*) 
FROM DBA_REGISTERED_SNAPSHOTS
";

   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   $count=$cursor->fetchrow;
   $cursor->finish;
   return $count;
}

sub repsnapshot {

# Find out if this instance has snapshots
# replicated from a master.

   my ($sql,$cursor,$count);

   $sql = "
SELECT 
   COUNT(*) 
FROM DBA_SNAPSHOTS
";

   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   $count=$cursor->fetchrow;
   $cursor->finish;
   return $count;
}

sub parallel {

# Find out if this is a parallel database.
# Oracle8 only. I'm not going to cover Oracle7
# parallel databases at this time.

   if ($oracle8) {
      my $sql = "
SELECT VALUE
   FROM V\$PARAMETER
WHERE NAME = 'parallel_server'
";

      my $cursor = $dbh->prepare($sql);
      $cursor->execute;
      my $foo = $cursor->fetchrow_array;
      $cursor->finish;
      if ( $foo eq "TRUE" ) {
         return 1; 
       } else {
         return 0; 
      }
    } else {
   return 0;
   }
}

sub DisplayGraph {

   my $graphtype	= shift;
   my $object_name	= shift;
   my $text		= shift;

   my ($file,$tablespace_name,$rgif,$vgif,$sql,$cursor);

   if ($graphtype eq "dbfile") {
      $sql = "
SELECT TABLESPACE_NAME 
   FROM DBA_DATA_FILES
WHERE FILE_NAME = '$object_name'
";
      $cursor=$dbh->prepare($sql);
      $cursor->execute;
      $tablespace_name = $cursor->fetchrow_array;
      $cursor->finish;
      $file = basename($object_name);
      $rgif = "$ENV{DOCUMENT_ROOT}/$repository/$database/$tablespace_name/$file.gif";
      $vgif = "$repository/$database/$tablespace_name/$file.gif";
   }

   if ($graphtype eq "sessions") {
      $rgif = "$ENV{DOCUMENT_ROOT}/$repository/$database/sessions.gif";
      $vgif = "$repository/$database/sessions.gif";
   }

# If the image file does not exist, return.
   if (! -e $rgif) {
      return (1);
   }

   print <<"EOF" if defined ($text);
<P><B>$text</B>
EOF
print "<IMG SRC=$vgif>\n";
}

sub showGrantButton {

   my ($sql,$cursor,$count);

   $sql = "
SELECT COUNT(*)
   FROM DBA_TAB_PRIVS
WHERE TABLE_NAME = '$object_name'
AND OWNER = '$schema'
";

   $cursor=$dbh->prepare($sql);
   $cursor->execute;
   $count = $cursor->fetchrow_array;
   $cursor->finish;

   if ($count > 0 ) {

   print <<"EOF";
<BR>
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
  <TR>
    <TD ALIGN=CENTER>
      <FORM METHOD="GET" ACTION="$scriptname">
        <INPUT TYPE="HIDDEN" NAME="database" VALUE="$database">
        <INPUT TYPE="HIDDEN" NAME="object_type" VALUE="OBJECTGRANTS">
        <INPUT TYPE="HIDDEN" NAME="schema" VALUE="$schema">
        <INPUT TYPE="HIDDEN" NAME="arg" VALUE="$object_name">
        <INPUT TYPE="SUBMIT" NAME="tablerows" VALUE="Display ($count) grants">
      </FORM>
    </TD>
  </TR>
</TABLE>
EOF
   }
}

sub showObjectGrants {

   my ($sql,$cursor,$text,$link);

   $sql = "
SELECT
   GRANTOR	\"Grantor\",
   GRANTEE	\"Grantee\",
   PRIVILEGE	\"Privilege\",
   GRANTABLE	\"Grantable\"
FROM DBA_TAB_PRIVS
   WHERE TABLE_NAME = '$object_name'
   AND OWNER = '$schema'
ORDER BY GRANTEE, PRIVILEGE
";

   $text = "Grants for object $schema.$object_name";
   $link = "";
   DisplayTable($sql,$text,$link);
}

sub Button {

   my $href		= shift;
   my $text		= shift;
   my $bgcolor		= shift;
   my $align		= shift;

   $align = "CENTER" unless $align;

   print <<"EOF";
      <TABLE BGCOLOR="BLACK" WIDTH="100" CELLPADDING="1" CELLSPACING="0" BORDER="0" ALIGN="$align">
        <TR>
          <TD VALIGN="TOP">
            <TABLE BGCOLOR="$bgcolor" WIDTH="100%" CELLPADDING="2" CELLSPACING="1" BORDER="0">
              <TR ALIGN="CENTER">
                <TD><B><FONT SIZE="2">
EOF
   if ($href) {
      print "<A HREF=$href>$text";
    } else {
      print "$text";
   }
print <<"EOF";
                </B></TD>
              </TR>
            </TABLE>
          </TD>
        </TR>
      </TABLE>
      <TABLE WIDTH="100" CELLPADDING="1" CELLSPACING="0" BORDER="0">
        <TD></TD>
      </TABLE>
EOF
}

sub help {

   my $object_type = uc(shift);
   my ($title,$heading,$fontsize,$text);

   $title       = "Oracletool help facility";
   $heading     = "";
   $fontsize    = 4;

   Header($title,$heading,$font,$fontsize,$fontcolor,$bgcolor);

#=============================================================================
   $text = "
<B>Object list</B>

This screen is simply a list of objects owned by the schema that you selected
on the previous page. Click on one of the hyperlinks for more information
about the object.
" if ($object_type eq "LISTOBJECTS");

#=============================================================================
   $text = "
<B>Table information screen</B>

This screen gives you a button for displaying 25 rows of a table in a HTML
table. You can also specify a \"<I><B>where</B></I>\" clause for the display. An 
example would be <I><B>\"product_name = 'WIDGET'\"</B></I>

It shows the structure of the table, much like doing a \"<B>describe</B>\".

If the table has been analyzed, additional information will be shown
pertaining to the storage and usage of the table.

If the table has a primary key, a hyperlink to it will display. A primary key
is a unique index that marks the primary column or columns that contain the data
that uniquely identify the rows in the table.

Any non primary key indexes also will be shown as hyperlinks. Generally, non
primary key indexes are put on a table to enforce a unique constraint, or for
performance reasons.

Column constraints are constraints which set the rules for the data within the
column. If the data does not match the criteria, it cannot be inserted.

Foreign key constraints require each value in a column or columns to match a 
value in a related table's <B>unique or primary</B> key. Foreign key constraints
also define referential integrity actions that dictate what Oracle should do
with dependent data if the data it references is altered.

The last display shows any foreign keys that reference this table. basically, the
opposite of the display above it.
" if ($object_type eq "TABLE");

#=============================================================================
   $text = "
<B>View information screen</B>

This screen gives you a button for displaying 25 rows of a view in a HTML
table.

A view is a compiled piece of SQL that can be stored in the data dictionary and
selected from as if it was a table. Each time you select from a view, the code
that makes it up is executed just as if it had been executed on the command 
line. 

It shows the structure of the view, much like doing a \"<B>describe</B>\".

It shows the text of the view. This is the source code that is executed each 
time you select from the view. If you cut this text and paste it into a text
editor, you can edit the text easily and recreate the view.
" if ($object_type eq "VIEW");

#=============================================================================
   $text = "
<B>Trigger information</B>

A database trigger is a compiled piece of PL/SQL code that is fired 
(implicitly executed) when an INSERT, UPDATE, or DELETE statement is issued 
against the associated table. Triggers can be very handy pieces of code, but 
can also seriously hinder the performance of your database if not written 
efficiently.
" if ($object_type eq "TRIGGER");

#=============================================================================
   $text = "
<B>Database link information</B>

A database link is an object that makes accessing data in a remote Oracle 
database easier. A table or view in a remote database can be selected from
easily over a database link.
" if ($object_type eq "DATABASE LINK");

#=============================================================================
   $text = "
<B>Source code information</B>

This help screen covers Functions, Procedures, Packages, and Package bodies.
This source code is what makes up the object you clivked on. It can easily be 
cut and pasted into a text editor for editing and recreation.
" if (($object_type eq "FUNCTION") || ($object_type eq "PACKAGE BODY") || ($object_type eq "PACKAGE") || ($object_type eq "PROCEDURE"));

#=============================================================================
   $text = "
<B>Help on help?</B>

Hmm, help on help. Seems a bit needy, don't ya think?
" if (! $object_type);

#=============================================================================
   $text = "
<B>Sequence information</B>

The min value of the sequence represents the lowest number of the sequence. 

The Max value is as high as the sequence can go.

The Cycle flag (if Yes) means that an ascending sequence will wrap to its 
minimum value. Opposite for descending sequences.

Setting the Order flag to Yes guarantees that all sequences will be generated 
in the order they were requested. This only pertains to OPS databases.

Cache size is the number of sequences Oracle will keep in memory for quick
access.

Last number is the last sequence number that was generated.
" if ($object_type eq "SEQUENCE");

#=============================================================================
   $text = "
<B>Index information</B>

The structure portion shows which columns the index spans.

General info shows the storage parameters and DDL times.
" if ($object_type eq "INDEX");

#=============================================================================
   $text = "
<B>Grants TO</B>

This screen shows the privileges that have been granted to a schema. It covers
system privileges, roles, and explicit grants.

Roles will be shown as hyperlinks, so you can click on a role name to see what 
privileges have been granted to it.
" if ($object_type eq "GRANTSTO");

#=============================================================================
   $text = "
<B>Grants FROM</B>

This screen shows the privileges that a schema has granted to others.
" if ($object_type eq "GRANTSFROM");

#=============================================================================
   $text = "
<B>Roles</B>

Shows the privileges that have been granted to the selected role. If roles have
been granted to the role, you can drill down into those roles as well.
" if ($object_type eq "ROLES");

#=============================================================================
   $text = "
<B>Toplevel page</B>

This is the toplevel page, where you select the type of information you want to
gather. It will show the database version after a successful connection is made,
and a bunch of buttons will appear. Also, a table of all user schemas will 
appear under the buttons. A button for Parallel Server specific information will
appear only if the database is OPS, and is version 8.x.

Any user that has the DBA role granted to them will show up in bold text 
surrounded by parenthesis.

Any user that is currently connected to the database will show up with a highlighted 
background. This does not mean that the user neccessarily has ACTIVE sessions, 
however. A session can be connected, but inactive. 
" if ($object_type eq "LISTUSERS");

#=============================================================================
   $text = "
<B>User info</B>

This screen is the starting point for finding out information about a particular
schema. It will display some general info about the user, and tablespace quotas,
if the user has any. If the user has no tablespace quotas, but does own objects,
then she probably has the UNLIMITED TABLESPACE privilege granted to her.

Below the quotas are buttons for displaying grants to/from the user, and if the
user has ACTIVE sessions in the instance, then a button will display. 

A table follows which shows a count of the different types of objects owned by
the user.

Next, if the user owns objects in this database, a list of the types will appear.
By clicking on an object type, a list of all of the objects of that type will appear
and additional information can be gathered about that object.

Finally, a button for an object report. This query may be long running for databases
with a large data dictionary. One situation where this report may be useful is if
you need to export an entire user schema to move to another database. This will
show you a list of her objects split up by the tablespaces they reside in.
" if ($object_type eq "USERINFO");

#=============================================================================
   $text = "
<B>Object list</B>

This screen shows a list of objects that are of the type that you clicked on.
You can find out more information about one of these objects by clicking on it.
" if ($object_type eq "LISTOBJECTS");

#=============================================================================
   $text = "
<B>Synonym</B>

This screen shows some general information about the synonym that you clicked on,
including the name and owner of the object the synonym points to. A synonym does
not have to point to a table. It can point to almost any object, including views,
sequences, procedures, database links, or even other synonyms.
" if ($object_type eq "SYNONYM");

#=============================================================================
   $text = "
<B>Tablespaces</B>

The tablespaces screen has a button for graphing the space allocation of all the
tablespaces in the database. This query can take a long time in databases with 
many tablespaces, but it provides useful information about the space allocation
and usage in the entire database. Be patient.

Next is a list of all of the tablespaces in the database. This is more useful if
you know the tablespace name that you are concerned with, and don't need information
about all of them at once.
" if ($object_type eq "TABLESPACES");

#=============================================================================
   $text = "
<B>Datafiles</B>

This screen is simply a list of all of the datafiles residing in the database.
Click on one of the datafiles for more information about it. Hopefully, you will
never see a message in this screen indicating that one or more of your datafiles
need media recovery. :-)

The datafile graph is handy for seeing which of you datafiles are the most busy.
" if ($object_type eq "DATAFILES");

#=============================================================================
   $text = "
<B>Datafile info</B>

This screen will show you information about a specific datafile, including general
info, I/O stats, next extent size of the tablespace it resides in, and 10 rows of
free space. If the largest free chunk in this datafile is smaller than the next 
extent size of the tablespace, then you may have a problem. More information about
tablespace fragmentation can be gathered from the tablespace information button 
at the toplevel screen. A datafile fragmentation inage will be displayed to show
a graphical representation of your extent allocation.

This screen also provides a list of all objects which have extents in this datafile. 
This does not mean that these objects don't have extents in other datafiles as well.
" if ($object_type eq "DATAFILE");

#=============================================================================
   $text = "
<B>Tablespace info</B>

This screen shows information about a particular tablespace that you have selected.
This includes general info, space allocation and usage, and allocated datafiles and
the fragmentation of said datafiles. If your datafiles have a large number of \"pieces\",
then you may need to coalesce the tablespace, or possibly reorg it.

The datafile information graphs show I/O statistics and datafile space info.
 
This screen will show a list of objects that cannot allocate a next extent, if any.
If you have any objects that cannot allocate a next extent, and you expect growth
from that object, then you need to fix this problem. You may need to coalesce and/or
reorg the tablespace, or add a datafile to it.

If any of your objects in this tablespace are nearing their max_extents limit, they
will also be displayed. 

A list of all objects residing in the tablespace is also provided. 
" if ($object_type eq "TSINFO");

#=============================================================================
   $text = "
<B>Instance parameters</B>

Shows instance SGA info, memory usage, data dictionary cache miss ratio, and
all parameters from V\$PARAMETER.
" if ($object_type eq "PARAMETERS");

#=============================================================================
   $text = "
<B>Redo log information</B>

This screen shows general online redo log information, and a graph of log 
switches. This graph is a quick look into the times when your instance
is the most busy.
" if ($object_type eq "REDOLOGS");

#=============================================================================
   $text = "
<B>Session information</B>

This screen shows valuable information about all sessions in the instance.
You can get to this screen at the toplevel screen, which will display ALL
sessions, or under an individual user selection, where only the sessions
for that user will be displayed. This can be very useful when a user is having
a problem with a particular query. Each session display will have a hyperlink in 
it for obtaining additional information about the query. These session statistics
can be used to determine if the session is actually getting work done, or if it
is just hanging. If the session button at the toplevel screen shows too many 
sessions, you may want to narrow it down by selecting the user you are
concerned with first, and then displaying that users sessions.
" if ($object_type eq "SESSIONS");

#=============================================================================
   $text = "
<B>Foriegn key constraint information</B>

This screen shows information about the foreign key constraint that you have 
selected, such as the parent table, parent constraint name, and parent table
owner.
" if ($object_type eq "CONSTRAINT");

#=============================================================================
   $text = "
<B>Rollback segment information</B>

Shows a list of rollback segments private to the instance you are connected to,
with storage information and number of active transactions. Click on a segment
name for more information.
" if ($object_type eq "ROLLBACKSEGS");

#=============================================================================
   $text = "
<B>Rollback segment information</B>

Shows general information about the rollback segment you have selected, and
information about current transactions on this rollback segment.

Also shows storage information about the tablespace the RBS resides in. This
is to help determine when a transaction is going to fail due to a rollback
segment space problem. 
" if ($object_type eq "ROLLBACK");

#=============================================================================
   $text = "
<B>Lock / contention information</B>

This screen will show information about contending locks within the database. 
In other words, if one transaction has a table lock on a table that another
transaction is trying to update, this page will help you debug that.

It also shows locks on objects that are not causing contention on other queries.

Session wait information is displayed below that. Handy for quickly determining
what type of command a hung transaction is trying to execute, or what that 
transaction is waiting for.
" if ($object_type eq "CONTENTION");

#=============================================================================
   $text = "
<B>Datafile I/O graph</B>

This graph is great for seeing which of your datafiles are most busy. The 
percentage represents the percentage that particular datafile is written
to or read from compared to the rest of the datafiles in the database.
Keep in mind that these statistics are valid only since instance startup.
" if ($object_type eq "FILEGRAPH");

#=============================================================================
   $text = "
<B>Tablespace space allocation / usage graph</B>

This graph is extremely useful, but unfortunately is also extremely slow. It will
show you the space allocated, used, and free for all tablespaces, and show a bar
graph for visual comparison purposes, and also tell you what percentage full each
of your tablespaces is. Great graph. Terrible performance.
" if ($object_type eq "TSGRAPH");

#=============================================================================
   $text = "
<B>Tablespace file graphs</B>

These graphs show you information about the datafiles that make up the tablespace
you have selected. This includes I/O stats, as compared to the other datafiles
in the database, and space information, including allocated, used, and percentage
full.
" if ($object_type eq "TSFILEGRAPH");

#=============================================================================
   $text = "
<B>Session statistics</B>

This table shows statistics that pertain only to the session you have selected.
If you suspect that a transaction is hung, looking at these stats may give you
a better idea about what's happening, or not happening.
" if ($object_type eq "SESSIONSTATS");

#=============================================================================
   $text = "
<B>Object report by tablespace</B>
This shows all of a users objects split up by the tablespaces they reside in.
This query may be long running for databases with a large data dictionary. One
situation where this report may be useful is if you need to export an entire user
schema to move to another database. This will show you a list of her objects 
split up by the tablespaces they reside in. It first shows a summary report with
number and type of objects by tablespace, and then gives a more detailed report
with object names and so on.
" if ($object_type eq "OBJECTREPORT");

#=============================================================================
   $text = "
<B>Object grants</B>
This screen shows the privileges that are granted to users for the selected
object.
" if ($object_type eq "OBJECTGRANTS");

#=============================================================================
   $text = "
<B>Object search</B>
This is a simple object search mechanism. It searches the DBA_OBJECTS view
for objects that are <B>LIKE</B> the object name you enter. If you enter the object
name as username<B>.</B>object_name, then it will search only in the schema you
have specified. The list displayed will be clickable links to screens with more
information about the object you have selected.
You may also enter an object id in numeric form, which will cause a search of
DBA_OBJECTS by the object_id.

After the object list displays, a search will be done for SID's accessing the 
objects that matched the search.
" if ($object_type eq "OBJECTSEARCH");

#=============================================================================
   $text = "
<B>SQL Worksheet</B>
This is a window that allows you to enter and execute SQL select statements
or SQL DML statements. You can do as many queries or statements as you want, 
provided they are separated by semicolons. A commit will be executed after 
each successful DML statement. If you want to change your query after submitting
it, just hit the \"Back\" button on your browser.
" if ($object_type eq "WORKSHEET");

#=============================================================================
   $text = "
<B>Profile</B>
This is simply a table of resource names assigned to a particular profile, and
their values.
" if ($object_type eq "PROFILE");

#=============================================================================
   $text = "
<B>SQL Worksheet output</B>
This screen shows the output of select statements, and a status of DML statements.
If a statement failed, an error will display with a description of the problem.
" if ($object_type eq "RUNWORKSHEET");

#=============================================================================
   $text = "
<B>Database Security</B>
This screen shows tables with all database roles and profiles as hyperlinks.
It also displays the names of all users in the database that have the \"DBA\"
role granted to them. If database auditing is enabled, a button will show up
leading to further information pertaining to auditing.
" if ($object_type eq "SECURITY");

#=============================================================================
   $text = "
<B>Database auditing</B>
This screen shows what types of auditing options are set. It is possible that
auditing is enabled (audit_trail = true), but no options are set, so there may 
not be any information here. 
" if ($object_type eq "AUDITING");

#=============================================================================
   $text = "
<B>Archived redo logs</B>
This screen shows you your log_archive_dest and log_archive_format. It also
lists the archived redo log information obtained from V\$LOG_HISTORY.
" if ($object_type eq "ARCHIVING");

#=============================================================================

# Change carriage returns and linefeeds into HTML breaks.

   $text =~ s/\n/<BR>/g;
   $text =~ s/\r/<BR>/g;
   $text = "</CENTER><BR>$text<BR>";

   print $text;
   print <<"EOF";
<P>
Press the "Back" button on your browser to return to the previous page.

EOF
exit;
}

sub Director {

# Put the if's here for reporting on the different types of objects.

# Report for a specific table.
   if ($object_type eq "TABLE")            {showTable();}

# Report for a specific table partition
   if ($object_type eq "TABLE PARTITION")  {showTablePart();}

# Report for a specific view.
   if ($object_type eq "VIEW")             {showView();}

# Report for a specific trigger.
   if ($object_type eq "TRIGGER")          {showTrigger();}

# Report for a specific database link.
   if ($object_type eq "DATABASE LINK")    {showDBlink();}

# Report for a specific function.
   if ($object_type eq "FUNCTION")         {showSource();}

# Report for a specific package body.
   if ($object_type eq "PACKAGE BODY")     {showSource();}

# Report for a specific package.
   if ($object_type eq "PACKAGE")          {showSource();}

# Report for a specific procedure.
   if ($object_type eq "PROCEDURE")        {showSource();}

# Report for a specific sequence.
   if ($object_type eq "SEQUENCE")         {showSequence();}

# Report for a specific index.
   if ($object_type eq "INDEX")            {showIndex();}

# Report for a specific index partition.
   if ($object_type eq "INDEX PARTITION")  {showIndexPart();}

# Report for a specific synonym.
   if ($object_type eq "SYNONYM")          {showSynonym();}

# Report on all privileges granted to a specific user.
   if ($object_type eq "GRANTSTO")         {showGrantsto();}

# Report on all privileges granted to a specific role.
   if ($object_type eq "ROLES")            {showRoles();}

# Report on all privileges granted from a specific user.
   if ($object_type eq "GRANTSFROM")       {showGrantsfrom();}

# This is what I call the "toplevel" page. Lists all users in database.
   if ($object_type eq "LISTUSERS")        {showUsers();}

# This is where you go after selecting a user. Lists general info,
# buttons for grants, and a list of object types owned by the user.
   if ($object_type eq "USERINFO")         {userInfo();}

# This will bring back a table of objects that are of the type that
# the user clicked on.
   if ($object_type eq "LISTOBJECTS")      {showObjects();}

# List all of the tablespaces in the database.
   if ($object_type eq "TABLESPACES")      {showTablespaces();}

# Report on information about a specific tablespace.
   if ($object_type eq "TSINFO")           {showTSinfo();}

# Show a clickable list of all datafiles in the database
   if ($object_type eq "DATAFILES")        {showDBfiles();}

# Show information abaout a particular datafile
   if ($object_type eq "DATAFILE")         {showFile();}

# Show all instance parameters from V$PARAMETER in a table
   if ($object_type eq "PARAMETERS")       {showParameters();}

# Show information about redologs, including a graph
   if ($object_type eq "REDOLOGS")         {showRedo();}

# Show information about all sessions in the instance, or
# for a particular user, if $user is set
   if ($object_type eq "SESSIONS")         {showSessions($user);}

# Display "n" rows 
   if ($object_type eq "TABLEROWS")        {showRows("25");}

# Display information about a constraint
   if ($object_type eq "CONSTRAINT")       {showConstraint();}

# Show a clickable list of all rollback segments in the database
   if ($object_type eq "ROLLBACKSEGS")     {showRollbacks();}

# Show information about a particular rollback segment
   if ($object_type eq "ROLLBACK")         {showRollback();}

# Check the instance for contending and non-contending locks
   if ($object_type eq "CONTENTION")       {showContention();}

# Show a table graph of datafiles with allocation
   if ($object_type eq "FILEGRAPH")        {showFilegraph();}

# Show a table graph of tablespaces with allocation
   if ($object_type eq "TSGRAPH")          {showTSgraph();}

# Show statistics for a particular file
   if ($object_type eq "TSFILEGRAPH")      {showTSfilegraph();}

# Show statistics for a selected session
   if ($object_type eq "SESSIONSTATS")     {showSessionstats();}

# Break down a user's object usage by object type and tablespace
   if ($object_type eq "OBJECTREPORT")     {objectReport();}

# Show OPS related information
   if ($object_type eq "OPSPAGE")          {OPSpage();}

# Search for objects by object name or object ID
   if ($object_type eq "OBJECTSEARCH")     {objectSearch();}

# Show the privileges granted to users for a particular object
   if ($object_type eq "OBJECTGRANTS")     {showObjectGrants();}

# Show memory and performance related data
   if ($object_type eq "PERFORMANCE")      {showPerformance();}

# Bring up a box for a user to run SQL in an explain plan
   if ($object_type eq "EXPLAINPLAN")      {enterExplainPlan();}

# Run the explain plan
   if ($object_type eq "RUNEXPLAINPLAN")   {runExplainPlan();}

# SQL-Worksheet
   if ($object_type eq "WORKSHEET")        {enterWorksheet();}

# Run the SQL entered on the worksheet
   if ($object_type eq "RUNWORKSHEET")     {runWorksheet();}

# Show settings for a profile
   if ($object_type eq "PROFILE")          {showProfile();}

# Show roles, profiles, and users with the DBA role
   if ($object_type eq "SECURITY")         {showSecurity();}

# Show auditing information
   if ($object_type eq "AUDITING")         {showAuditing();}

# Show archiving information
   if ($object_type eq "ARCHIVING")        {showArchiving();}

# Show controlfile information
   if ($object_type eq "CONTROLFILES")     {showControlfiles();}

# Show Replication information (Master)
   if ($object_type eq "REPMASTER")        {showRepmaster();}

# Show Refresh groups
   if ($object_type eq "REFRESHGROUPS")    {showRefreshgroups();}

# Show Refresh group children.
   if ($object_type eq "REFRESHINFO")      {showRefreshinfo();}

# Show info for a particular snapshot 
   if ($object_type eq "SNAPINFO")         {showSnapinfo();}

# General healthcheck
   if ($object_type eq "HEALTHCHECK")      {healthCheck();}        # Not yet implemented

}
###############################################################################################
__END__

=head1 NAME

Oracletool (oracletool.pl) - A web based tool for Oracle DBA's

=head1 SYNOPSIS

Oracletool is run from your web server as a CGI script. It is not
web server or platform specific.

=head1 DESCRIPTION

   Oracletool is a perl based CGI script that creates dynamic HTML based on
information gathered from an Oracle database. It does not use any views, 
packages, procedures ora anything else that doesn't already exist in your 
Oracle database to gather the information. It is useful for quickly extracting 
information stored in the Oracle data dictionary about most anything you need 
to know about. There's no magic here, just the same query's a typical Oracle DBA 
uses on a daily basis, but in an interactive point-and-click application. 
   Oracletool has been written unspecific to Oracle7 or Oracle8, meaning that it 
looks the same under both major releases, and works the same under both. Some of 
the queries are slightly different depending on the major release of Oracle though.

   Here's a list of the things Oracletool will retrieve for you... 

B<User information:>

Defaults, Tablespace quotas, grants to, grants from, active session 
info, object list. 

B<User Object list:>

B<   Tables> 
   Shows structure, analyzation info, storage params, DDL
   times, primary key, indexes, column constraints, 
   foreign keys, and foreign keys which reference said 
   table. Button for displaying rows in HTML table format. 

B<   Indexes> 
   Structure, storage params, DDL times. 

B<   Views> 
   Structure and source. Button for displaying rows in
   HTML table format. 

B<   Other source objects> 
   (Triggers, packages, procedures, functions etc.): Shows 
   source.  Easy for cutting and pasting to recreate. Also
   displays for synonyms, sequences, and DB links. 

B<Instance parameters:> 
Shows all initialization parameters and values in table format 

B<Tablespace info:> 
Allocation bar graph 
Extent information, space allocation, datafile list with fragmentation info, 
datafile I/O bar graph and free space bar graph. 
Checks for objects that will fail to allocate a next extent. 
Checks for objects approaching max extents. 
Hyperlinked list of objects within the tablespace. 

B<Datafile info:> 
I/O bar graph comparison to all other datafiles. 
Size, tablespace name, I/O, status. 
Checks for datafiles needing media recovery. 
  
B<Online redo log info:> 
Status of all online redo logs, including size, group, thread, sequence. 
Graph of log switch history by day and hour. 

B<Session info:> 
Info about all active and inactive sessions in instance, including 
oracle username, OS username, SID, serial#, status, process, program, 
command, # of rows processed, logon time, and currently executing SQL. 
Each session has a hyperlink to show session statistics. 
Sessions can also be broken down by user. 

B<Locking / contention:> 
Info about object locks that are contending and non contending, 
and session wait information. 

B<Memory / performance:> 
Instance SGA settings, memory usage, library cache information, 
data dictionary cache miss ratio, resource limits and usage, parallel 
query slave and server stats. 

B<Instance parameters:> 
Shows all initialization parameters and values in table format 

B<Tablespace info:> 
Allocation bar graph 
Extent information, space allocation, datafile list with fragmentation info, 
datafile I/O bar graph and free space bar graph. 
Checks for objects that will fail to allocate a next extent. 
Checks for objects approaching max extents. 
Hyperlinked list of objects within the tablespace. 

B<Datafile info:> 
I/O bar graph comparison to all other datafiles. 
Size, tablespace name, I/O, status. 
Checks for datafiles needing media recovery. 
Datafile fragmentation / extent allocation graph.
  
B<Online redo log info:> 
Status of all online redo logs, including size, group, thread, sequence. 
Graph of log switch history by day and hour. 

B<Session info:> 
Info about all active and inactive sessions in instance, including 
oracle username, OS username, SID, serial#, status, process, program, 
command, # of rows processed, logon time, and currently executing SQL. 
Each session has a hyperlink to show session statistics. 
Sessions can also be broken down by user. 

B<Locking / contention:>
Info about object locks that are contending and non contending, 
and session wait information. 

B<Memory / performance:>
Instance SGA settings, memory usage, library cache information, 
data dictionary cache miss ratio, resource limits and usage, parallel 
query slave and server stats. 

=head1 PREREQUISITES

=over 2

=item 1.
B<Oracle 7 or Oracle 8>

=item 2.
B<Perl 5.003 or later>

=item 3.
B<DBI version 1.02 or later>

=item 4.
B<DBD::Oracle 0.56 or later>

=item 5.
B<GD 1.18 or later>

=item 6.
B<A functioning web server>

=back

B<INSTALLATION>

   Installation of Oracletool is pretty straightforward, especially if
you have installed stuff on your web server before. The main thing is 
that you need to have the DBI, DBD::Oracle and GD modules compiled into
your perl BEFORE you attempt to install Oracletool. These instructions 
will assume that you have already done so. If you have not done that yet, 
download the  required  Perl modules and follow the instructions to 
install them. I have compiled the DBI and DBD::Oracle modules many
times and have had very few problems. If you do encounter problems with 
DBI or the DBD::Oracle module, there is a whole mailing list devoted to 
the subject at http://www.hermetica.com , please use it. 

   OK, let's get to it! At this point, you should have a recent version 
of Perl with the DBI and DBD::Oracle modules compiled in and tested. You 
also have a functional web server in place, right? If not, back up and 
come back here when you've got those things in place.

  There are several variables in oracletool.pl that may need to be set. 
These are at the very top of the script and there is an explanation of 
each variable above it. I'll walk through them. Before that though, 
let's get the most obvious one out of the way first...

Make sure you change this to the path to your perl binary with DBI, 
DBD::Oracle and GD compiled in! 
AND make sure you do a chmod 755 oracletool.pl !! 

#!/usr/bin/perl 

OK, on to the less obvious stuff. 

You will see a section at the top of the script that looks like this... 
#========================================================================
# Begin user editable section. 
# You may need to change some things in this section.                    
#========================================================================

   The first variable you may want to set is for your $ORACLE_HOME. 
Set this in the line that looks like this. 

$ENV{'ORACLE_HOME'} = '/home/oracle/product/8.0.5';

   Next, set your $TNS_ADMIN variable, if you use one that is not default. 
The default is $ORACLE_HOME/network/admin. 

$ENV{'TNS_ADMIN'} = '/home/oracle/admin/sqlnet'; 

  The rest of the variables in this section are self explanatory, and you 
can mess with them if you choose to. The default colors work OK for me. 

 When you see the following... 
#======================================================================== 
# End user editable section. Do not edit below this point. 
#======================================================================== 
Then you're almost ready to go!. 

    Copy oracletool.pl to a directory that is defined to the web server 
as a cgi directory. For instance, under Redhat Linux, the default CGI 
directory is "/home/httpd/cgi-bin". 
    Make sure that oracletool.pl is executable by the web server, meaning 
that, the web server may not run as the same userid that installed 
oracletool.pl. chmod 755 oracletool.pl is safe. There is no info stored 
in the script that people shouldn't see for any reason.  When you are 
finished with all of the above, you should be able to execute oracletool.pl 
by putting something like the following into your browser address window. 
Let's assume that your web server is named 'mywebserver' and that you copied 
oracletool.pl into the default CGI directory on your web server. 

http://mywebserver/cgi-bin/oracletool.pl 

=head1 AUTHOR

oracletool.pl by Adam vonNieda.

=head1 COPYRIGHT

oracletool.pl is Copyright (c) 1998,1999 Adam vonNieda, USA.
You may distribute under the terms of either the GNU General Public
License or the Artistic License, as specified in the Perl README file,
with the exception that it cannot be placed on a CD-ROM or similar media
for commercial distribution without the prior approval of the author.

=cut
